/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2014. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.AbstractArtifactEditor");
dojo.require("jazz.core.loader");
dojo.require("jazz.ui.Menu");

dojo.require("dojox.xml.parser");
dojo.require("dojo.fx.easing");
dojo.require("dojox.fx.scroll");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.Button");

dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.DirectoryPane");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.EditorSection");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.EditorSectionPrintView");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.EditorSubSection");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.client.internal.CompositeWebClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.ContributorSelect");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.ESignOperationDialog");

dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.WorkItemUtils");
dojo.require("com.ibm.rqm.planning.web.client.internal.template.TemplateClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.ArtifactModel");
dojo.require("com.ibm.asq.common.web.ui.internal.model.SaveParticipant");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.DynamicSection");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.DynamicGridSection");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.SectionGroup");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.ManageSectionsDialog");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.DuplicateAction");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.ActionEntityType");
dojo.require("jazz.app.context");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.rqm.planning.web.client.internal.PreferenceClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.selector.QueryableProjectArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.HistoryPane");
dojo.require("com.ibm.asq.common.web.ui.internal.util.PrintHelper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.TeamAreaSelector");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ArtifactPriorities");
dojo.require("com.ibm.rqm.process.web.ui.internal.view.extension.ReviewSection");
dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");
dojo.require("com.ibm.team.repository.web.client.init.InitializationData");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.workflow.WorkflowManager");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.workflow.WorkflowModel");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.workflow.WorkflowInitialization");

dojo.require("com.ibm.rqm.planning.web.ui.internal.util.StateTransitionConstraintsUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.ExecutionConstraintsUtil");
dojo.require("com.ibm.asq.common.web.client.internal.DirtyItemInfoClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.SelectItemTableDialog");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.DiffMergeController");
dojo.require("com.ibm.rqm.planning.web.client.internal.DiffMergeClient");

(function(){ // module container    
    var Utility = com.ibm.asq.common.web.ui.internal.util.Utility;
    var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var cmnConstants =  com.ibm.asq.common.web.client.internal.Constants;
    var WorkItemUtils = com.ibm.rqm.planning.web.client.internal.WorkItemUtils;
    var ArtifactModel = com.ibm.rqm.planning.web.ui.internal.model.ArtifactModel;
    var SaveParticipant = com.ibm.asq.common.web.ui.internal.model.SaveParticipant;
	var DynamicSection = com.ibm.rqm.planning.web.ui.internal.view.extension.DynamicSection;
	var DynamicGridSection = com.ibm.rqm.planning.web.ui.internal.view.extension.DynamicGridSection;
	var DirectoryPane = com.ibm.asq.common.web.ui.internal.widgets.DirectoryPane;
    var EditorSection = com.ibm.asq.common.web.ui.internal.view.common.EditorSection;
	var EditorSectionPrintView = com.ibm.asq.common.web.ui.internal.view.common.EditorSectionPrintView;
    var EditorSubSection = com.ibm.asq.common.web.ui.internal.view.common.EditorSubSection;
    var SectionGroup = com.ibm.rqm.planning.web.ui.internal.view.extension.SectionGroup;
    var GlobalEvents = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
	var ManageSectionsDialog = com.ibm.rqm.planning.web.ui.internal.view.construction.ManageSectionsDialog;
    var TemplateClient = com.ibm.rqm.planning.web.client.internal.template.TemplateClient;
    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
	var SelectUtility = dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
	var PreferenceClient = com.ibm.rqm.planning.web.client.internal.PreferenceClient;
	var YesNoDialog = com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog;
	var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
	var ESignatureDialog = com.ibm.asq.common.web.ui.internal.widgets.ESignOperationDialog;
	var ContributorSelect = com.ibm.asq.common.web.ui.internal.widgets.ContributorSelect;
    var DuplicateAction = com.ibm.rqm.planning.web.ui.internal.model.action.DuplicateAction;
	var ActionEntityType = com.ibm.rqm.planning.web.ui.internal.model.action.ActionEntityType;	
    var HistoryPane 			 = com.ibm.rqm.planning.web.ui.internal.view.construction.HistoryPane;
    var PrintHelper = com.ibm.asq.common.web.ui.internal.util.PrintHelper;
	var ArtifactPriorities	= com.ibm.rqm.planning.web.ui.internal.view.common.ArtifactPriorities;
    var ConfirmationDialog = com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog;
    var AlertDialog = com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
	var WorkflowManager = com.ibm.rqm.planning.web.ui.internal.view.administration.workflow.WorkflowManager;
	var WorkflowInitialization = com.ibm.rqm.planning.web.ui.internal.view.administration.workflow.WorkflowInitialization;
    var CommonUtility = com.ibm.asq.common.web.ui.internal.util.Utility;
    var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
    
	var ConstraintsUtil = com.ibm.rqm.planning.web.ui.internal.util.StateTransitionConstraintsUtil;
	var ExecutionConstraintUtil = com.ibm.rqm.planning.web.ui.internal.util.ExecutionConstraintsUtil;
    var LabelLoading = Constants.getMessage("labelLoading");;
    var DirtyItemInfoClient = com.ibm.asq.common.web.client.internal.DirtyItemInfoClient;
	var CompositeWebClient = com.ibm.asq.common.web.client.internal.CompositeWebClient;
	var PlanningUtility = com.ibm.rqm.planning.web.ui.internal.util.Utility;
    var SelectItemTableDialog = com.ibm.rqm.planning.web.ui.internal.view.common.SelectItemTableDialog;
    var DiffMergeController = com.ibm.rqm.planning.web.ui.internal.view.common.DiffMergeController;
	var DiffMergeClient		= 	com.ibm.rqm.planning.web.client.internal.DiffMergeClient;
	
	// This map serves two purposes - the first of which is temporary.  
	// - does this artifact support the conversion?
	// - what is the composite web type code for the specific model type code.
    var _mapSupportedCompositeDTO = {};
    _mapSupportedCompositeDTO[ Constants.TYPE_CASE] = CompositeWebClient.TYPE_TESTCASE;
    _mapSupportedCompositeDTO[ Constants.TYPE_PLAN] = CompositeWebClient.TYPE_TESTPLAN;
    _mapSupportedCompositeDTO[ Constants.TYPE_SCRIPT] = CompositeWebClient.TYPE_TESTSCRIPT;
    _mapSupportedCompositeDTO[ Constants.TYPE_SUITE] = CompositeWebClient.TYPE_TESTSUITE;
    _mapSupportedCompositeDTO[ Constants.TYPE_DATAPOOL] = CompositeWebClient.TYPE_TESTDATA;
    _mapSupportedCompositeDTO[ Constants.TYPE_EWI] = CompositeWebClient.TYPE_TCER;
    _mapSupportedCompositeDTO[ Constants.TYPE_SER] = CompositeWebClient.TYPE_TSER;
    _mapSupportedCompositeDTO[ Constants.TYPE_SUITE_RESULT] = CompositeWebClient.TYPE_TSRESULT;
    

    dojo.declare("AbstractArtifactEditor.TemplatePicker", [dijit._Widget, dijit._Templated], {
        
        templateString:                      
        '      <div>' +
        '        <table style="width:100%;" role="presentation">' +
        '          <tr dojoAttachPoint="fullAttributeNode">' +
        '            <td>' +
        '              <label for="${id}_templateSelect" class="attributes-entry-label">${label}</label>' +
        '            </td>' +
        '            <td>' +
        '              &#160;&#160;' +
        '            </td>' +
        '            <td style="width:98%;">' +
        '              <select id="${id}_templateSelect" dojoAttachPoint="_templateSelect" class="attributes-entry-value" style="width:25em;" dojoAttachEvent="onchange:_onSelect"></select>' +
        '            </td>' +
        '           </tr>' +
        '        </table>' +
        '      </div>',

        
        label: null,
        value: "",
        
        postMixInProperties: function(){
            if (!this.label) 
                this.label = Constants.getMessage("labelCreateUsingTemplateLabel"); // just postponed this getMessage
            this.inherited('postMixInProperties',arguments);
        },

        postCreate: function() {
            var tempLen = this.templates ? this.templates.length : 0;
            for (var i = 0; i < tempLen; i++) {
                var template = this.templates[i];
                var option = new Option(Constants.getExtensionDisplayMessage(template.name), template.itemId);
                option.selected = this.value == template.itemId;
                SelectUtility.add(this._templateSelect, option);
            }
        },
        
        _setValueAttr: function(value) {
            this.value = value;
            if (this._templateSelect){
                SelectUtility.select(this._templateSelect, value);
            }
        },
        
        _setHideAttr: function(hide) {
            dojo.style(this.domNode, "display", hide ? "none" : "inline");
        },
        
        _onSelect: function(selected) {
            this.value = this._templateSelect.value;
            this.onSelect(this.value);
        },

        onSelect: function() {
        },
        
    });

    
 dojo.declare("AbstractArtifactEditor.StaleDataMessage", [dijit._Widget, dijit._Templated], {
        
        templateString:                      
        '      <div>' +
        '      <span dojoAttachpoint="saveConflictSpan"></span>' +
        '        <table role="presentation">' +
        '          <tr  role="presentation">' +
        '            <td>' +
        '              <span dojoAttachPoint="mergeNode"></span>' +
        '            </td>' +
        '            <td>' +
        '				<label dojoAttachPoint="mergeLabelComponent">${mergeLabel}</span>' +
        '            </td>' +      
        '           </tr>' +
/*        '          <tr  role="presentation">' +   //disabled for now until server-side support is added
        '            <td>' +
        '              <span dojoAttachPoint="overrideNode"></span>' +
        '            </td>' +
        '            <td>' +
        '				<label>${overrideLabel}</span>' +
        '            </td>' +       
        '           </tr>' + */
        '          <tr  role="presentation">' +
        '            <td>' +
        '              <span dojoAttachPoint="cancelNode"></span>' +
        '            </td>' +
        '            <td>' +
        '				<label dojoAttachPoint="cancelLabelComponent">${cancelLabel}</span>' +
        '            </td>' +      
        '           </tr>' +
        '        </table>' +
        '      </div>',                  
       
        mergeLabel: Constants.getMessage("labelMergeDescription"),
        overrideLabel: Constants.getMessage("labelOverrideDescription"),
        cancelLabel: Constants.getMessage("labelCancelDescription"),        
        artifactTypeLabel: "",
        
        mergeCallback: null,
        overrideCallback: null,
        cancelCallback: null,
        
        
        postCreate: function() {
        	this.saveConflictSpan.innerHTML = Constants.getMessage("labelStaleDataErrorMessage",  this.artifactTypeLabel);
        	  var merge  = new com.ibm.asq.common.web.ui.internal.widgets.Button({
                  label:  Constants.getMessage("labelMerge"),
                  showLabel: true,
                  onClick: this.mergeCallback
              });	  
        	  this.mergeNode.appendChild(merge.domNode);
        	  this.mergeLabelComponent.setAttribute("for", merge.id);
        /*      var override  = new com.ibm.asq.common.web.ui.internal.widgets.Button({
                  label: Constants.getMessage("labelOverride"),
                  showLabel: true,
                  onClick: this.overrideCallback
              });	 
             this.overrideNode.appendChild(override.domNode);
          */    
              var cancel  = new com.ibm.asq.common.web.ui.internal.widgets.Button({
              	label: Constants.getMessage("labelCancel"),
              	showLabel: true,
              	onClick: this.cancelCallback
              });
              this.cancelNode.appendChild(cancel.domNode);
              this.cancelLabelComponent.setAttribute("for", cancel.id);
        }
        
		});
    
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.AbstractArtifactEditor", [SaveParticipant], {
		_duplicationAction: 0,
        _splitHeaderAttributeArea: true,
        _headerTabOrientation: 'horizontal',
        
        // Used by the duplicate action to map the artifact's id type to use for duplication.
        // Artifact types that don't use the versionableItemId for duplication, its artifact
        // editor subclass must override this attribute to specific the id type name, e.g.,
        // for keyword it's "itemId", etc.
        _duplicateActionIdTypeName: "versionableItemId",
        
        // subclass should override if diff/merge is supported for the artifact type
        diffMergeEnabled: false,
        
        // indicate that the editor is currently in diff/merge mode
        _isMerging: false,
        
        constructor: function(){
//		   	console.debug("++++++++++++++++++++AbstractArtifactEditor Constructor");
        	var arg = arguments[0];
			this._duplicationAction = new DuplicateAction();
			this._isLoading = false;
            this._artifactModel = null;
            this._isReadOnly = false;
            this._rolePermitsEdit = true;
            this._rolePermitsArchive = true;
            this._rolePermitsSnapshot = true;
            this._isCopy = false;
			this._isArchived = false;
			this._isNew = (arg && arg.kwArgs) ? false : true;
			this._isSaving = false;
			this._isSnapshot = false;
			this._isPrintView = false;
			this._printViewURI = null;
			this._isCopySnapshot = false;
			this._dirty = false;
            this._artifact = null;
            this._templateId = null; 
			this._template = null;  /* ITemplate */
            this._sections = []; //the contributed section widgets
            this._sectionsRemoved = [];  //string array, list of sections to remove from this plan
            this._sectionsBlocked = []; //string array, list of sections prevented from being added via manage sections
            this._sectionMap = {}; //maps section configs by id for easier access from group (sectionId: section)
			this._sectionsNode = null; // dom node where sections are added
			this._tocNode = null; // dom node where sections are added
			this._titleModified = false;
			this._cshelpId = null;	
            this._editorRegistry = dojo.getObject(Constants.EDITOR_REGISTRY_OBJECT_ID);
			this._editorConfig = this._editorRegistry.getEditor(this);
			this._editorSections = this._editorConfig ? dojo.clone(this._editorConfig.sections) : [];
			this._uri = null;
			this._projectAlias = Utility.getCurrentProjectAreaAlias();
			this._menus = [];
            // customize locale specific preferred width for TOC panel
            this.tocWidth = 140;
            this._initialState = null; // Only needed for new artifacts.
            this._workflowActions = [];
            this.reinitAsCallback = false;
            this.ownsDirtyItemInfo = false; // used to know if this artifact has a current entry in DirtyItemInfo table
            this.handleWindowUnload = null; // to save the handle when subscribe to Window Unload Event
            this.deferredRelatedInfo = true; // defer updating the related info until loading is completed
            this.hasContentOnPostSavedOnly = false; //intended for sections that save using post calls to services onSaveFinish, inherited editors must change this flag to enable this functionality
            this.localEditorDirty = false; //flag to indicate our editor itself is dirty
            this.changedSections = false;
            switch (dojo.locale.split('-')[0]) {
                case "ja":
                    this.tocWidth = 165;
                    break;
            }

            // The editor is not completely initialized until the dynamic sections (according to the tempalte) are loaded.
            // Default with no dynamic sections required and these flags are set upon invoking the sections loading method.
            this._getTemplatedComplete = true;
            this._loadSectionsComplete = true;
			
			//A confirmation dialog is displayed only if the artifact is changed.
			this._isAlertWhenChangeTemplate = false;
			
			//State Management
			this._stateChanged = false;
			
			// listen for section changes via URI
            this._updateTabUriTopic = dojo.subscribe(GlobalEvents.UpdateTabUri, this, "_onUpdateTabUri");
            
            if (arg && arg.compositeDTO) {
            	// Temporary until I stop using the ActionBarEntry stuff
            	this._compositeDTO = arg.compositeDTO;
            	WorkflowManager._loadData(this._compositeDTO.workflowsDTO);
            } else {
            	var type = _mapSupportedCompositeDTO[arg.model._artifactType];
            	if (type) {
            		this._callCompositeWeb(type);
            	} else {
            		//update section for keyword artifact
            		if( this.getEditorId() == Constants.EDITOR_ID_KEYWORD ) {
            			this._getEditorSections();	
            		}
            WorkflowManager.reloadWorkflows();
            	}
            }
        },
        
        supportsCompositeWeb: function(type) {
        	return _mapSupportedCompositeDTO(type);
        },

        _callCompositeWeb: function(type, isRefresh) {
        	var compositeCallback = isRefresh?"_afterCompositeWebRefresh":"_afterCompositeWeb";
        	var responseHandler = new ServiceResponseHandler(this,compositeCallback , "_loadError"); 
        	var projectAreaItemId = jazz.app.context.get().itemId;        	      	        
        	CompositeWebClient.getOpenCreateInfo(responseHandler, projectAreaItemId, type, null, null, isRefresh, this.isNew());
        },
        
        _afterCompositeWebRefresh: function(dto){
        	this._compositeDTO = dto;
        	this.loadArtifact();
        },
        _afterCompositeWeb: function(dto) {
        	this._compositeDTO = dto;
        	//update the available sections, now we take those from the DB instead of xml definition
        	if(dto.sections) {
        		this._editorSections = dto.sections;
        	}
        	WorkflowManager._loadData(dto.workflowsDTO);
        	this.artifactAfterCompositeWeb();
        },
        
        /*
         *  override this to get called back after the composite web dto is available in this._compositeDTO
         */
        artifactAfterCompositeWeb: function() {
        	
        },
        /****************************************************************************************
         * The editor may be closing so any update of the editor should check with this method.
         * Especially in a response handler that post an async call to the server.  Skip any
         * update if this method returns true to avoid any exception.
         * 
         * ArtifactEditorPageController will close the editor if non-preferred uri is used while
         * there is an editor using the preferred uri is already opened.
         ****************************************************************************************/
        isClosing: function() {
            return this.selfClosing ? true : false;
        },
        
        postCreate: function() {
			//connect state setters to updatSaveable
			//this will enable/disable the save/cancel buttons appropriately
			this.connect(this, "setReadOnly", "updateSaveable");
			this.connect(this, "setSaving", "updateSaveable");
			this.connect(this, "setDirty", "updateSaveable");
			this.connect(this, "setLoading", "updateSaveable");
			this.connect(this, "setArtifactType", "_initPermissionsAndPreferences");
			this.connect(this, "setArtifactType", "_loadWorkflowInitialState");
			this.connect(this, "setArtifactType", dojo.hitch(this, function() {
				var dto = this._compositeDTO;
				if (dto) {
					ConstraintsUtil.setConstraints(dto.projectArea, this.getArtifactType() ,dto.advisorsEnabledForSave);
					ExecutionConstraintUtil.setConstraints(dto.projectArea,this.getArtifactType(),dto.advisorsEnabledForExecute);
				} else {
				// Load the constraints configuration as soon we know the artifact type
				ConstraintsUtil.loadConstraints(this.getArtifactType());
				ExecutionConstraintUtil.loadConstraints(this.getArtifactType());
				}
			}));
			this.connect(this, "initialize", "_updateLockAction");
			
			// Make sure the validation handler is attached every time the header is created, 
			// even if a subclass overrides the createHeader method.
			this.connect(this, "createHeader", dojo.hitch(this, function() {
				this._headerStartValidatingAction = this.connect(this, "validate", dojo.hitch(this._header, "startValidating"));
			}));
			//lock the description and title of the artifact if the artifact is locked.
			//the artifact must first be loaded to determine if it is editable.
			this.connect(this, "setArtifact", dojo.hitch(this, function() {
                var header = this.getHeader();
                if (header) {
                    var editable = this.isEditable();
                    header.setTitleEditable(editable);
                    if(this.isSupportSummary()){
                    	header.setSummaryEditable(editable);
                    }
                }

                var artifact = this.getArtifact();
				this._loadWorkflowActions(this.getWorkflowState(artifact));
				
				// subscribe to the WindowUnload event
				this.handleWindowUnload = dojo.subscribe(GlobalEvents.WindowUnload, this, function(){
					if (this.ownsDirtyItemInfo && !this.isNew()) {
						//if is IE we made this call sync to avoid the addOnWindowUnload issue on IE: 
						//the bowser page is reload before the request is done 
						var isSynCall = !!dojo.isIE;
						this.deleteDirtyItemInfo(isSynCall);
					}	            	
	            });				
				
			}));
			
			this.setUri(window.location.hash);
        },
        
        getWorkflowState: function(artifact){
        	return (artifact ? artifact.state : null);        	
        },
        
        setWorkflowState: function(state){
        	var artifact = this.getArtifact();
        	if(artifact){
	        	artifact.state = state;
	        }
        },
        
        // unsubscribe from pub/sub
        uninitialize: function() {
            //console.debug("-------------------AbstractArtifactEditor Uninitialize");
			dojo.unsubscribe(this._updateTabUriTopic);
            
            //delete DrtyItemInfo if needed
            if (this.ownsDirtyItemInfo){
            	//false = no sync call
            	this.deleteDirtyItemInfo(false);
            }
            
			// unsubscribe to the WindowUnload event
            dojo.unsubscribe(this.handleWindowUnload);
			
            this.destroySections();
            if(this._artifactModel)
                this._artifactModel.uninitialize();
            this._header = null;
            this._artifactModel = null;
            this._artifact = null;
            this._templateId = null; 
            this._template = null; 
            this._sections = null;
            this._sectionsRemoved = null;
			this._sectionsBlocked = null;
            this._sectionMap = null;
            this._sectionsNode = null;
			dojo.forEach(this._menus, function(menu){ 
				if(menu.destroyRecursive){
					menu.destroyRecursive();
				}
			});
			this._menus = [];
			
            var relatedInfo = this.getStaticRelatedInfo();
			if (relatedInfo){
				relatedInfo.destroy();
			}
            if (this.teamAreaSelector && !this.teamAreaSelector._beingDestroyed) {
                this.teamAreaSelector.destroyRecursive();
            }
			if (this._headerStartValidatingAction) {
				this.disconnect(this._headerStartValidatingAction);
			}
        },
        getStaticRelatedInfo: function() {
			return null;
        },
        
        // created the "Copied From" and "Copied To" copy links related info sections
        createCopyLinksSections: function() {
        	if(!this.copyLinksSection){
        		var relatedInfo = this.getStaticRelatedInfo();
        		if (relatedInfo) {            	
        			this.copyLinksSection = relatedInfo.getInfoGroup(Constants.getMessage("labelCopiesStaticSection"), true);                
        		}
        	}
        },
        
               
        // set the content in the Copied From section which is { label, url, presentationUri }
        setCopiedFromLink: function(link) {
        	if(link){
        		this._setCopiedLinks([link], true);
        	}
        },
        
        // set the content in the Copied To section which is an array of { label, url, presentationUri }
        setCopiedToLinks: function(link) {        	
        	this._setCopiedLinks(link, false); 
        },
        
        _setCopiedLinks: function(links, isFrom){                  	                               
                if (links && links.length > 0) {
                    var relatedInfo = this.getStaticRelatedInfo();
                    var len = links.length;
                    var subSectionLabel = (isFrom?Constants.getMessage("labelCopyFromStaticSection"):Constants.getMessage("labelCopyToStaticSection",len));
                    var icon = (isFrom?ImageCache.COPY_FROM:ImageCache.COPY_TO);
                    
                    for(var i=0; i<len; i++){    
                    	var link =  links[i];
                    	relatedInfo.addMixedRichHoverLink(Constants.getMessage("labelCopiesStaticSection"), link.label, link.url, link.presentationUri, null,{
                    		label: subSectionLabel, 
                    		icon: icon
                    		}, link.htmlContent);
                    }
                }                    
        },

        // check the artifact for copy links and populate the copy links sections
        processCopyLinks: function(artifact) {
        	if(this.copyLinksSection){
        		this.copyLinksSection.clearActionsNode();
        	}
        	if(artifact.copiedFromArtifact || artifact.copiedToArtifacts){
        		this.createCopyLinksSections();
        		if (artifact.copiedFromArtifact) {
        			var copiedFromArtifact = this._constructCopyLinkParam(artifact.copiedFromArtifact);
        			this.setCopiedFromLink(copiedFromArtifact);
        		} 

        		// check "Copied To" copy links
        		if (artifact.copiedToArtifacts) {
        			var copiedToArtifacts = [];
        			dojo.forEach(artifact.copiedToArtifacts, dojo.hitch(this, function(linkArtifact) {
        				copiedToArtifacts.push(this._constructCopyLinkParam(linkArtifact));
        			}));
        			this.setCopiedToLinks(copiedToArtifacts);
        		}
        	}            
        },
        
        // construct the param to all a hover link to the copy links sections
        _constructCopyLinkParam : function(linkArtifact) {
        	if(linkArtifact.notAllowed){
        		return {
        			label: Constants.getMessage("labelRestricted"),
        			notAllowed:true,
        			url: "javascript:{}", 
        			htmlContent:  "<STRONG>" + Constants.getMessage("labelNotPermissionToRead") + "</STRONG>"            	
        		};
        	}
            var richHoverURL = this.getCopyLinkResourceLinkURL(linkArtifact);
            var linkURL = this.getCopyLinkURL(linkArtifact);
            var label =  (linkArtifact.id ? Constants.getCommonMessage("labelIdLabel", linkArtifact.id) + " " : "") + linkArtifact.name;
            if (linkArtifact.projectAreaItemId && linkArtifact.projectAreaItemId != CommonUtility.getCurrentProjectAreaId()) {
                // use the resource link url for rich hover if the artifact is in a different project area
                linkURL = richHoverURL;
                label+= " [" + linkArtifact.projectAreaName + "]";
            }
            var param = {                
                presentationUri: linkURL,
                url: richHoverURL,
                label: label
            };
            return param;
        },
        
        getCopyLinkURL: function(linkArtifact) {
            console.debug("subclass of AbstractArtifactEditor must implement this method - getCopyLinkURL");
        },

        getCopyLinkResourceLinkURL: function(linkArtifact) {
            console.debug("subclass of AbstractArtifactEditor must implement this method - getCopyLinkResourceLinkURL");
        },
        
        // Clean up the to be discarded editor sections. The editor could
        // unload all of the sections and recreate them. The old sections
        // needs to be cleaned up before being unloaded.
        cleanUpSectionsBeforeReload: function() {
            Utility.destroyWidgetsFromNode(this._sectionsNode);
            this.destroySections();
        },
        
        // Clean up section contents. Section contents may not have
        // attached to the section's container. Need to explicitly destroy
        // them.
        destroySections: function() {
            var sections = this._sections;
            var len = sections ? sections.length : 0;
            for(var i = 0; i < len; i++) {
                var sw = sections[i];
                sections[i] = null;
                if(sw.destroy) {
                    //console.debug("destroying section widget: " + sw.id);
                    if (!sw._beingDestroyed) {
                        sw.destroy();
                    }
                    sw.sectionContainer = null;
                    sw.parentController = null;
                    sw.parentEditor = null;
                }
            }            
        },
        
        getArtifactModel: function(){
            return this._artifactModel;
        },
		
        setArtifactModel: function(artifactModel){
            if(this._artifactModel) {
                this._artifactModel.uninitialize();
            }
            this._artifactModel = artifactModel;
			if (this.isRolePermitsEdit() || this.isRolePermitsArchive() || this.isRolePermitsLock() || this.isRolePermitsUnlock() || this.isRolePermitsSnapshot()) {
				this._artifactModel.getSaveContext().addParticipant(this);
				this._artifactModel.setArtifact(this.getArtifact());
			}
        },
		
        getSaveContext: function() {
            var artifactModel = this.getArtifactModel();
            if (artifactModel == null) {
                console.error("AbstractArtifactEditor:getSaveContext() - artifact model is null");
                artifactModel = new ArtifactModel();
            }
            return artifactModel.getSaveContext();            
        },
        
        isReadOnly: function(){
            return this._isReadOnly;
        },
        
		//State Management
		isSaveableState: function()
		{
			//If not initialized yet then sure, we're saveable.
			if (this.getStateValue() == null)
				return true;
			
			//State Management - Hard Coded
			//If the state has changed then saveable is true.
			//if the state has NOT changed and the current state is Approved or Retired then saveable is false
			if (this.getStateChanged() ==  true)
				return true;
			
			//No state change so return false if in Approved or Retired and we the no edit in those constraints is in effect
			//Otherwise return true			
			var currentState = this.getStateValue();
			if (WorkflowManager.stateBelongsToApprovedOrRetired(currentState, this.getArtifactType()) 
					&& ConstraintsUtil.isConstraintEnabled(ConstraintsUtil.RestrictSave, this.getArtifactType(), this.getTeamAreaItemId())) {
				return false;
			}
			
			return true;
		},
		
		// Summary:
		//    Returns the initial state object for this editor's artifact type
		//    based on its workflow binding.
		//
		getInitialState: function() {
			return this._initialState;
		},
				
		// Summary:
		//    Sets the initial state id for this editor's artifact type
		//    based on its workflow binding.
		//
		setInitialState: function(initialState) {
			this._initialState = initialState;
		},
		
		// Summary:
		//    Returns the initial state id for this editor's artifact type
		//    based on its workflow binding.
		//
		getInitialStateId: function() {
			return this._initialState ? this._initialState.id : null;
		},
		
		// Summary:
		//    Load the initial workflow state for this artifact based on its artifact type. 
		//    Only needed for new artifacts.
		//
		_loadWorkflowInitialState: function() {
			
			WorkflowInitialization.whenReady(dojo.hitch(this, function() {
				var state = WorkflowManager.getInitialStateForArtifactType(this.getArtifactType());
				this.setInitialState(state);
			}));
			
		},

		// Summary:
		//    Loads the available workflow actions for this artifact based
		//    on its current state.
		//
		_loadWorkflowActions: function(state, /* Optional */callback, /* Optional */ errCallback) {
			WorkflowInitialization.whenReady(dojo.hitch(this, function() {
				var artifactType = this.getArtifactType();
				if (!artifactType || !state) {
					return;
				}
				var actions = WorkflowManager.getActionsForState(state, artifactType);
				
				// If no actions are found, we might have an artifact with a state 
				// that has been deleted or the workflow has been changed.
				if (!actions) {
					if (!WorkflowManager.isStateValidForArtifactType(state, artifactType)) {
						var initialState = WorkflowManager.getInitialStateForArtifactType(artifactType);
						actions = WorkflowManager.getActionsForState(initialState, artifactType);
						
						this._invalidStateHandler();
					}
				}
				
				this._workflowActions = actions;
				if (callback && dojo.isFunction(callback)) {
					callback(actions);
				}
			}));
		},

		_invalidStateHandler: function() {
			var artifact = this.getArtifact();
			var state = this.getInitialStateId();
			
			if (artifact && state) {
				var originalState = this.getWorkflowState(artifact);
				this.setWorkflowState(state);
				var artifactType = this.getArtifactType();
				var stateName = WorkflowManager.getStateNameById(state, artifactType);
				var stateIcon = WorkflowManager.getStateIconById(state, artifactType);
				
				if (this._action) {
					// add "select action" and select it
					var option = new Option(Constants.getMessage("labelChangeStateTitle"), "NULL");  
					option.style.color = "gray";
					SelectUtility.add(this._action, option);
					SelectUtility.select(this._action, "NULL");
					
					this._state = stateName;
					// Set the state to be the previous state
					this._stateValue = state;
					this.updateWorkflowIconNode(this._stateIcon, stateIcon);
		 			// Update next state
		            this._stateTxt.nodeValue = stateName;
				}
				
				if (originalState) {
					setTimeout(dojo.hitch(this, function() {
						this.setDirty(true);
						
			            var header = this.getHeader();
			            if (header) {
			            	header.setStatus(Constants.getMessage("labelInvalidStateUpdatedTitle"), ViewHeaderLayout.INFO, 
			            			Constants.getMessage("labelInvalidStateUpdated", originalState, stateName));
			            } else {
			            	// Wait for the header to be present and set the status
			            	var handle = dojo.connect(this, "createHeader", dojo.hitch(this, function() {
			            		dojo.disconnect(handle);
			            		this.getHeader().setStatus(Constants.getMessage("labelInvalidStateUpdatedTitle"), ViewHeaderLayout.INFO, 
			            				Constants.getMessage("labelInvalidStateUpdated", originalState, stateName));
			            	}));
			            }
					}, 250));
				}
			}
		},
		
		//State Management
		//If the state has changed then the user should be allowed to save
		setStateChanged: function(changed, action) {
			this._actionApplied = action;
			this._stateChanged = changed;
		},
		
		//State Management 
		getStateChanged: function()
		{
			return(this._stateChanged);
		},
		
		// Summary:
		//    If a workflow action has been applied, returns the
		//    action id.
		//
		getWorkflowActionApplied: function() {
			return this._actionApplied;
		},

        setReadOnly: function(readOnly){
            this._isReadOnly = readOnly;
        },

        isRolePermitsEdit: function(){
            return this._rolePermitsEdit;
        },
        
        setRolePermitsEdit: function(permits){
            this._rolePermitsEdit = permits;
        },
        
        setRolePermitsSnapshot: function (permits){
        	this._rolePermitsSnapshot =  permits;
        },
        
        isRolePermitsSnapshot: function(){
        	return this._rolePermitsSnapshot;
        },
        	
        isRolePermitsArchive: function(){        
            return this._rolePermitsArchive;
        },
        
        setRolePermitsArchive: function(permits){
            this._rolePermitsArchive = permits;
        },
		
        isRolePermitsUnlock: function(){
            return this._rolePermitsUnlock;
        },
        
        setRolePermitsUnlock: function(permitsUnlock){
			this._rolePermitsUnlock = permitsUnlock ? (permitsUnlock === true) : false; 
        },		
		
        isRolePermitsLock: function(){
            return this._rolePermitsLock;
        },
        
        setRolePermitsLock: function(permitsLock){
			this._rolePermitsLock = permitsLock ? (permitsLock === true) : false; 
        },		
		
        isRolePermitsCreateSection: function(){
            return this._rolePermitsCreateSection;
        },
				
        setRolePermitsCreateSection: function(permission) {
            this._rolePermitsCreateSection = permission ? (permission === true) : false; 
        },		
        
        isCopy: function(){
            return this._isCopy;
        },
        
        setCopy: function(copy){
            this._isCopy = copy;
        },
		
		/*
		 * Since 1.0.1
		 */
		setArchived: function(value){
			this._isArchived = value;
		},
		
		isArchived: function(){
			return this._isArchived;
		},
						
		//@Overriden from SaveParticipant
		setDirty: function(dirty){

			this._isAlertWhenChangeTemplate = dirty;
            // no change in dirty status. don't have to do all the processing needlessly.
            if(dirty == this._dirty) return;

			if (!this.isArchived() && !this.isPurged()) {
				this.inherited("setDirty", arguments);	
				
				//Do not allow editing of an "Approved" or "Retired" artifact
				if (!this.isNew() && dirty == true && this.isSaveableState()) {
					dojo.publish(GlobalEvents.UpdateTabLabel, [this._uri ? this._uri : window.location.hash, "", this.getArtifactModel().getTabClass(), dirty]);
				}
	            // if our header is already created, update the save status.
	            if (this.getHeader()) {
	                if (dirty) {
						if (this.isSaveableState()) {
							this.setLastSaved(Constants.STATUS_DIRTY);
						} else {
						   this.setHeaderStatus(Constants.CONSTRAINT_WARNING, Constants.HEADER_STATUS_WARNING, Constants.getMessage("labelConstraintDescription1"));
						}
					} else { 
						this.getHeader().clearStatus();
					}	
					this.getHeader().setDirty(dirty);
	            }
			}
			//DirtyItemInfoClient Entries
			if(this._dirty && !this.isNew()){
				this.postDirtyItemInfo();
			}
			if(dirty == false){
				//reset the localEditor  dirty  if programatically we reset the general dirty flag too
				this.localEditorDirty = false;
			}
			
			// disable diff/merge if the editor is dirty
			if (this._diffMergeButton) {
			    this._diffMergeButton.setDisabled(dirty);
			}
		},
		
		//to insert DirtyItemInfo data
		postDirtyItemInfo : function(){
			var self = this;
			if (!self.supportsDirtyItemInfo()) {
				return;
			}			
			var responseHandler = new ServiceResponseHandler({
				success: function(data) {
					if(!data.entryCreated){
						self.setHeaderStatus(data.message, Constants.HEADER_STATUS_WARNING);
						self.ownsDirtyItemInfo = false;
						if (PlanningUtility.isConcurrentEditModal()) {
						    // use alert dialog as well if server property is set
			                new AlertDialog({
			                    message: data.message,
			                    primaryTitle: Constants.getMessage("labelAlert")
			                }).open();
						}
					}else{
						self.ownsDirtyItemInfo = true;
					}
				},
				error: function(e) {
					console.dir(e);
				}
			}, "success", "error");	
			
			var itemType = self.getArtifactType();
			if (itemType == "Test Script") {
				if (self._script.scriptType.id != "com.ibm.rqm.planning.common.scripttype.manual") {
					itemType = "Remote Test Script";
				}
			}
			var itemId =  self.getRealItemId ? self.getRealItemId() : self.getItemId();
			var params = {
				artifactItemId: itemId,
				artifactStateId: self.getStateId(),
				artifactType: itemType
			};
			DirtyItemInfoClient.postDirtyItemInfo(responseHandler, params);
		},
		
		//This method must be override for the artifact that will support DirtyItemInfo and return true
		supportsDirtyItemInfo: function() {
			return false;
		},
		
		deleteDirtyItemInfo : function(sync){
			var self = this;
			if (!self.supportsDirtyItemInfo()) {
				return;
			}
			var cont = EditorUtil.getCurrentContributor();
				
			var params = {
				artifactItemId: self.getItemId(),
				artifactStateId: self.getStateId(),
				contributorId: cont.userId
			};
			DirtyItemInfoClient.postDeleteDirtyItemInfo({
				success: function(data) {
					if(data){
						self.ownsDirtyItemInfo = false;
					}
				},
				error: function(e) {
					console.dir(e);
				}
			}, params, sync);	
		},

		isSaving: function() {
			return this._isSaving;
		},
		
		setSaving: function(saving) {
			this._isSaving = saving;
		},
		
        isLoading: function() {
            return this._isLoading;
        },
        
        setLoading: function(loading) {
            this._isLoading = loading;
			if (this.getHeader()) {
				if (loading === true) {
                    // hide UI items while loading to minimize flickering 
                    if (this._tableOfContentsNode)      
                        dojo.style(this._tableOfContentsNode, "visibility", "hidden");
                    var localizedType = Constants.getArtifactTypeLabel(this.getArtifactType());
					this.getHeader().setProgressStart(Constants.getMessage("labelLoadingArtifact", localizedType), /*hide content*/true);
				} else {
                    if (this._tableOfContentsNode)      
                        dojo.style(this._tableOfContentsNode, "visibility", "visible");
					this.getHeader().setProgressEnd();
				}
			}
        },		
		
        setLoadingArtifactComplete: function() {
            if (this._getTemplatedComplete && this._loadSectionsComplete) {
                this.setLoading(false);

                if (this.isNew() || this.isCopy()) {
                    if(this.changingTemplate)
                        delete this.changingTemplate;
                     else
                     {
                        if (this.getHeader()) 
                                this.getHeader().setEditableTitleFocus();                        
                     }
                }
            }
			this._isAlertWhenChangeTemplate = false;
			this.updateSaveable();
			
            delete this.deferredRelatedInfo;
            if (this.page && dojo.isFunction(this.page.updateRelatedInfoHandler)) {
                // the related info is delegated to the widget to update on load completed
                this.page.updateRelatedInfoHandler(this.page);
            }
        },
        
        // Wrapper method used by the ArtifactEditorPageController to listen to loading completed
        // including the dynamic editor sections.  This is needed because subclass editors use
        // setLoadingArtifactComplete() during the init.
        contentLoadCompleted: function() {
            this.setLoadingArtifactComplete();
        },

        isArchived: function() {
        	var artifact = this.getArtifact();
            return artifact && artifact.archived;
        },
        
        isPurged: function() {
        	var artifact = this.getArtifact();
            return artifact && artifact.purged;
        },
		        
        isSnapshot: function() {
            return (this._isSnapshot || (!this.isCopy() && this.getArtifact() && this.getArtifact().snapshotInfo));
        },
		
		setIsSnapshot: function(isSnapshot) {
			this._isSnapshot = isSnapshot;
		},
		
		isCopySnapshot: function(){
			return this._isCopySnapshot;
		},
		
		setIsCopySnapshot: function(isCopySnapshot){
			this._isCopySnapshot = isCopySnapshot;
		},
		
		//Individual artifacts may decide to over-ride if snapshots are not supported
		isSnapshotSupported: function(){
			return true;
		},
		
		isSupportSummary: function(){
        	return true;
        },
		
		isPrintView: function() {
			return this._isPrintView;
		},
		
        setPrintView: function(printView) {
            this._isPrintView = printView;
        },		

        getPrintViewURI: function() {
            return this._printViewURI;
        },
        
        setPrintViewURI: function(uri) {
            this._printViewURI = uri;
        },		
		
		supportsPrintView: function() {
			return (this.getPrintViewURI() != null);
		},
        
        isEditable: function() {
            return !(this.isReadOnly() || this.isSnapshot() || !this.isSaveableState());
        },
        
        isNew: function(){
            return this._isNew;
        },
	
		isWorkItemSupported:function(){
			return this.isEditable();
		},
        
        setNew: function(newx){
            this._isNew = newx;
        },
        
        getArtifact: function(){
            return this._artifact;
        },
        
        setArtifact: function(artifact){
            this._artifact = artifact;
			
			if (this.isCopy()) {
                // save the name of the artifact. Use that to generate a new name for this copy
                if(!this._baseName) {
                    this._baseName = this._artifact.name;
                }               			    
				this._artifact.name = Constants.getMessage("labelCopyOf", this._baseName);
			} 
			// Copied from snapshot, don't count that it's a snapshot. 
			var isSnapshot = this.isSnapshot();
			
			// initialize the read only mode for the artifact.
            this.setReadOnly(this._artifact && (isSnapshot || this._artifact.locked || this.isPrintView() || !this.isRolePermitsEdit() || (this.isMerging() && this.isMergeSource)));

            var model = this.getArtifactModel();
			if (model!=null) {
				model.setArtifact(this._artifact);
			}
        },
        
        getArtifactType: function(){
        	if (this._artifactType == null) {
        		console.debug("getArtifactType returning null");
        	}
            return this._artifactType;
        },        
        
        setArtifactType: function(artifactType){
            this._artifactType = artifactType;
        },   
		
		getTemplate: function() {
            return this._template;		      			
		},	

        setTemplate: function(template) {
            this._template = template;                      
        },		
		
		getTemplateId: function() {
			if (this._templateId) {
				return this._templateId;
			} else if (this.isNew() && this.getTemplate()) {
				return this.getTemplate().itemId;
			} else if (this.getArtifact()) {
				return this.getArtifact().templateItemId;
			}
			return null;
		},
		
        setTemplateId: function(templateId) {
            this._templateId = templateId;                      
        },		
		
		getEditorId: function() {
			if (this._editorConfig) {
				return this._editorConfig.id;
			}
			return null;
		},
		        
		getArtifactSection: function(id) {
            if (this.getArtifact()) {
				var sections = this.getArtifact().sections;
				var secLen = sections ? sections.length : 0;
				for (var i = 0; i < secLen; i++) {
					var s = sections[i];
					if (s.id == id) return s;
				}
			}
			return null;
        },
        
        // @override for SaveParticipant
        getItemId: function(){
            if (this.isCopy() || this.isNew()) 
                return null;
            return this.getArtifact().itemId;
        },
		
        // @override for SaveParticipant
        getStateId: function(){
        	if(this.isMerging() && this.getCurrentStateItemId()){
        		return this.getCurrentStateItemId();
        	} else {
        		if (this.isCopy() || this.isNew()) 
        			return null;        
        		return this.getArtifact().stateId;	
        	}			
        },		
        
        // @override for SaveParticipant
        getVersionableItemId: function(){
            if (this.isCopy() || this.isNew()) 
                return null;
            return this.getArtifact() ? this.getArtifact().versionableItemId : null;
        },
        
        getSectionIndex: function(sectionID){
        	var sections = this.getSections();
        	var len = sections.length;
        	for(var i=0;i<len;i++){
        		var section = sections[i]; 
        		if(section._section.id == sectionID){
        			return i;
        		}
        	}
        	return -1;
        },
        
        updateArtifact:function(newArtifact, /* optional */ checkMerging){                	        	
        	if (this.getWorkflowState(newArtifact) !== this.getStateValue()) {
        		this._reloadEditor();
        	}
        	// Check if we should consider if artifact is in merging.
        	// We don't want to keep current sections if in merging that contains
        	// section entries from diff that are not real artifact sections.
        	var merging = checkMerging ? this.isMerging() : false;
        	
        	if(!this.changedSections) {
        	    if (merging && this.diffMergeController) {
        	        // Restore the original saved artifact sections if no sections changed.
        	        // Otherwise the new artifacts will replace all the artifact sections.
        	        this.diffMergeController.restoreSaveArtifactSections();
        	    }
        		var currentSections = this.getArtifact().sections;
        		var newSections = newArtifact.sections; //updated sections sent by the server
        		//merge sections, update  changed sections and ignore others        		        	
        		var len = newSections ? newSections.length : 0;
        		for(var i=0;i<len;i++){     
        			var section = newSections[i];
        			var index = (merging && this.diffMergeController) ? this.diffMergeController.getArtifactSectionIndex(section.id) : this.getSectionIndex(section.id);
        			currentSections[index] = section;        			
        		}        	
        		newArtifact.sections = currentSections;
        	}
        	this.setArtifact(newArtifact);        
        },

        saveFinishedApprovalOnly: function(){
        	//update header
        	this.updateHeader();
        	this.getHeader().setProgressEnd();
        	this.getHeader().clearStatus();
        	var error = {};        	
			var formalReviewMessage = this.formalReviewMessage;			
        	this._isSaving = false; //set manually the setsaving flag to avoid updatesaveable (we will do it later)
        	if(formalReviewMessage){
        		error.message = formalReviewMessage;
        		this._saveError(error);        		
        	} else {
        		this.setSaving(false);
        		//re-publish the artifact and let the model update the tab (probably we are doing extra work here,
        		//but if we don't republish the artifact the tab  status stays dirty when the approval is modified and the artifact not)
        		var model = this.getArtifactModel();
    			if (model!=null) {
    				model.setArtifact(this._artifact);
    			}     	
    			//If we are here means that everything was ok
        		this.setDirty(false);
        		if(this._approvalSection)
        			this._approvalSection._initialize(true);
        		this.setLastSaved(Constants.STATUS_SUCCESS);
        	}  
        	
        	//clean messages and flags from class context
			this.formalReviewMessage =  null;
			this.artifactError = null;
			this._delayedFormalReviewSave = false;			
			this.saveSnapshot = false;
        },
        
        // @override for SaveParticipant
        saveFinished: function(savedArtifact){
        	if(this.draftInProgress){
        		//This means this is not a real artifact, but a draft one created with merge purposes, 
        		//we should break  the cycle and invoke merge 
        		delete this.draftInProgress;
        		this.setSaving(false);
        		this._staleMergeInProgress = true;
        		this._onMergeSourceSelected([savedArtifact], true);
        		return;
        	}
        	var wasNew = this.isNew();
        	this.setNew(false);
        	this.setCopy(false);
        	this.localEditorDirty = false;
        	 
        	savedArtifact = WorkItemUtils.fixupArtifactWorkItems(savedArtifact);
        	if(!wasNew){
        		this.updateArtifact(savedArtifact, /* checkMerging */ true);
        	} else {
        		this.kwArgs  = {
        			id: savedArtifact.id
        		}; 
        		this.setArtifact(savedArtifact);
        		
        		// Check if owner changed
        		var newOwner = savedArtifact.owner;
        		if (newOwner && this.getOwnerValue() !== newOwner.itemId) {
        			this.setOwnerValue(newOwner);
        		}
        	}
        	//flag must be reset AFTER updateArtifact
        	this.changedSections = false;
        	//update header
        	this.updateHeader();
        	
            if (this.isMerging()) {
                this._exitDiffMerge();  
                delete this._staleMergeInProgress;                
                this.initialize({
                    isCopy: this.isCopy(),
                    artifact: this.getArtifact()
                });
            } else {
                //update Sections
                this.updateSections();
            }
        	//update TOC
        	this.updateTableOfContents();  
        	        	
        	this.saveSnapshot = false;
        	
            this.getHeader().setProgressEnd();
        	this.getHeader().clearStatus();

        	// update the state, just in case that the state had changed.
        	this._updateState();

            // if there is an exception occurred during outside 
            // handling of the published event, we need to catch it 
            // to avoid this editor from not completing its processing. 
            try {
                // this was a new artifact. Need to update its URI to a saved artifact one.
                // This allows any new navigation to this artifact to reuse the same editor page. 
                if (wasNew) {
                    this._publishArtifactUriChanged();
                    this._publishArtifactAdded();
                }
                // Publish artifact on update
                // notify other tabs is it is not new
                else {
                    this._publishArtifactUpdated();
                }
            } 
            catch (e) {
                CommonUtility.printException('AbstractArtifactEditor', 'saveFinished', e);
            }

        	//Update Section's WIs if needed to disable re-saving (WI:33157)  
        	var sections = this.getSections(); 
        	var secLen = sections ? sections.length : 0;
        	for (var i = 0; i < secLen; i++) {
        		var sectionWorkItem = sections[i]._sectionWI;
        		if(sectionWorkItem)
        			sectionWorkItem.isSaved = true;
        	}
        	// if the title is changed, the listing view, "My" and "All" artifacts query result view,
        	// need to be updated.
        	//
        	if (this._titleModified) {
        		this._titleModified = false;
        	}
        	this.setSaving(false);
        	this.setDirty(false);
            this.setLastSaved(Constants.STATUS_SUCCESS);
			//set ownsDirtyItemInfo flag to false
			this.ownsDirtyItemInfo = false;


        	//When state changes we may require to  set/unset some sections from/to read only mode
        	//so we will redo the Editor on those cases
        	if(this._stateChanged){
        		// clean up the approval DTO to re-fetch it internally, this is because for this specific case, 
        		// the CompositeDTo is not fetched and we use the getArtifact that IDocumentRaw service returns. 
        		// But only clear the attribute if we have the artifactCompositeDTO. For a new artifact after save
        		// we don't have an artifactCompositeDTO
        		if(this.artifactCompositeDTO) {
        			this.artifactCompositeDTO.approvalGroup = null;
        		}
        		// WI 68592: Re initialize as callback for sections like rmLinksSection to avoid widget destruction when in use
        		if(!this.reinitAsCallback) {  
        			this.reinitializeEditor();
        		}
        	}
        	this.setUri(window.location.hash);
        },
        
        reinitializeEditor: function() {
        	var args = {
    				isCopy:this.isCopy(),
    				artifact: this.getArtifact()
    		};
    		this.setTemplateId(null);
            this.setTemplate(null);
    		this.getArtifactModel().getSaveContext().clearParticipant();
    		this.getArtifactModel().getSaveContext().addParticipant(this);                

			// we are about to recreate the section content. If we're in
			// maximize mode, restore to normal mode. The section may not
			// be editable after the reinitialize
    		if(this.inMaximize && this.maximizedSectionId) {
    		    this.maximizeCenterContent(false, this.maximizedSectionId);
    		}
            // save the current selected section and attempt to restore it, we only
            // need to do this specifically in the case where the editor is re-initialized. 
            // Save the section for the restore.
            // 
            var curSelectedSection = null;
            if (this._tocWidget) {
                curSelectedSection = this._tocWidget.getSelectedEntry();
                if (curSelectedSection) {
                    this.restoreLastSelectedSection = curSelectedSection.tag;
                }
            }
            setTimeout(dojo.hitch(this, function() {
            	this.initialize(args);

            	if (!this.justApprovedOrRetired) {
            		this.setLastSaved(Constants.STATUS_SUCCESS);
				} else {
					this.setHeaderStatus(Constants.getCommonMessage("statusSaveSuccess", EditorUtil.getTimeString()), 
							Constants.HEADER_STATUS_WARNING, Constants.getMessage("labelConstraintDescription1"));
				}
            }), 0);
        },
		
		setUri: function(uri){
			this._uri = uri;
		},                
		
		saveDataStalledError: function(status){
			this.getHeader().setProgressEnd();
        	this.getHeader().clearStatus();
        	this.setSaving(false);
        	var args =  {
        			mergeCallback:  dojo.hitch(this, dojo.hitch(this, function(){
                      	this.draftInProgress = true;                      	
                      	this.getSaveContext().commit();  //save, but skip all process validations, we just want to create a draft
                      })),
        		 /*   overrideCallback: dojo.hitch(this, function() {
                      	this.overrideSave = true;
                      	this.onSave();
                      }), */
        		     cancelCallback: dojo.hitch(this, function(){
        		                var confirmDialog = new ConfirmationDialog({
        		                    message: Constants.getMessage("msgConfirmCancel"),
        		                    primaryTitle: Constants.getMessage("labelConfirmation"),
        		                    okCallback: dojo.hitch(this, "_reloadEditor")
        		                });
        		                confirmDialog.open();
                   	}),
                   	artifactTypeLabel:Constants.getArtifactTypeLabelPart(this.getArtifactType())
        		};
        	var staleMessage = new AbstractArtifactEditor.StaleDataMessage(args);
        	
            this.setHeaderStatus(staleMessage.domNode, Constants.HEADER_STATUS_ERROR, "");

		},
		
		 //Update local attributes, like description, priority and owner for for the local artifact when we are in stale data merge, otherwise we will end up losing that data
        updateLocalArtifactAttributes: function(){
        	
        	var artifact = this.getArtifact();
        	
        	//save a copy before updating attributes in case user decides to cancel the merge
        	this._originalArtifact = dojo.clone(artifact);       
        	
        	var name = this.getHeader().getTitle();
            var state = this.getStateValue();
			var priority = this.getPriority();
            var description = this.getHeader().getSummary();		
            var ownerId = this.getOwnerValue();                    	
        	        	
        	if(name){
        		artifact.name = name;
        	}
        	
        	if(state){
        		artifact.state = state;         		
        	}
        	if(priority){
        		artifact.priority = priority;
        	}
        	if(description){
        		artifact.description = description;
        	}
        	if(ownerId != artifact.owner.itemId){
        		artifact.owner = this.getOwner.getValue();
        	}
        },
        
		
        // @override for SaveParticipant
        saveFailed: function(status){        	
        	if(this.diffMergeEnabled && status.code == Constants.EDITOR_STALLED_DATA_EXCEPTION){ 
        		this.setSaving(false);
            	return this.saveDataStalledError(status);            	
        	}
            var saveTypeMsgId = this.saveSnapshot ? "msgSaveArtifactSnaphotError" : "msgSaveArtifactError";
            var artifactMsg = Constants.getMessage(saveTypeMsgId, Constants.getArtifactTypeLabel(this.getArtifactType()));
            
        	this.saveSnapshot = false;
            this.getHeader().setProgressEnd();
            if (status != null && status.ok != true) {
                status.message = artifactMsg + "\n" + status.message;
                this._saveError(status);
            }
			this.setSaving(false);
        },
        
        onSaveSnapshot: function(){      
        	this.saveSnapshot = true;
        	if (this.isSaving()) {
                return; //protects against multiple save button clicks
            } else {
                this.setSaving(true);
            }
        	this.getHeader().clearStatus();
        	this.getHeader().setProgressStart(Constants.getMessage("labelSavingArtifact", Constants.getArtifactTypeLabel(this.getArtifactType())));             
            dijit.focus(this.getHeader().domNode);          
            var status = this.getSaveContext().commit();
            if (status != Constants.STATUS_SAVING) {
                this.setSaving(false);
                this.getHeader().setProgressEnd();
                this.setLastSaved(status);
            }			
        },
        
        isContentPostSaveSectionsDirty: function(){
			if(this.localEditorDirty){
				return false;
			}
			var sections = this.getSections();
			var secLen = sections ? sections.length : 0;
			var postSaveSectionDirty = false;
			for (var i = 0; i < secLen; i++) {
				var s = sections[i];
				if(s.contentSaveOnPostSavedOnly()){
					if(s.isSectionDirty()){
						postSaveSectionDirty = true; 
					}					
				}else if(s.isSectionDirty()){
					return false;
				}	            
			}
			return postSaveSectionDirty;
		}, 
        
        //used for sections that do not require the normal document raw service save and use its own post save instead
    	//RETURNS either if normal save should continue or not
        onSavePostSavedContentOnly: function(){
        	if(this.isDirty() && this._isSaveable() && this.isEditable() && this.isContentPostSaveSectionsDirty()){
				this.saveFinished(this.getArtifact());   
				return false;
				//Stop normal save processs, we are done. 
			} else {
				//no action was done, just continue with normal save
				return true;
			}
        	
        },
        
        onSave: function(){
        	if(this.hasContentOnPostSavedOnly){
        		var shouldContinue  = this.onSavePostSavedContentOnly();
        		//If there are no other dirty sections to save except the ones registered as post-save on finish only, 
        		//onSavePostSavedContentOnly has already called saveFinished, so we are done. 
        		//Continue with normal save otherwise
        		if(!shouldContinue){
        			return;
        		}
        	}
        	if(this._approvalSection && this._approvalSection.isDirty()
        	        && !this.isDirty()){
                var saveRequiresSignature = this._approvalSection.saveRequiresSignature();
                if (saveRequiresSignature) {
                    new ESignatureDialog({
                        onSign: dojo.hitch(this, "_doSaveApproval"),
                        esignRequiredMessage: Constants.getMessage("msgEsignReview"),
                        esignConfigData: saveRequiresSignature
                    });                     
                } else {
                    this._doSaveApproval();
                }
    		}
			//protect against keyboard shortcut save when save shouldn't be available
			if (!this._isSaveable()) {
				return;
			}
			//clean Header Status: 
			this.getHeader().clearStatus();
			
			if(this.isEditable() && this.validate() == false) {
				return false;
			}     
            //HACK - section level validation
            //SHOULD BE REMOVED - See RQM WI 2562
            var sections = this.getSections();
			var secLen = sections ? sections.length : 0;
            for (var i = 0; i < secLen; i++) {
				var s = sections[i];
				if (s.isEditable() && s.validate() == false) return false;
            
            }
			
			//can we save yet or is esig required ?
            var esigRequired = false;
            var esigConfigData = {};
            for (var i = 0; i < secLen; i++) {
				var s = sections[i];
				esigConfigData = s.saveRequiresSignature();
                if (s.isEditable() && esigConfigData) {
                    esigRequired = true;
                    break;
                }
            }
			
			if (esigRequired) {
	            //re-authenticate the user
	            new ESignatureDialog({
	                onSign: dojo.hitch(this, "_doSave"),
	                esignRequiredMessage: Constants.getMessage("msgEsignReview"),
                    esignConfigData: esigConfigData
	            });						
			} else {
				this._doSave();
			}
        },
		
        _startSaving: function() {
            // notification of the start of a commit save.    
        },
        
        registerApprovalSection: function(approvalSection){        	
        	this._approvalSection = approvalSection;
        	if(this.artifactCompositeDTO){
        		approvalSection.setCompositeDTO(this.artifactCompositeDTO.approvalGroup);
        		
        		// provide method to have review section to call us back when the data has changed.
        		approvalSection.notifyApprovalCompositeChanged = dojo.hitch(this, function(approvalDTO) {
        			if(this.artifactCompositeDTO){
        				this.artifactCompositeDTO.approvalGroup = approvalDTO;
        			}
        		});
        	}
        },
                      
        _doSaveApproval: function(esignPassword, esignComment, esignReason, esignAction) {            
            //set save in progress
            if (this.isSaving()) {
                return; //protects against multiple save button clicks
            } else {
                this.setSaving(true);
            }
            this._approvalSectionDirty = true;
            this.getHeader().setProgressStart(Constants.getMessage("labelSavingArtifact", Constants.getArtifactTypeLabel(this.getArtifactType()))); 
            var callback = {
                    success: dojo.hitch(this, function(data){
                        this.saveFinishedApprovalOnly();
                    	// Reload the editor if the artifact state changed (for approval trackings)
                        if (data.stateUpdated) {
                        	this._reloadEditor();
                        }
                    }),
                    error: dojo.hitch(this, function(error){
                        this.formalReviewMessage = error;
                        this.saveFinishedApprovalOnly();
                    })
            };              
            this._approvalSection.internalFormalReviewSave(callback, esignPassword, esignComment, esignReason, esignAction);
        },
        
        _doSave: function(esignPassword, esignComment, esignReason, esignAction) {            
            //set save in progress
            if (this.isSaving()) {
                return; //protects against multiple save button clicks
            } else {
                this.setSaving(true);
            }
        
            if(this._approvalSection && this._approvalSection.isDirty()){
                this._approvalSection.initializeAsSaveParticipant(esignPassword, esignComment, esignReason, esignAction);
            }
            
            this.justApprovedOrRetired = false;
            
            if (this.getStateChanged()) {
            	var state = this.getStateValue();
            	var artifactType = this.getArtifactType();
            	if (WorkflowManager.stateBelongsToApprovedOrRetired(state, artifactType) 
    					&& ConstraintsUtil.isConstraintEnabled(ConstraintsUtil.RestrictSave, artifactType, this.getTeamAreaItemId())) {
    				this.justApprovedOrRetired = true;
    			}
            }
            
            
            // send a notification of a start saving.
            // interested parties, i.e., sections can 
            // connect to this method to receive the start
            // of a save commit.
            this._startSaving();
            						
			// Turn off the template changed flag
			if(this.templateChanged)
				delete this.templateChanged;
			
            //invoke the global save transaction        
            this.getHeader().setProgressStart(Constants.getMessage("labelSavingArtifact", Constants.getArtifactTypeLabel(this.getArtifactType()))); 
            //HACK: FIX 6663, give a new focus after the Save button is disabled
            dijit.focus(this.getHeader().domNode);          
            
            var commitFunc = dojo.hitch(this, function() {
                var status = this.getSaveContext().commit();
                if (status != Constants.STATUS_SAVING) {
                    this.setSaving(false);
                    this.getHeader().setProgressEnd();
                    this.setLastSaved(status);
                }			            	
            });
            
            // call our pre-save processor method to do any needed long running processing
            // before the commit save can be called.
            this._preSaveProcessor(commitFunc);
		},
        
		// Summary:
		//     A method that sub-class or child sections can override to take over thread control before
		//     the actual save commit is performed. This allows for any long running processing, like adding
		//     1000s of items to the save participants, to be performed in chucks to avoid starving the 
		//     browser's UI thread and popup an non-responsive script dialog. Note that only the last 
		//     override would be run. If more then one section attempt to use this, only the last section
		//     overriding this method would be called.
		//     
		//     NOTE: Currently, only the test cases section is overriding this method. If more then one section
		//     need this processing, we'll need to create a queue to call each pre-save processor.
		//     NOTE2: Environments section is also connecting here, but just for merge preprocessing for save
		// 
		_preSaveProcessor: function(onComplete) {
			// by default, we'll just call onComplete to commit the save immediately.
			onComplete();
		},
		
        _closeNewEditor: function(){
            var model = this.getArtifactModel();
            if (model.viewController) {
                model.viewController.closeTab();
                return true;
            }
            return false;
        },
                                
        onCancel: function(){
            // new editor and no edits yet, just close the tab.
            if(this.isNew() && !this.isDirty()) {
                if(this._closeNewEditor()) {
                    return;
                }
            }
			var self = this;
			var artifact = this.getArtifact();
			var msgKey = "msgConfirmCancel";
			if (this.isMerging()) {
				// Cancel is enabled for merging when not dirty
				msgKey = this.isDirty() ? "msgConfirmCancelMergeDirty" : "msgConfirmCancelMerge";
			}
			var args = {
				primaryTitle: Constants.getMessage("labelConfirmation"),
				message: Constants.getMessage(msgKey),
				yesCallback: function(){
                    if (self.isNew()) {
                        if (self._closeNewEditor()) {
                            return;
                        }
                    }
					//delete DirtyItemInfo if needed
					if(self.ownsDirtyItemInfo){
						//false = no sync call
						self.deleteDirtyItemInfo(false);
					}                       
                    //reset to default template (if templated)
                    self.setTemplateId(null);
                    self.setTemplate(null);
                    //reset savecontext
                    if (self.isEditable()) {
                        self.getArtifactModel().discardChanges();
                        self.getArtifactModel().getSaveContext().addParticipant(self);
                    }
                    // reset state changed, this also controls the editability
                    // of the editor. We don't want this flag to change the actual
                    // editability of the editor
                    self._stateChanged = false;
                    
                    if (self.isMerging()) {                    	
                    	if(self._staleMergeInProgress){
                    		//should mark the artifact dirty again and recover the old state artifact
                    		self.setArtifact(self._originalArtifact);

                    		setTimeout(dojo.hitch(self, 'setDirty', true), 
                    				0);
                    		
                    		//cleanup flags/objects
                    		delete self._originalArtifact;
                    		delete self._staleMergeInProgress;
                    		
                    	}                  
                    	self._exitDiffMerge(/* restore original sections */ true);        
                    }
                    
                
                    	//re-initialize	         	                  
                    	self.initialize({
                    		isCopy: self.isCopy(),
                    		artifact: artifact
                    	});
                    return true;
                },
				noCallback: function() {
					return false;
				}
			};
			var dialog = new YesNoDialog(args);
	        dialog.open();
        },
		
		onPrintView: function() {
			if (this.supportsPrintView()) {
                this.goingToPrintView();
				window.location.hash = this.getPrintViewURI();
			}
		},
		
		
        goingToPrintView: function() {
            // notify going to the print view of the editor
        },
        
		_submitPrintJob: function(printType, mimeType, condensedOrDojoAction) {
		    var revision;
		    var artifact = this.getArtifact();
		    
		    if (artifact.snapshotInfo && artifact.snapshotInfo.revision)
		        revision = artifact.snapshotInfo.revision;
		    
            var artifactList = [PrintHelper.createArtifactObject(artifact.id, revision)];
            var historyArgs = {};
            if(printType == "history" && this._historyMainPanel){
            	historyArgs = this._historyMainPanel.getCurrentHistoryParameters();
            }
            PrintHelper.submitPrintJob(printType, this._printArtifactType, artifactList, null, null, historyArgs, null, null, null, condensedOrDojoAction);
		},
		
		/*
	      * A Method to launch the print options dialog. Override in subclass.
	      */
	    startPrintOptions: function(){
	        return;
    	},
				
		_onLock: function() {
            if (this.isDirty()) {
                new AlertDialog({
                    message: Constants.getMessage("msgDirtyArtifact"),
                    primaryTitle: Constants.getMessage("labelAlert")
                }).open();
            } else {
                var artifactType = this.getArtifactType();
                var teamArea = this.getTeamAreaItemId();
    		    if (ConstraintsUtil.isConstraintEnabled(ConstraintsUtil.getESignLockConstraintId(artifactType), artifactType, teamArea)) {
    		        // get the config data for the E-Sign of Lock/Unlock
                    ConstraintsUtil.loadConfigurationData(ConstraintsUtil.EsignLockChange, artifactType,
                        ConstraintsUtil.ESignConfigElementId, /* isSaveOperation */ true, teamArea, dojo.hitch(this, "_showESignatureDialog"),
                        /* optional projectArea */ null, /* useCache */ null, /* blockUI */ true);
    		    } else {
    		        this._doLock();
    		    }
            }		        
		},
        
		_showESignatureDialog: function(configData) {
		    // prepare the config data to populate the E-Sign dialog
	        var constraintConfigData = ConstraintsUtil.parseESignaureConfigurationData(configData);
	        if (constraintConfigData) {
                var action = this.getArtifact().locked ? Constants.getMessage("labelUnlocked") : Constants.getMessage("labelLocked");
                var approvalAction = [{ "action": action }];
                constraintConfigData.approvalActions = approvalAction;
	        }
            new ESignatureDialog({
                onSign: dojo.hitch(this, "_doLock"),
                esignRequiredMessage: Constants.getMessage("msgEsignLock"),
                esignConfigData: constraintConfigData
            });
		},
		
		//@Override if locking is supported
		lock: function(serviceResponseHandler, esignPassword, esignComment, esignReason, esignAction) {
			this.getHeader().setProgressEnd();
			this.getHeader().setStatus("Inconsistent Editor Behavior", ViewHeaderLayout.WARNING, "X Model indicates locking supported but editor does not implement doLock()");
		},
		
		_doLock: function(esignPassword, esignComment, esignReason, esignAction) {
			//successful esig; lock the artifact
            var action = this.getArtifact().locked ? "labelUnlockingArtifact" : "labelLockingArtifact";
            var localizedType = Constants.getArtifactTypeLabel(this.getArtifactType());
            this.getHeader().setProgressStart(Constants.getMessage(action, localizedType));            
            //
            // TODO: get the correct params to save
            //
			this.lock(new ServiceResponseHandler(this, "_lockSuccess", "_lockFailure"), esignPassword, esignComment, esignReason, esignAction);
		},
		
		_lockSuccess: function(newArtifact) {
            //reset the editor
			this.getHeader().setProgressEnd();
			if (!newArtifact.locked) {
				// Artifact unlocked, remove the "Artifact locked" message
				this.getHeader().clearStatus();
			}
            //reset savecontext
            this.getArtifactModel().discardChanges();   
            this.getArtifactModel().getSaveContext().addParticipant(this);  
            //re-initialize editor           
			this.setReadOnly(newArtifact.locked);  
			this.localEditorDirty = false;
            this.initialize({
                isCopy: this.isCopy(),
                artifact: newArtifact
            });         
		},
		
		_lockFailure: function(e) {
            //locking server operation failed
		    if (e.nestedError && e.nestedError.errorClass 
		            && e.nestedError.errorClass == "com.ibm.team.process.common.advice.TeamOperationCanceledException"){
		        // remove the stacktrace blob that comes back for invalid e-sig
		        e.nestedError = e.exception = e.errorClass = null;
		    }
            this.getHeader().setProgressEnd();
			var action = this.getArtifact().locked ? Constants.getMessage("labelUnlock") : Constants.getMessage("labelLock");
            this.getHeader().setStatus(Constants.getMessage("msgLockFailure", action, Constants.getArtifactTypeLabel(this.getArtifactType())), ViewHeaderLayout.ERROR, null, e);			
		},
		
		//@Override for SaveParticipant
        getAttributes: function(){
            var attributes = {};
            	//add attributes from sections into main args
            	var sectionsOrder = [];
            	// if it is merging, get the sections from the diffMergeController without any chicklets
            	var sections = this.diffMergeController ? this.diffMergeController.getEditorSections() : this.getSections(); 
            	var secLen = sections ? sections.length : 0;
            	for (var i = 0; i < secLen; i++) {
            		var s = sections[i];
            		var sectionAttributes = s.getAttributes();
            		dojo.mixin(attributes, sectionAttributes);
            		sectionsOrder.push(s.getConfig().id);
            	}            

            	if (this.changedSections && sectionsOrder) {
            		//TODO send up an array instead of this comma delimited string
            		attributes.sectionsOrder = sectionsOrder.join();
            	}
            attributes.workItemsJsonString = this.getWorkItemsJSON();
            attributes.sectionJsonString = this.getSectionsJSON();	
            if (this._sectionsRemoved != null && this._sectionsRemoved.length > 0) {
                //TODO send up an array instead of this comma delimited string
                attributes.sectionsRemoved = this._sectionsRemoved.join();
            }

            var artifactType = this.getArtifactType();
            if (WorkflowManager.stateBelongsToUnderReview(this.getStateValue(), artifactType) && 
            		ConstraintsUtil.isConstraintEnabled(ConstraintsUtil.ReadyForReview, artifactType, this.getTeamAreaItemId())) { 
                attributes.checkWIsApproved = true; 
            }            
            if(this.draftInProgress){
            	attributes.isDraft = true;            	
            }
			return attributes;		
		},
		
		//@Abstract - override if necessary, but default behavior should be sufficient
        getWorkItemsJSON: function(){
            var workItemList = [];
            var sections = this.getSections(); 
			var secLen = sections ? sections.length : 0;
            for (var i = 0; i < secLen; i++) {
               var sectionWorkItemInfo = sections[i].getWorkItemInfo();
               if(sectionWorkItemInfo && !sectionWorkItemInfo.isSaved){                    
                        workItemList.push(sectionWorkItemInfo);
                }
			   var removedSectionWorkItemInfo = sections[i].getRemovedWorkItem();
               if(removedSectionWorkItemInfo){                   
                        workItemList.push(removedSectionWorkItemInfo);
                }
            }           
            return dojo.toJson(workItemList);
        },
        
        //@Abstract - override if necessary, but default behavior should be sufficient
		getSectionsJSON: function(){
            var sectionList = [];
            var sections = this.getSections(); 
			var secLen = sections ? sections.length : 0;
            var isNew = this.isNew();
            
			for (var i = 0; i < secLen; i++) {	
				var section = sections[i];
				if(isNew || section.isSectionDirty() || section.isNewSection()){
					var sectionInfo = section.getSectionInfo();
					if (sectionInfo) {
						sectionList.push(sectionInfo);
					}
				}
			}           
            return dojo.toJson(sectionList);
        },		

        ////////////////////////////////////////////////////////////////////////////////////////////////////
        //                                   EDITOR VIEW HEADER API                                       //
        ////////////////////////////////////////////////////////////////////////////////////////////////////        
        createHeader: function(iconClass, contentNode, snapshotsNode, historyNode) {
			// disconnect the validate action associated with previous header
			if(this._headerStartValidatingAction)
				this.disconnect(this._headerStartValidatingAction);
            var _dojo = dojo;
            var artifact = this.getArtifact();
            var labelArtifactType = Constants.getArtifactTypeLabel(this.getArtifactType());
			var args = {
                tabsControlOrientation: !this.isPrintView() ? this._headerTabOrientation : 'horizontal',
                splitAttributeArea: this._splitHeaderAttributeArea,
                title: this.getHeaderTitle(),
                titleEditable: !(this.isReadOnly()),
                noTitleLabel: Constants.getArtifactTypeMessage("labelNewPageNoTitlePrompt", this.getArtifactType()),
                subTitle: this.getHeaderSubTitle(),
                useDualContents: (!this.isPrintView() && contentNode && snapshotsNode),
                mainContentSelectedLabel: Constants.getMessage("labelArtifactOverview", labelArtifactType),
                mainContentDeselectedLabel: Constants.getMessage("labelArtifactOverview", labelArtifactType),               
                altContentSelectedLabel: Constants.getMessage("labelViewSnapshots"),
                altContentDeselectedLabel: Constants.getMessage("labelViewSnapshots"),
                historyContentSelectedLabel: Constants.getMessage("labelViewHistory"),
                historyContentDeselectedLabel: Constants.getMessage("labelViewHistory"),               
                typeLabel: labelArtifactType,
                iconClass: iconClass,
                historyActivated:historyNode?true:false,                
                summary: artifact ? artifact.description : ""
            };
                 
            this._header = new ViewHeaderLayout(args);

            if (this.breadcrumbTrail) {
                this._header.setBreadcrumb(this.breadcrumbTrail);
            }
			
            //create the save & cancel buttons          
            if (!this.isSnapshot()) {
				this._header.onTitleEdited = _dojo.hitch(this, "_onTitleChange");
				//dojo.connect(this._header, "onTitleEdited", this, "_onChange");
                if (!this.isPrintView()) {
                    if(this._supportsDuplicate == true){
                        this._duplicateButton = this.getHeader().addLeftViewAction(Constants.getMessage("labelDuplicateAction"), _dojo.hitch(this, "_onDuplicateActionClick"), null, "duplicate-icon-image");                   
                        var type = this._mapType2ExecutionType(this.getArtifactType());                        
                        if (this._compositeDTO) {
                        	this._isDuplicateAllowedCallback(this._compositeDTO.isCopyPermitted);
                        } else {
                        this._duplicationAction.isDuplicateAllowedInCurrentProjectArea(type, _dojo.hitch(this, "_isDuplicateAllowedCallback"));
                    }       
                    }       
					if (this.supportsPrintView()) {
                        //this._printButton = this._header.addRightViewAction(Constants.getMessage("labelPrintView"), dojo.hitch(this, "onPrintView"));
						this._printButton = this._header.addLeftViewAction(Constants.getMessage("labelPrintView"), _dojo.hitch(this, "onPrintView"), null, "print-icon-image");
					}
					if (this.getArtifactModel().isLockSupported()) {
						this._lockButton = this._header.addLeftViewAction(Constants.getMessage("labelLock"), _dojo.hitch(this, "_onLock"), null,  "lock-icon-image");
						this._updateLockAction();
					}
                    
                	if (this.diffMergeEnabled) {
                		this._diffMergeButton = this._header.addLeftViewAction(Constants.getMessage("labelCompare"), _dojo.hitch(this, "_initDiffMerge"), null, "compare-icon-image");
                    }
					
	                this._cancelButton = this._header.addRightViewAction(Constants.getMessage("labelCancel"), _dojo.hitch(this, "onCancel"),  null, null);
	                this._saveButton = this._header.addRightViewAction(Constants.getMessage("labelSave"), _dojo.hitch(this, "onSave"), null, null);
	                this._cancelButton.setLabel(Constants.getMessage("labelDiscardChanges"));
	                this._saveButton.setLabel(Constants.getMessage("labelSave"));
				}
                this.updateSaveable();
				
            } else {
                var onCurrentRev = _dojo.hitch(this, "_onCurrentRevisionClick");
                this._currentRevisionButton = this._header.addRightViewAction(Constants.getMessage("labelGotoCurrentRevision"), onCurrentRev);                
            }
            
            // add print button to header
            if (this._supportsPrint && !this.isPrintView()) {
			    var printMenu = PrintHelper.buildPrintMenu(
			        this, "_submitPrintJob", 
			        this._supportsArtifactSummary, this._supportsComprehensive, this._supportsHistory, this._supportsTableSummary,  true, (this.getArtifactType() == Constants.TYPE_PLAN || this.getArtifactType() == Constants.TYPE_CASE),(this.getArtifactType() == Constants.TYPE_CASE), (this.getArtifactType() == Constants.TYPE_SCRIPT) );
			    
    			this._menus.push(printMenu);
    			    			
    			this._pdfButton = this._header.addLeftViewAction(Constants.getMessage("labelPDFView"), _dojo.hitch(this, "_submitPrintJob"), null, "pdf-icon-image", printMenu);
    			this._pdfHistoryButton = this._header.addLeftViewAction(cmnConstants.getMessage("printLabelHistory"), dojo.hitch(this, "_submitPrintJob", "history", "application/pdf", true), null, "pdf-icon-image"); 
    		}
            
            // This editor supports refresh operation. Create the refresh action.
            if (this.loadArtifact && !this.isSnapshot()) {
                this._refreshButton = this._header.addLeftViewAction(Constants.getMessage("labelRefresh"), _dojo.hitch(this, "_handleRefreshAction"), null, "refresh-icon-image");
            } 
                       
            //append buttons if appropriate
            if (contentNode) {
                dojo.empty(contentNode);
                this._header.getContentNode().appendChild(contentNode);
                this.connect(this._header, "_selectMainContent", "_contentSelected");
            }
            if (snapshotsNode) {
                dojo.empty(contentNode);
                this._snapshotButton = this._header.addRightViewAction(Constants.getMessage("labelCreateNewSnapshot"), _dojo.hitch(this, "onSnapshot"));
                this._snapshotButton.setLabel(Constants.getMessage("labelCreateNewSnapshot"));
                this._header.getAltContentNode().appendChild(snapshotsNode);
                this.connect(this._header, "_selectAltContent", "_snapshotsSelected");
            }                
            
            if(historyNode){
            	dojo.empty(historyNode);                
                this._header.getHistoryContentNode().appendChild(historyNode);
                this.connect(this._header, "_selectHistoryContent", "_historySelected");
            }            
                        
            if(artifact && artifact.id)
            	this._header.setID(artifact.id);
			this._contentSelected();
            return this._header;          
        },  
		
        _handleRefreshAction: function () {
            if (this.isDirty()) {
                var confirmDialog = new ConfirmationDialog({
                    message: Constants.getMessage("labelConfirmRefreshArtifact"),
                    primaryTitle: Constants.getMessage("labelConfirmation"),
                    okCallback: dojo.hitch(this, "_reloadEditor")
                });
                confirmDialog.open();
            }
            else {
                this._reloadEditor();
            }
        },
        
        _reloadEditor: function(){
            // throw away the composite DTO. It might contain staled data. Let the editor's component
            // to reload fresh data.
            this._compositeDTO = null;
            
            this.localEditorDirty = false; 
            
            // save the current selected section and attempt to restore it, we only
            // need to do this specifically in the case where the editor is re-initialized. 
            // Save the section for the restore.
            var curSelectedSection = null;
            if (this._tocWidget) {
                curSelectedSection = this._tocWidget.getSelectedEntry();
                if (curSelectedSection) {
                    this.restoreLastSelectedSection = curSelectedSection.tag;
                }
            }         
            var type = null;
            if(this._artifactModel){
            	type = _mapSupportedCompositeDTO[this._artifactModel._artifactType];
        	}
        	if (type) {
        		this._callCompositeWeb(type, true);
        	} else {
        		this.loadArtifact();
        	}          
            
        },
        
		_isDuplicateAllowedCallback: function(allowed){
			if(!allowed)
    			this._duplicateButton.addClass("hidden");			
		},
		
		_duplicateError: function(e)
		{
			this.getHeader().setProgressEnd();
		},
		
		_duplicateEnd: function(copyStatus) {
			this.getHeader().setProgressEnd();
			if (copyStatus) {
				var detailsMsg = null;
				var uri = copyStatus.copiedItemUri;
				var duplicateSuccessfulMsg = Constants.getMessage("msgDuplicateSuccessful");
				detailsMsg = uri != null ? "<a href='" + uri + "'> " + duplicateSuccessfulMsg + "</a>" : duplicateSuccessfulMsg;
				
				this.getHeader().setStatus(duplicateSuccessfulMsg, ViewHeaderLayout.SUCCESS, detailsMsg);
			}
			var type =  this.getArtifactType();
			var responseHandler = new ServiceResponseHandler(this, "_reloadDTOAfterCopy", "_duplicateError");
			if(type == Constants.TYPE_PLAN ||type == Constants.TYPE_CASE  || type == Constants.TYPE_SUITE){										
				this.loadArtifact(responseHandler);
			} else if (type == Constants.TYPE_SCRIPT){
				this._reloadDTOForCopy(responseHandler);
			}
		},
		
		_reloadDTOAfterCopy:function(dto){
			if(dto && dto.length > 0 ){
				this.processCopyLinks(dto[0]);
			}
		},
		
		 _onDuplicateActionClick: function() {
			 	var _self = this;
				var selection = [ this.getArtifact()[this._duplicateActionIdTypeName] ];
				var duplicating = Constants.getMessage("msgDuplicating3", Constants.getArtifactTypeLabel(this.getArtifactType()));
				this.getHeader().clearStatus();
				this.getHeader().setProgressStart(duplicating);
				//this._duplicationAction.runWithNoFeedback();
				this._duplicationAction._onCancel = function(){
					_self.getHeader().setProgressEnd();
				};
				this._duplicationAction.openAfterComplete();
				this._duplicationAction.setType(this._mapType2ExecutionType(this.getArtifactType()));
				this._duplicationAction.execute(selection , dojo.hitch(this, "_duplicateEnd"), dojo.hitch(this, "_duplicateError"));					
		 },
		 
		 _mapType2ExecutionType: function(type){
		 	if(type == Constants.TYPE_CASE)
				return ActionEntityType.TEST_CASE;
			else if(type == Constants.TYPE_PLAN)
				return ActionEntityType.TEST_PLAN;
			else if(type == Constants.TYPE_SCRIPT)
				return ActionEntityType.TEST_SCRIPT;
			else if(type == Constants.TYPE_SUITE)
				return ActionEntityType.TEST_SUITE;
			else if(type == Constants.TYPE_DATAPOOL)
				return ActionEntityType.DATAPOOL;
			else if(type == Constants.TYPE_KEYWORD)
				return ActionEntityType.KEYWORD;
		 },

		updateContentSelectVisibility: function() {
            var header = this.getHeader();
            if (header && header.useDualContents && this._headerTabOrientation == 'horizontal') {
				dojo.style(this._header.contentSelectorNode, "display", (this.isNew() ? "none" : "inline"));
			}
		},
        
        updateHeader: function() {
            var header = this.getHeader();
            if (header) {         
                var artifact = this.getArtifact();       
                header.setTitle(this.getHeaderTitle());                
                header.setSubTitle(this.getHeaderSubTitle());
                if(artifact && artifact.id)
                	this._header.setID(artifact.id);
                // If a template change has occurred, preserve the already typed description, if any
                if(this.previousDescription && this.templateChanged){
                	if(this.isSupportSummary()){
                		header.setSummary(this.previousDescription);
                	}
                	this.previousDescription = null;
                }
                else{
                	if(this.isSupportSummary()){
                		header.setSummary(artifact ? (artifact.description ? artifact.description : (artifact.summary ? artifact.summary : "")) : "");
                	}
                }
                    
				if (!this.isNew() && this._templateSelectContainer) {
					dojo.addClass(this._templateSelectContainer, "hidden");
				}
				this._updateLockAction();
				 // if the user doesn't have permission to edit,
	            // put up a warning in the header to give the user
	            // a heads up.
	            if(!this.isRolePermitsEdit()) {	            	
	                var text = Constants.getCommonMessage("statusNoEditPerm");
	                var details = Constants.getCommonMessage("msgNoEditPermDetails", Constants.getArtifactTypeLabel(this.getArtifactType()));
	                this._header.setStatus(text, ViewHeaderLayout.WARNING, details);    
	            }
	            
				this.updateContentSelectVisibility();
            }             
        },
		
        _updateLockAction: function() {
			if (!this.getArtifactModel().isLockSupported() || !this._lockButton || this.isPrintView() || this.isSnapshot()) {
				return;
			}
			var artifactType = this.getArtifactType();
			ConstraintsUtil.isConstraintEnabled(ConstraintsUtil.RestrictSave, artifactType, this.getTeamAreaItemId(), 
					dojo.hitch(this, function(isConstraintEnabled) {
						
				this._lockButton.addClass("hidden");
				if (Utility.isTeamAreaEnabled()) {
				    this._lockButton.removeClass("hidden");
				}
				
	            //display the lock button if user has proper permissions to lock/unlock
				var artifact = this.getArtifact();
	            if (artifact) {    // Locking is enabled
	              	var contributor = null;
					var type = null;
					var lockedByMe = null;
	            	if (artifact.locked == true) {   // get info if it is locked
	               	   	contributor = EditorUtil.getCurrentContributor();
						type = Constants.getArtifactTypeLabel(this.getArtifactType());
						lockedByMe = contributor.itemId == artifact.modifiedBy.itemId;
					}           	
	            	if (this.isRolePermitsLock() || this.isRolePermitsUnlock()) {
						if (artifact.locked != true) {
							if (this.isRolePermitsLock()) {  // not locked and user may lock 
						    	this._lockButton.removeClass("hidden");
							    this._lockButton.setLabel(Constants.getMessage("labelLock"));
							} 
						} else {
							if (this.isRolePermitsUnlock()) { // is locked and user may unlock
								this._lockButton.removeClass("hidden");
								this._lockButton.setLabel(Constants.getMessage("labelUnlock"));
	       			   	        this.getHeader().setStatus(Constants.getMessage("msgLocked", type), ViewHeaderLayout.INFO, 
	                     				    Constants.getMessage(lockedByMe ? "msgLockedByMe" : "msgLockedByOther" , type, artifact.modifiedBy.name));
	                     	} else {  // locked and user may not unlock
	                     		// just display that its locked
	                     		this.getHeader().setStatus(Constants.getMessage("msgLocked", type), ViewHeaderLayout.INFO, 
	                           				Constants.getMessage("msgLockedByOther", type, artifact.modifiedBy.name));
	                        }
	              		}
						//disable lockButton when the artifact is archived
        				this._lockButton.setDisabled(this.isArchived() || this.isPurged());
	                } else {  // user does not have permission
	                    if (artifact.locked == true) {  // and it is locked
							// just display that its locked
	                    	this.getHeader().setStatus(Constants.getMessage("msgLocked", type), ViewHeaderLayout.INFO, 
	                             Constants.getMessage("msgLockedByOther", type, artifact.modifiedBy.name));
	                    }					
	                }
	            }
			}));	
		},		
        
        getHeader: function() {
            return this._header;
        },
        
        getHeaderTitle: function() {
            var title = "";
            var artifact = this.getArtifact(); 
			if (this.isNew() && !this.isCopy()) {
				// In case the user had selected a new Template, let's keep already typed title
				if(this.previousTitle){
					title = this.previousTitle;
					this.previousTitle = null;
				}
            } else if (artifact) {
	            if (artifact.snapshotInfo) {
					title = artifact.name + " (" + artifact.snapshotInfo.name + ")";
				} else if (artifact.archived && !artifact.purged) {
					title = artifact.name + " (" + Constants.getMessage("labelDeleted") + ")";
				} else {
					title = artifact.name;
				}
            }
            return title;
        },
        
        getHeaderSubTitle: function() {
            var subTitle = "";
            var artifact = this.getArtifact();    
            if (artifact && artifact.snapshotInfo != null) {
                subTitle = Constants.getMessage("labelArtifactSnapshot", artifact.snapshotInfo.name);
            }
            return subTitle;
        },        
		
        addHeaderButton: function(label, iconClass, onClick) {            
            var arg = {
                label: label,
                showLabel: false,
                iconClass: iconClass,
                onClick: onClick
            };
            var button = new com.ibm.asq.common.web.ui.internal.widgets.Button(arg);
            button.callback = onClick;
            button.set('disabled', false);
            this._header.getRightActionsContainer().appendChild(button.domNode);
            return button;          
        },		     
		
		addHeaderDropDownButton: function(label, iconClass, onClick, dropDown) {            
            var arg = {
                label: label,
                showLabel: false,
                iconClass: iconClass,
                dropDown: dropDown
            };
            var button = new com.ibm.asq.common.web.ui.internal.widgets.MenuButton(arg);
            button.callback = onClick;
            button.set('disabled', false);
            this._header.getRightActionsContainer().appendChild(button.domNode);
            return button;
        },
        
        setState: function(state) {
        	if (state) {
        		this._state = state;
        	}
            var stateSpan = this._stateNode = dojo.create("div", {
                className: "attributes-entry-label",
                innerHTML: LabelLoading,
                style: {
                    display: "inline-block"
                }
            });            
            var stateLabel = this._stateLabelNode = dojo.create("span",{
                innerHTML: Constants.getMessage("labelStateLabel"),
                title:Constants.getMessage("labelState")
            });
            this._stateEntry = this.getHeader().addInfoAttribute(stateLabel, stateSpan);
            
        	WorkflowInitialization.whenReady(dojo.hitch(this, function() {
        		this._doSetState(state);
        	}));
        },
        
        _doSetState: function(state) {
            var doc = document;
        	//Error check.  If we try to set the state to null then fall back to the default state.
        	//There was a bug with Chrome and IE that was causing null state.  This handles any more olf those types of bugs
        	if (state == null || state == "") {
        		state = this.getInitialStateId();
        	}
        		
			this._stateValue = state;
			this.previousState = this.getStateValue();
            
			this._state = WorkflowManager.getStateNameById(state, this.getArtifactType());
			
			if (!this.isSaveableState()) {
				this.setHeaderStatus(Constants.CONSTRAINT_WARNING, Constants.HEADER_STATUS_WARNING, Constants.getMessage("labelConstraintDescription1"));
			}
            
            // clear the temporary state node and start filling in the content
            this._stateNode.innerHTML = "";

            this._stateIcon = dojo.create("span", {
                className: "dijitInline",
                style: {
                    height: "16px",
                    width: "16px",
                    marginRight: "5px"
                }
            });
            this.updateWorkflowIconNode(this._stateIcon, WorkflowManager.getStateIconById(state, this.getArtifactType()));
            this._stateTxt = doc.createTextNode(this._state);
            
            var stateSpan = this._stateNode;
            stateSpan.appendChild(this._stateIcon);
            stateSpan.appendChild(this._stateTxt);
            stateSpan.setAttribute("title", "");
            stateSpan.setAttribute("tabindex","-1");

            // If not read only, create the change state action combo
			if (!this.isReadOnly() && this.isRolePermitsEdit()) {				
                stateSpan.setAttribute("id", "change-state");
                
                //Create the actions label
                var actionLabel = doc.createElement("label");
                actionLabel.setAttribute("for", "action-select");
                actionLabel.innerHTML = Constants.getMessage("LabelAction");
                actionLabel.className = "attributes-entry-label";
                
                var actionLabelLine = dojo.create('div', {
                    style: {
                        minWidth: '62px'
                    }
                });
                this._actionIcon = dojo.create("span", {
                    className: "dijitInline",
                    style: {
                        height: "16px",
                        width: "16px",
                        minWidth: "16px"
                    }
                });
                this.updateWorkflowIconNode(this._actionIcon, null, true);
                
                dojo.place(this._actionIcon, actionLabelLine);
                dojo.place(actionLabel, actionLabelLine);

                //Create the actions combo box
                this._action = doc.createElement("select");
                this._action.id = "action-select";
                this._action.name = "action-select";
                
                this._actionApplied = null;
                
                //Add the change handler.
                //The handler will need to update the state field and reload the combo box based on the actions available in the new current state
                this.connect(this._action, "onchange", "_onActionChange");
                
                //Add the combo box to the ui
                var attributeEntry = this.getHeader().appendToExistingInfoAttribute(this._stateEntry, actionLabelLine, this._action);
                this._loadWorkflowActions(state, dojo.hitch(this, "setActions"));

                if (this._restoreStateAfterReload){
                    this._doChangeState(state, this._restoreStateAfterReload);
                    this._restoreStateAfterReload = null;
                }
                
			}
        },
		
		setPriority: function(priority){
            this._priorityValue = priority;
            var priorityNode = this._priorityNode = dojo.create("span", {
                className: "attributes-entry-label",
                innerHTML: LabelLoading,
                style: {
                    display: "inline-block"
                }
            });
            var label = this._priorityLabelNode = dojo.create('div', {
                innerHTML: Constants.getMessage("labelPriorityAttribute"),
                style: {
                    'display': 'inline-block',
                    'width': '100%'
                }
            });
            this._priorityEntry = this.getHeader().addInfoAttribute(label, priorityNode);
            
            ArtifactPriorities.initializePriorities(dojo.hitch(this, "_setPriority"));
        },
        
		_setPriority: function(){
            if (this.isClosing()) {
                // do nothing if the editor is closing
                return;
            }
            var doc = document;
            if (!this._priorityValue) {
                this._priorityValue = ArtifactPriorities.getDefaultPriority(ArtifactPriorities.Priorities);
            }
            
            // remove the temporary loading label span entirely, and add
            // new content into it. Just use the parent node as our container.
            var priorityNode = this._priorityNode.parentNode;
            var labelSpan = this._priorityLabelNode;
            
            priorityNode.innerHTML = "";
            labelSpan.innerHTML = "";
            
            // No pre-existing priority
            if (!this._priorityValue) {
                return;
            }
                        
            var priorityLabel = doc.createElement("label");
            // float right icon img might overlap with the label span, add blank chars at the end of the span to reserve room
            priorityLabel.innerHTML = Constants.getMessage("labelPriorityAttribute") + "&nbsp; &nbsp; &nbsp;";
            
            this._priorityImage = dojo.create('img', {
                src: ArtifactPriorities.getPriorityIconUri(this._priorityValue.icon),
                alt: "",
                title: "",
                className: "attributes-entry-label",
                style: {
                    'float': 'right',
                    'marginRight': '1px',
                    'marginTop': '5px'
                }
            });
            dojo.place(this._priorityImage, labelSpan);
            dojo.place(priorityLabel, labelSpan);
            
            ConstraintsUtil.loadConstraints(this.getArtifactType(), this.getTeamAreaItemId(), dojo.hitch(this, function() {
	            if (this.isReadOnly() || !this.isRolePermitsEdit() || !this.isSaveableState()) {
	                this._priorityTxt = doc.createTextNode(this._priorityValue.name);
	                dojo.place(this._priorityTxt, priorityNode);
	            }
	            else {
	                //If not read only, create the action combo now so it stays
	                //next to the state text field in the ui
	                
	                //Create the actions label
	                priorityLabel.setAttribute("for", "priority-select");
	                
	                //Create the actions combo box
					this._prioritySelectNode = dojo.create("span", {
		                className: "attributes-entry-value"
		            });
					dojo.place(this._prioritySelectNode, priorityNode);
	                this._priority = doc.createElement("select");
	                this._priority.tabIndex = "0";
	                this._priority.id = "priority-select";
	                this._priority.name = "priority-select";
	                
	                //Add the change handler.
	                //The handler will need to update the state field and reload the combo box based on the actions available in the new current state
	                this.connect(this._priority, "onchange", "_onPriorityChange");
	                
	                var artifactPriorities = ArtifactPriorities.Priorities;
	                var found = false;
	                if (artifactPriorities) {
	                    for (var i = 0; i < artifactPriorities.length; i++) {
	                        var option = new Option(artifactPriorities[i].name, artifactPriorities[i].id);
	                        SelectUtility.add(this._priority, option);
	                        if (this._priorityValue && this._priorityValue.id == artifactPriorities[i].id) {
	                            option.selected = true;
	                            found = true;
	                        }
	                    }
	                }
	                
	                if (found == false) {
						setTimeout(dojo.hitch(this, function() {
							var oldPriority = this._priorityValue;
							this._priorityValue = ArtifactPriorities.getDefaultPriority(artifactPriorities);
							SelectUtility.select(this._priority, this._priorityValue.id);
							this._priorityImage.src =  ArtifactPriorities.getPriorityIconUri(this._priorityValue.icon);
							this._priorityImage.alt = "";
							this._priorityImage.title = "";
							this.setDirty(true);
				            var header = this.getHeader();
				            if (header) {
				            	header.setStatus(Constants.getMessage("labelInvalidPriorityUpdatedTitle"), ViewHeaderLayout.INFO, 
				            			Constants.getMessage("labelInvalidPriorityUpdated", oldPriority.id, this._priorityValue.id));
				            } else {
				            	// Wait for the header to be present and set the status
				            	var handle = dojo.connect(this, "createHeader", dojo.hitch(this, function() {
				            		dojo.disconnect(handle);
				            		this.getHeader().setStatus(Constants.getMessage("labelInvalidPriorityUpdatedTitle"), ViewHeaderLayout.INFO, 
				            				Constants.getMessage("labelInvalidPriorityUpdated", oldPriority.id, this._priorityValue.id));
				            	}));
				            }
							
						}, 250));
	                    
	                }
					dojo.place(this._priority, this._prioritySelectNode);             	
	            }
	        }), /* optional, projectArea */null, /* useCache */true);
        },
		
		_onPriorityChange: function(){
			var selection = null;
			var combo = this._priority;
			var len = combo.options.length;
			for(var i=0;i<len; i++){
				if(combo.options[i].selected){
					selection = combo.options[i];
					break;
				}	 
			}
			if (selection != null) {				
				var priority = ArtifactPriorities.getPriorityById(ArtifactPriorities.Priorities, selection.value);
				this._priorityValue = priority;
				this._priorityImage.src =  ArtifactPriorities.getPriorityIconUri(priority.icon);
				this._priorityImage.alt = "";
				this._priorityImage.title = "";				
			}
			this.localEditorDirty = true;
			this.setDirty(true);
		},
		
		getPriority:function() {
			if(!this._priorityValue){
				return ArtifactPriorities.getDefaultPriority(ArtifactPriorities.Priorities);
			}
			return this._priorityValue;
		},
        
        getState: function() {
            return this._state;  
        },
        
        getStateValue: function() {
            return this._stateValue;
        },
		
		getActionValue: function()
		{
            if (this._action!=null) {
				return this._action.value;
            }
            return "NULL";
		},
		
		setActions: function() {
			// Load the actions combo box with the appropriate actions
			// The actions are based on the current state so pass that into the method
			
			var select = this._action;
			dojo.empty(select);
			
			// Add the select action prompt
			var option = dojo.create("option", {
				style: {
					color: "gray"
				},
				innerHTML: Constants.getMessage("labelChangeStateTitle"), 
				value: "NULL"
			});
			select.appendChild(option);
			
			dojo.forEach(this._workflowActions, dojo.hitch(this, function(action) {
				var option = dojo.create("option", {
					innerHTML: action.name,
					value: action.id
				});
				select.appendChild(option);
			}));
			
			this.updateSaveable();			
		},
		
		_onActionChange: function() {
			var action = this.getActionValue();
			var state = this.getArtifact() == null ? this.getInitialStateId() : this.getArtifact().state;
			if (this._actionIcon) {
				this.updateWorkflowIconNode(this._actionIcon, WorkflowManager.getActionIconById(action, this.getArtifactType()), true);
			}
			this._loadWorkflowActions(state, dojo.hitch(this, function() {
				this._changeState(state, action);
			}));
		},
		
		_changeState: function(currentState, action) {
			WorkflowInitialization.whenReady(dojo.hitch(this, function() {
				this._doChangeState(currentState, action);
			}));
		},
		
		_doChangeState: function(currentState, action) {
			
			// If the user selected the change state prompt then just return
			// This should not happen since we remove the state change prompt below
			if (action == "NULL") {
				return;
			}
 
			var firstTimeStateChanged = !this.getStateChanged();
			
			// Remember that we have changed state.
			// This used to help decide whether the save button should be enabled
			this.setStateChanged(true, action);
			
			// Do change stuff like marking the artifact as dirty
			this._onChange();
			
			// Update the save and discard buttons.
			this.updateSaveable();
			
			// If the action is to return to the previous state	
			var actionLen = this._action.length;
			if (action == currentState) {
				// Remove the "Return to State" Action				
				for (var i = 0; i < actionLen; i++)
					if (this._action.options[i].value == currentState) {
						this._action.remove(i);
						break;
					}				

				// add "select action" and select it
				var option = new Option(Constants.getMessage("labelChangeStateTitle"), "NULL");  
				option.style.color = "gray";
				SelectUtility.add(this._action, option);
				SelectUtility.select(this._action, "NULL");
				
				// Set the state to be the previous state
				this._stateValue = currentState;
				// Remove the action applied
				this._actionApplied = null;
			} else {  
				// A "real" action other than return to previous state
				// remove "select action" if needed
				for (var i = 0; i < actionLen; i++) {
					if (this._action.options[i].value == "NULL") {
						this._action.remove(i);
						break;
					}
				}
				
				// add "return to <last state>" if needed
				if (this._action.options[this._action.options.length - 1].value != currentState) {
					var option = new Option(Constants.getMessage("com.ibm.rqm.planning.common.return", WorkflowManager.getStateNameById(this._stateValue, this.getArtifactType())), this._stateValue);
					SelectUtility.add(this._action, option);
				}				
				
				//Determine the next state to show in the artifact
				this.previousState = this.getStateValue();

				var actionDefinition = WorkflowManager.getActionById(action, this.getArtifactType());
				this._stateValue = actionDefinition.state;

                // if we were in non-edit mode due to the contraint when approved or retired
                // we need to check to put the editor back to editable mode.
				if (firstTimeStateChanged && 
				    ConstraintsUtil.isConstraintEnabled(ConstraintsUtil.RestrictSave, this.getArtifactType(), this.getTeamAreaItemId()) &&
				    WorkflowManager.stateBelongsToApprovedOrRetired(currentState, this.getArtifactType())) {
				    // if the new state being changed DON'T belong to one of the constraint states, we need
				    // to re-enable the edit mode of the editor.
				    if ((!WorkflowManager.stateBelongsToApprovedOrRetired(actionDefinition.state, this.getArtifactType())) && this.loadArtifact) {
	                    this.loadArtifact(); // async load
	                    this._restoreStateAfterReload = action;
	                }
	            }
			}
 
 			// Update next state
            this._stateTxt.nodeValue = WorkflowManager.getStateNameById(this._stateValue, this.getArtifactType());
            this.updateWorkflowIconNode(this._stateIcon, WorkflowManager.getStateIconById(this._stateValue, this.getArtifactType()));
            
		},
		
		//Load the new actions based on the current state
        _updateState: function()
        {
            //Reload the combo box with the actions for this new state
			if (!this.isReadOnly()) {
				this._loadWorkflowActions(this.getStateValue());
			}
        },
        
		_resetActionCombo: function()
		{
			this._action.options[0].selected = true;
		},		
		
        setOriginator: function(originator) {
			//always set the originator as the current contributor if its a copy. defect 26529
            if ((originator == null && this.isNew() )|| this.isCopy()) {
                originator = EditorUtil.getCurrentContributor().name;
            }
						
            var originatorlabel = document.createElement("span");
            originatorlabel.innerHTML = Constants.getMessage("labeloriginatorLabel");
            
            this._originator = document.createTextNode(originator);
            this._originatorContainer = this.getHeader().addInfoAttribute(originatorlabel, this._originator);
        },
        
        getOriginator: function() {
            return this._originator;  
        },
        
        getOriginatorValue: function() {
            return this._originator.textContent;  
        },
        
        /* 
         * Expected input differs depending on the editor mode.
         *   if readOnly mode --> Display String expected
         *   if edit mode --> itemId of contributor expected
         */           
        setOwner: function(owner) {        
            var ownerlabel = document.createElement("label");
            ownerlabel.innerHTML = Constants.getMessage("labelowner");
			
            
            if (this.isReadOnly() || !this.isSaveableState()) {
                this._owner = document.createElement("span");
				this._owner.innerHTML = owner;
				this._owner.id=this.id+"_ownerValue_";
            } else {
				//create new contributor selection widget
				this._owner = new ContributorSelect({
					defaultValue: owner || null,
					onValueChanged: dojo.hitch(this, "_onChange")
				});
            }
            ownerlabel.setAttribute("for", this._owner.id);
            if (this._originatorContainer) {
                this.getHeader().appendToExistingInfoAttribute(this._originatorContainer, ownerlabel, this._owner);
            }
            else {
                this.getHeader().addInfoAttribute( ownerlabel, this._owner);
            }
        },
        
        setOwnerValue: function(owner) {
        	var _owner = this._owner;
        	if (_owner instanceof ContributorSelect) {
        		_owner._setInitialValue([owner]);
        	} else {
        		_owner.domNode.innerHTML = owner.name;
        	}
        },
		
        setTeamArea: function(teamArea) {
            if (this.isClosing()) {
                // do nothing if the editor is closing
                return;
            }
    		if (Utility.isIterationSupportActivated()) {
        		if (!this.teamAreaSelector) {
        			this.teamAreaSelector = new com.ibm.asq.common.web.ui.internal.widgets.TeamAreaSelector({ 
        				teamAreaItemId: teamArea,
        				_compositeDTO: this._compositeDTO,
        				onValueChanged: dojo.hitch(this, "onTeamAreaChanged")
        			});
        			var teamAreaSelector = this.teamAreaSelector;
        			var label = document.createElement("label");			
        			label.innerHTML = Constants.getMessage("fieldLabelTeamArea");
        			
        			var node = dojo.create("div");
        			
        			// By default show the read only widget, once and if we know it's editable, we'll change it
        			var readOnlyWidget = teamAreaSelector.getReadOnlyWidget();
        			label.setAttribute("for", readOnlyWidget.id);
        			node.appendChild(readOnlyWidget);
        			
        			if (Utility.isTeamAreaEnabled()) {
        				this.getHeader().addInfoAttribute(label, node);
        			        			
	        			ConstraintsUtil.loadConstraints(this.getArtifactType(), teamArea, dojo.hitch(this, function() {
	        				// Neither read only nor unsaveable state (e.g. Approved with Constraint enabled)
	            			if (!this.isReadOnly() && this.isSaveableState()) {
	            				node.removeChild(readOnlyWidget);
	            				node.appendChild(teamAreaSelector.domNode);
	            				label.setAttribute("for", teamAreaSelector.id);
	            			}
	                	}), /* projectArea */null, /* useCache */true);
        			}
        		} else {
        			this.teamAreaSelector.setSelected(teamArea);
        			ConstraintsUtil.loadConstraints(this.getArtifactType(), teamArea, /* callback */null, /* projectArea */null, /* useCache */true);
        		}
    		} else {
    			ConstraintsUtil.loadConstraints(this.getArtifactType(), teamArea, /* callback */null, /* projectArea */null, /* useCache */true);
    		}
			ExecutionConstraintUtil.loadConstraints(this.getArtifactType(), teamArea, /* callback */ null, /* projectArea */ null, /* useCache*/ true);
            if (this._approvalSection){
                this._approvalSection.refreshConstraints(teamArea);                
            }
        },
                        	
        onTeamAreaChanged:function(newValue, oldValue){
        	this.setDirty(true);
        	this.localEditorDirty = true;
        	ConstraintsUtil.loadConstraints(this.getArtifactType(), newValue);
			ExecutionConstraintUtil.loadConstraints(this.getArtifactType(), newValue);
            if (this._approvalSection){
                this._approvalSection.refreshConstraints(newValue);                
            }
        	var action = this.isNew() ? PermissionsClient.ACTION_CREATE : PermissionsClient.ACTION_EDIT;
        	var args = {
        		operationId: this.mapArtifactTypeToOperationId(this.getArtifactType()),
        		processArea: this.getTeamAreaItemId(),
        		action: action
        	};
        	var handler = {
				success: dojo.hitch(this, function(permissions) {
					if (!permissions[action]) {
						this.getHeader().setStatus(Constants.getMessage("labelTeamAreaPermissionsNotGranted", this.getTeamAreaName()), 
								ViewHeaderLayout.WARNING);
						this._hasTeamAreaPermissionsError = true;
					} else if (this._hasTeamAreaPermissionsError) {
						this._hasTeamAreaPermissionsError = false;
						this.getHeader().clearStatus();
					}
				}),
				failure: dojo.hitch(this, function(error) {
					console.error("Unable to load permissions");
				})
			};
			
			var responseHandler = new ServiceResponseHandler(handler, "success", "failure");
        	PermissionsClient.checkPermissions(responseHandler, args);
        },
        
        getTeamAreaName: function() {
        	if(com.ibm.team.repository.web.client.init.InitializationData.get("teamarea.enabled") && this.teamAreaSelector){
       			return this.teamAreaSelector.getSelectLabel();
        	} else {
        		return "";
        	}
        },
       
        getTeamAreaItemId:function(){
        	if(com.ibm.team.repository.web.client.init.InitializationData.get("teamarea.enabled")){
        		var val;
        		if(this.teamAreaSelector){
        			val = this.teamAreaSelector.getSelectValue(); 
        		}
        		return (val && val!="Unassigned")?val:null;}  
        	else{
        		return "";
        	}
        },
        
		setOwnerVisible: function(visible) {
			var node = this._owner instanceof ContributorSelect ? this._owner.domNode : this._owner;
			if (node != null) {
				dojo.style(node.parentNode, "display", (visible === true ? "inline" : "none"));
			}
		},
        
        getOwner: function() {
            return this._owner;  
        },
       
        getOwnerValue: function() {
        	var owner = this._owner;
        	return owner instanceof ContributorSelect ? owner.getSelectedValue().itemId : this.getArtifact().owner.itemId;
        },
        
        setLastSaved: function(status, error) {   
            var st_code = -1; // none, no status icon
            var text = "";
            var detail_msg = null;
            
         
			switch(status) {				
	            case Constants.STATUS_SUCCESS: 
	                st_code = ViewHeaderLayout.SUCCESS;
	                text = Constants.getCommonMessage("statusSaveSuccess", EditorUtil.getTimeString());
					break;  
                case Constants.STATUS_FAILURE:
	                st_code = ViewHeaderLayout.ERROR;
	                text = (error && error.message) ? error.message : Constants.getCommonMessage("statusSaveFail", EditorUtil.getTimeString());
					break;
                case Constants.STATUS_SAVING:
	                st_code = ViewHeaderLayout.INFO;
	                text = Constants.getCommonMessage("statusSaving");
		            break;
	            case Constants.STATUS_NEW:
	                st_code = ViewHeaderLayout.INFO;
	                text = Constants.getCommonMessage("statusNewNeedSave");
                    break;	               
	            case Constants.STATUS_DIRTY:
	                st_code = ViewHeaderLayout.INFO;
	                text = Constants.getCommonMessage("statusDirty");
                    break;
                case Constants.STATUS_NOT_NECESSARY:
                    st_code = ViewHeaderLayout.SUCCESS;
                    text = Constants.getCommonMessage("statusSaveNotNecessary");
                    break;									                   
			}
            
            if(st_code > -1)
                this.getHeader().setStatus(text.replace(/\n/g, "<br />"), st_code, detail_msg);
            else
                this.getHeader().clearStatus();
        },
		
        updateSaveable: function(formalReviewSaveable) {
            if (this._saveButton) {
				var disabled = (!this._isSaveable() || this.isArchived() || this.isPurged()) && !formalReviewSaveable;
				if (this._prevSaveDisabled != disabled) {
					this._saveButton.setDisabled(disabled);
					this._prevSaveDisabled = disabled;
				}
            }	
            if (this._cancelButton) {
				var disabled = ((!this.isNew() && !this._isDiscardable()) || this.isArchived() || this.isPurged()) && !formalReviewSaveable || this.isReadOnly();
				if (this._prevCancelDisabled != disabled) {
					this._cancelButton.setDisabled(disabled);
					this._prevCancelDisabled = disabled;
				}
            }
			
			if(this._duplicateButton){	
				var disabled = (this.isSaving() || this.isLoading() || this.isNew() || this._isSaveable() || this.isArchived() || this.isPurged());
				if (this._prevDuplicateDisabled != disabled) {
					this._duplicateButton.setDisabled(disabled);
					this._prevDuplicateDisabled = disabled;
				}
			}			
			if (this._printButton) {
				var disabled = (this.isSaving() || this.isLoading() || this.isNew() || this.isArchived() || this.isPurged());
				if (this._prevPrintDisabled != disabled) {
					this._printButton.setDisabled(disabled);
					this._prevPrintDisabled = disabled;
				}
			}		
			if (this._pdfButton) {
				var disabled = (this.isSaving() || this.isLoading() || this.isNew() || this._isSaveable() || this.isArchived() || this.isPurged());
				if (this._prevPdfDisabled != disabled || this.isArchived() || this.isPurged()) { //disable pdf button for deleted elements
					this._pdfButton.setDisabled(disabled);
					this._prevPdfDisabled = disabled;
				}
			}
            if(this._refreshButton) {
                var disabled = (this.isSaving() || this.isLoading() || this.isNew());
                this._refreshButton.setDisabled(disabled);
            }
        },		
		
		_isSaveable: function() {
			//once dirty detection is fully implemented, this should check this.isDirty()
			//to disallow saves of non-dirty items for editors using save context (see RQM WorkItem #5222)
			if (this.getSaveContext() != null && !this.isDirty()) {
                return false;			 	
			}
			var canEdit = (this.isRolePermitsEdit() && !this.isReadOnly()) || this._hasEditableSections();
			var saveable = (canEdit && !this.isSaving() && !this.isLoading() && this.isSaveableState() && !this.isArchived() && !this.isPurged());
			//console.debug(this.declaredClass + ": _isSaveable: canEdit: " + canEdit + "; saveable: " + saveable);
			return saveable; 
			
		},
		
		_isDiscardable: function() {
			if (this.getSaveContext() != null && !this.isDirty()) {
                return false;			 	
			}
			var canEdit = (this.isRolePermitsEdit() && !this.isReadOnly() && !this.isArchived() && !this.isPurged()) || this._hasEditableSections();
			var discardable = (canEdit && !this.isSaving() && !this.isLoading());
			return discardable;
		},
		
		_hasEditableSections: function() {
			var sections = this.getSections() || []; 
			var secLen = sections.length;
            for (var i = 0; i < secLen; i++) {
               	if (sections[i].isEditable()) {
					return true;
			   	}
            }
			return false;	
		},
        ////////////////////////////////////////////////////////////////////////////////////////////////////
        //                                   EDITOR VIEW HEADER INTERNAL                                  //
        ////////////////////////////////////////////////////////////////////////////////////////////////////        
        _contentSelected: function() {
            if (this._pdfButton) {
                this._pdfButton.removeClass("hidden");
            }
            if (this._pdfHistoryButton) {
                this._pdfHistoryButton.addClass("hidden");
            }    
			if(this._duplicateButton){
				this._duplicateButton.removeClass("hidden");
			}
            if (this._printButton) {
                this._printButton.removeClass("hidden");
            }
            if (this._saveButton && this._cancelButton) {
                this._saveButton.removeClass("hidden");
                this._cancelButton.removeClass("hidden");
            }
            if (this._refreshButton) {                
                this._refreshButton.removeClass("hidden");
            }            
            if (this._currentRevisionButton) {
                this._currentRevisionButton.removeClass("hidden");
            }
            if (this._snapshotButton) {                
                this._snapshotButton.addClass("hidden");
            }            
            this._updateLockAction();
			var _dojo = dojo;
            //show the infoNode if necessary    
             this.getHeader().showInfoAttributesNode(true);                    

            //show the summaryNode if necessary   
            var summaryNode = this.getHeader().getSummaryNode();
            if (summaryNode) {
                dojo.style(summaryNode, "display", "");
            }
			//show the table of contents if necessary
			if (this._headerTabOrientation == "horizontal" && this._tableOfContentsNode && _dojo.hasClass(this._tableOfContentsNode, "hidden"))      
				_dojo.removeClass(this._tableOfContentsNode, "hidden");
			
			// restore cshelp id that was temporarily replaced
			// by snapshot help id
			var originalCSHelpId = this.getCSHelpId();
			this.setCSHelpId(originalCSHelpId);
            
            // restore the no edit permisssion status.
            if(!this.isRolePermitsEdit()) {
                var text = Constants.getCommonMessage("statusNoEditPerm");
                var details = Constants.getCommonMessage("msgNoEditPermDetails", Constants.getArtifactTypeLabel(this.getArtifactType()));
                this._header.setStatus(text, ViewHeaderLayout.WARNING, details);    
            }
            else if(!this.isRolePermitsArchive()) {
                this._header.clearStatus();
            }      

            var currentSection = this.getSelectedSection();
            if (currentSection) {
            	for (var i = 0; i < this._sections.length; i++) {
            		var section = this._sections[i];
            		if (section._section.id == currentSection) {
            			section.onActivated();
            			break;
            		}
            	}
            }
            if (this.isArchived() || this.isPurged()) {
            	this._disableActions();
            }
        },
        
        _disableActions: function() {
        	var buttons = [
                this._pdfButton, this._pdfHistoryButton, this._duplicateButton, 
                this._printButton, this._saveButton, this._cancelButton, this._lockButton
            ];
        	dojo.forEach(buttons, function(button) {
   	    		button != null && button.setDisabled(true);
        	});
        },
        
        _snapshotsSelected: function() {
			this.refreshSnapshots();
			if(this._duplicateButton){
				this._duplicateButton.addClass("hidden");
			}
			if (this._printButton) {
                this._printButton.addClass("hidden");
            }
			if (this._pdfHistoryButton) {
                this._pdfHistoryButton.addClass("hidden");
            }    			
            if (this._pdfButton) {
                this._pdfButton.addClass("hidden");
            }
            if (this._saveButton && this._cancelButton) {
                this._saveButton.addClass("hidden");
                this._cancelButton.addClass("hidden");
            }
            if (!this.isSnapshot() && !this.isArchived() && !this.isPurged() && this._currentRevisionButton) {
                this._currentRevisionButton.addClass("hidden");
            }
			
            if (this._lockButton) {
                this._lockButton.addClass("hidden");
            }
            if (this._refreshButton) {
                this._refreshButton.addClass("hidden");
            }
						
            if (!this.isSnapshot() && this._snapshotButton) {
                this._snapshotButton.removeClass("hidden");
                               
                if(this.isDirty()){
                	this._snapshotButton.setDisabled(true);
                	var text =  Constants.getCommonMessage("msgSaveArtifactFirstSnapshots");
                    var details = text + "<br>" + Constants.getCommonMessage("msgSaveArtifactFirstSnapshotsDetail", this.getArtifactType());
                	this._header.setStatus(text, ViewHeaderLayout.WARNING, details);
                } else if (!this.isRolePermitsSnapshot()) {
                    this._snapshotButton.setDisabled(true);
                    var text = Constants.getCommonMessage("statusNoArchivePerm");
                    var details = Constants.getCommonMessage("msgNoArchivePermDetails", this.getArtifactType());
                    this._header.setStatus(text, ViewHeaderLayout.WARNING, details);    
                } else {
                	this._snapshotButton.setDisabled(false);
                	this.getHeader().clearStatus();
                }
                if (this.isArchived() || this.isPurged()) {
                	this._snapshotButton.setDisabled(true);
                } 
            } 
            //hide the infoNode if necessary
            this.getHeader().showInfoAttributesNode(false);

            //hide the summaryNode if necessary   
            var summaryNode = this.getHeader().getSummaryNode();
            if (summaryNode) {
               dojo.style(summaryNode, "display", "none");
            }
			//hide the table of contents if necessary
			if (this._headerTabOrientation == "horizontal" && this._tableOfContentsNode && !dojo.hasClass(this._tableOfContentsNode, "hidden"))      
				dojo.addClass(this._tableOfContentsNode, "hidden");

            this.getHeader().setCSHelpId("rqm_snapshots.html");
        },
       	
       	_historySelected: function(e)
       	{       		
            if (e) {
                dojo.stopEvent(e);
            }
       		if(this.refreshHistory)
       			this.refreshHistory();
       		else
       			return;       			
       		if(this._duplicateButton){
				this._duplicateButton.addClass("hidden");
			}
			if (this._printButton) {
                this._printButton.addClass("hidden");
            }
            if (this._pdfButton) {
                this._pdfButton.addClass("hidden");
            }
            if (this._pdfHistoryButton) {
                this._pdfHistoryButton.removeClass("hidden");
            }			
            if (this._saveButton && this._cancelButton) {
                this._saveButton.addClass("hidden");
                this._cancelButton.addClass("hidden");
            }
            if (!this.isSnapshot() && !this.isArchived() && !this.isPurged() && this._currentRevisionButton) {
                this._currentRevisionButton.addClass("hidden");
            }
			
            if (this._lockButton) {
                this._lockButton.addClass("hidden");
            }
            if (this._snapshotButton) {                
                this._snapshotButton.addClass("hidden");
            }
            if (this._refreshButton) {
                this._refreshButton.addClass("hidden");
            }
            
            // hide the attributes area
            this.getHeader().showInfoAttributesNode(false);

            //hide the summaryNode if necessary   
            var summaryNode = this.getHeader().getSummaryNode();
            if (summaryNode) {
                dojo.style(summaryNode, "display", "none");
            }
			//hide the table of contents if necessary
			if (this._headerTabOrientation == "horizontal" && this._tableOfContentsNode && !dojo.hasClass(this._tableOfContentsNode, "hidden"))      
				dojo.addClass(this._tableOfContentsNode, "hidden");

			this.getHeader().setCSHelpId("rqm_view_history.html");
			
			if (this.isArchived() || this.isPurged()) {
            	this._disableActions();
            }
       	},
       	
       	
       	refreshHistory: function()
		{			
			if(!this._historyMainPanel){						
			   	this._historyMainPanel =  new HistoryPane(
	           	{	           	    
	           		itemId: (this._artifact && this._artifact.versionableItemId)?this._artifact.versionableItemId:this.versionableItemId?this.versionableItemId:"",
	           		itemType: this.artifactType,  
	           		itemNameSpace:  this.itemNameSpace  
	           	});
	           	this._historyNode.appendChild(this._historyMainPanel.domNode);
           	}
           this._historyMainPanel.refreshHistory();
		},		
       	                     
        ////////////////////////////////////////////////////////////////////////////////////////////////////
        //                                   PLUGGABLE SECTION SUPPORT                                    //
        ////////////////////////////////////////////////////////////////////////////////////////////////////
        getSections: function(){
            return this._sections;
        },
        
        getSection: function(id) {
			var secLen = this._sections ? this._sections.length : 0;
            for (var i = 0; i < secLen; i++) {
				var s = this._sections[i];
                if (s.getConfig().id == id) return s;
                
            }
            return null;
        },
        
		blockSection: function(id) {
			//prevents a section from being added via 'manage sections'
			this._sectionsBlocked.push(id);
		},
		
		unblockSection: function(id) {
			//removes a section from the blocked list
			var len = this._sectionsBlocked.length;
			for (var i = 0; i < len; i++) {
				var secId = this._sectionsBlocked[i];
				if (secId == id) {
					this._sectionsBlocked.splice(i, 1);
					return;
				}
			}
		},	
		
		isBlocked: function(sectionId) {
			return this._containsValue(this._sectionsBlocked, sectionId);		
		},
        
        getSectionGroup: function(id) {
			var secLen = this._sections ? this._sections.length : 0;
            for (var i = 0; i < secLen; i++) {
				var s = this._sections[i];
                var config = s.getConfig();
                if (config.sections && config.id == id) {
                    return s;
                }
            }
            return null;
        },              
        
        loadSections: function(/* REQUIRED */ sectionsNode){
            if (this.isClosing()) {
                // just set load completed if the editor is closing
                this.contentLoadCompleted();
                return;
            }
			// save the sections
			this._sectionsNode = sectionsNode;

            if (this.getTemplate() != null) {
				this._loadSectionModules();
			
			} else {			
				if (this._editorConfig.isTemplated) {
				//get the template for this artifact
				this._getTemplatedComplete = false;
				var self = this;
				var handler = {
					success: function(template){
							self._loadedDefaultTemplate(template);
					},
					failure: function(e){
						console.error("Unable to load template: (" + self.getTemplateId() + ")");
                        self._getTemplatedComplete = true;
                        self.contentLoadCompleted();
					}
				};
				
				//get the specified template, or the default template if none specified
				var srh = new ServiceResponseHandler(handler, "success", "failure");
				if (!this.getTemplateId()) {
					if (this._compositeDTO) {
						this._loadedDefaultTemplate(this._compositeDTO.defaultTemplate);
					} else {
						TemplateClient.getDefaultTemplate(srh, this.getEditorId());
					}
				} else {
					if(this.artifactCompositeDTO){
						this._loadedDefaultTemplate(this.artifactCompositeDTO.template);
					} else {
						TemplateClient.getTemplate(srh, {itemId: this.getTemplateId()});
					}
				}
				} else {
					// NOT templated
					this._getTemplatedComplete = true;
					this._loadSectionsComplete = false;
					this._loadSectionModules();
				}
			}
			
        },		
        _loadedDefaultTemplate: function(template) {
            if (!this.isClosing()) {
                //set the template, and then display sections if the editor is not closing
                this._getTemplatedComplete = true;
                this._loadSectionsComplete = false;
                this.setTemplate(template);
                this._loadSectionModules();
            }
        },
		
        _loadOneModule: function(module, callback, modulesToLoad){
            try {
                jazz.core.loader.load_async(module, callback);
                console.debug("===> Loading " + module);
            } 
            catch (e) {
                // call the callback on error to keep count for continuing the display
                this._oneModuleLoaded(modulesToLoad);
            }   
        },
        
		_loadSectionModules: function() {
            var editorSections = this._editorSections;            
            if (this._sectionsLoaded) {
                //sections have already been loaded, just show them
                this._displaySections();
                this._loadSectionsComplete = true;
                this.contentLoadCompleted();
            } else {
                //dynamically load contributed section widgets
                var modulesToLoad = [];
				var secLen = editorSections.length;
                for (var i = 0; i < secLen; i++) {
                    var jsClass = editorSections[i].jsClass;
					if (jsClass && dojo.getObject(jsClass) == null) {
                        modulesToLoad.push(jsClass);
                    }
                }
                
                // edge case, make sure js classes for the sections in the template are all loaded
                var template = this.getTemplate();
                if (template) {
                    var sections = template.sections;
                    for (var j = 0; j < sections.length; j++) {
                        var jsClass = sections[j].jsClass;
                        if (jsClass && dojo.getObject(jsClass) == null) {
                            // make sure it is not already included to load
                            var included = false;
                            for (var k = 0; k < modulesToLoad.length; k++) {
                                if (modulesToLoad[k] == jsClass) {
                                    included = true;
                                    break;
                                }
                            }
                            if (!included) {
                                modulesToLoad.push(jsClass);
                            }
                        }
                    }
                }
                
				if (modulesToLoad.length > 0) {
					this._loadStarted = new Date().getTime();
	                var callback = dojo.hitch(this, "_modulesLoaded", modulesToLoad);
	                jazz.core.loader.batch_load_async(modulesToLoad, callback);					
				} else {
					//console.debug(this.declaredClass + "._loadSectionModules: No section modules require loading...");
					this._displaySections();
                    this._loadSectionsComplete = true;
                    this.contentLoadCompleted();
				}
            }			
		},
		
		_modulesLoaded: function(modules) {
			//log any errors (modules that were to be loaded but are not available)
			var failures = [];
			var modLen = dojo.isArray(modules) ? modules.length : 0;
			for (var i = 0; i < modLen; i++) {
				var mod = modules[i];
				if (mod.substr(0,11)==="javascript:") {
					mod = mod.substr(11);
				}
				if (dojo.getObject(mod) == null) {
					failures.push(mod); 
				}
			}  
			//log errors or success
			if (failures.length > 0) {
				var elapsed = new Date().getTime() - this._loadStarted;
	            var message = this.declaredClass + "._modulesLoaded: ";
	            message += "Contributed module load Completed (in " + elapsed + "ms): ";
	            message += "Total/Loaded/Failed: [" + modLen + "/" + (modLen - failures.length) + "/" + failures.length + "]";
	            console.info(message);		
            }
            this._displaySections();
            this._loadSectionsComplete = true;
            this.contentLoadCompleted();
		},
        
        _displaySections: function() {                                   			   
            //create and append the section widgets to the editor           
            this.sectionDefinitions = this._getDisplayable();
            var defLen = this.sectionDefinitions ? this.sectionDefinitions.length : 0;
			
            // Ensure that we clean up any previously created sections widgets
            // before we unload them and recreate the sections.
            if (!this.isMerging() || !this.diffMergeController) {
                // We don't want to destroy the widgets if this is reinitlaized from a
                // diff/merge. The new sections might have additional entries but existing
                // one are valid. The diffMergeController will reuse the existing widgets
                // when creating the new sections.  The diffMergeController clean up.
                this.cleanUpSectionsBeforeReload();
                dojo.empty(this._sectionsNode);
            }
            
            this._sections = [];
			var isCopy = this.isCopy();       
			var sectionsNode = document.createDocumentFragment();     
			if (dojo.isIE) {
				for (var i = 0; i < defLen; i++) {
					setTimeout(dojo.hitch(this, function(sectionDef, expanded, lastOne){
						this.appendSection(sectionDef, expanded, sectionsNode);
						if (lastOne) {
							this._sectionsNode.appendChild(sectionsNode);
							this.updateTableOfContents(true);
						}
					}, this.sectionDefinitions[i], i == 0 || isCopy, i == defLen - 1), 20 * i);
				}
			}else {
				for (var i = 0; i < defLen; i++) {
            		this.appendSection(this.sectionDefinitions[i], isCopy,sectionsNode);
	            }
				this._sectionsNode.appendChild(sectionsNode);
				this.updateTableOfContents(true);
			}
			
			// init for diff/merge after the sections are setup to display
			if (this.diffMergeEnabled && this.isMerging() && this.diffMergeController) {
	            // additional init for concurrent modification
			    this._initializeStaleMerge();
			}
		},
		
		_getSectionDefinition: function(id) {
			var sectionsLen = this.sectionDefinitions ? this.sectionDefinitions.length : 0;
			for (var i = 0; i < sectionsLen; i++) {
				if (this.sectionDefinitions[i].id == id) {
					return this.sectionDefinitions[i];
				}
			}
			return null;
		},
		
		_showTOC:function(/* OPTIONAL */ tocNode){
			this._tocNode = tocNode;
			//show the table of contents, if the implementor has specified a domNode for it
			if (this._tocNode != null) {
				if (!this.getTableOfContents()) {
					this.loadTableOfContents(this._tocNode);
				} else {
					this.updateTableOfContents(true);
				}
			} else {
				//if no table of contents, must show all sections
				this.setSectionDisplayMode(true);
			}
			// create skip to TOC link
			var div = document.createElement("div");
			div.style.position = "absolute";
			div.style.display = "inline";
			div.style.visibility = "hidden";
			
			var skipToTOC = document.createElement("a");
			skipToTOC.innerHTML = "Skip to table of content";
			skipToTOC.href = "javascript:{}";
			this.connect(skipToTOC, "onclick", "_skipToTOC");
 
 			div.appendChild(skipToTOC);
			this._header.domNode.appendChild(div);
		},
		
		_skipToTOC: function()
		{
			var hrefs = dojo.query("a", this._tocWidget.domNode);
			if (hrefs.length > 0){
				dijit.focus(hrefs[0]);
			} 
		},
		
		_getDisplayable: function() {
            //which set of sections is the display based on
			var sections = [];		
			var artifact = this.getArtifact();	
			var sectionsPersisted = false;
			//for new (& not copied) artifacts or artifacts that do not contain sections, 
			//load the section defs from the template / editor config		
			var editor = this._editorConfig;
			if ((this.isNew() && !this.isCopy()) || (artifact && !artifact.sections)) {
				if (editor.isTemplated) {
					//for new arifacts, use the sections defined by the template
					var template = this.getTemplate();
					if (template) {
						// odd case - i have seen it only when i start to create a TC, then close the tab before the panel is fully painted.
						// then, the template was null.
						sections = template.sections;
					}
				} else {
					return editor.sections;
				}
			} else {
				//for existing arifacts, use the sections persisted on the artifact
				sections = artifact.sections;
				sectionsPersisted = true;
			}

            //get the definitions for each from the EditorRegistry
            var definitions = [];
			var secLen = sections ? sections.length : 0;
            for (var i = 0; i < secLen; i++) {
				var section = sections[i];
                var def = this._editorRegistry.getSection(this, section.id);
				if (def != null) {
	                if(editor.isTemplated && !sectionsPersisted) {
	                	//chage the content for static sections (name, description and CKeditor content) WI 80383
	                	def.name = section.name || def.name;
	                	def.description = section.description || def.description;
	                	def.content = section.content || def.content || "";
	                }
	                if (section.hasChicklet) {
	                    // track if the section has associated chicklet (reordered in merging) in the config 
	                    def.hasChicklet = true;
	                }
	                definitions.push(def);
				} else { 
				    //but allow for custom sections
					definitions.push(section);
				}
            }
			return definitions;
		},
       
        appendSection: function(sectionConfig, expanded,sectionsNode, newSection) {
            
            //create the widget for this section
            var sectionImpl = this._createSectionProvider(sectionConfig);
			if (sectionImpl == null) {
				return;
			}
            var sectionContainer = sectionConfig.isChicklet ? null : this._createSectionWidget(sectionImpl);
            // chicklet is just a place holder in the TOC don't need any section widget
            if (sectionContainer) {
                sectionImpl.setContainer(sectionContainer);
            }
            
            if(dojo.isFunction(sectionImpl.setNewSection) && newSection)
                sectionImpl.setNewSection(true);
            
            this._sections[this._sections.length] = sectionImpl;            
            if (!sectionConfig.isChicklet) {
                if (this._isTopLevelSection(sectionConfig)) {
                    var bookmark = document.createElement("div");
                    bookmark.id = sectionConfig.id;
                    sectionsNode.appendChild(bookmark);
                    sectionsNode.appendChild(sectionImpl.getContainer().domNode);
                    if (expanded && sectionContainer) {
                        sectionContainer._onTitleClick();
                    }
                } else {
                    var sectionGroup = this.getSectionGroup(sectionConfig.groupId);
                    sectionGroup.addSection(sectionImpl);
                }
            }
			return sectionImpl;
        },
        
        removeSection: function(sectionId) {
			var self = this;
			var args = {
				primaryTitle: Constants.getMessage("labelConfirmation"),
				message: Constants.getMessage("msgConfirmRemoveSection"),
				yesCallback: function(){
					 //set the section to not visible
            		var section = self.getSection(sectionId);
            		section.setVisible(false);
					
            		//add to the list to be removed
            		self._sectionsRemoved.push(sectionId);
            
            		//update the table of contents
            		self.updateTableOfContents(true); 
					self.setDirty(true);
					self.localEditorDirty = true;
					return true;          
				},
				noCallback: function() {
					return false;
				}
			};
			var dialog = new YesNoDialog(args);
	        dialog.open();
        },
        
        updateSections: function(){
            var sections = this.getSections();
			var secLen = sections ? sections.length : 0;
            for (var i = 0; i < secLen; i++) {
                var section = sections[i];
                if (section["saveFinished"]) {
                    section.saveFinished();
                    this._updateEditorSection(section);
                } else {
                    console.warn("Section Widget DOES NOT extend AbstractArtifactEditorSection! (" + section.id + ")");
                }
            }
        },
        
        loadTableOfContents: function(/* REQUIRED */ domNode) {
			if (this._tocWidget != null || this.isCopy()) {
				//table of contents already created; use current setting for 'showAll'
				var showAll = this.isCopy() || this._tocWidget.showAll == true;
				this._displayTableOfContents(domNode, showAll);
				return;
			}
			
			//otherwise, look up preference to determine 'showAll' behavior
			var handler = {
				callBack: dojo.hitch(this, function(userPreference) {
					var showAll = userPreference && userPreference.key && userPreference.value && userPreference.value == "TOCAllSection";
					this._displayTableOfContents(domNode, showAll);
				})
			};
			PreferenceClient.getCurrentUserPreferences(handler, handler.callBack, Constants.USER_UI_CUSTOMISE_ACTIONBAR_TOC_CATEGORY.key);  
        },
		
		_displayTableOfContents: function(domNode, showAll) {
            var vTabAlign = this._headerTabOrientation == 'vertical';
			//table of contents
			this._tocNode = domNode;
            var entries = this.getTocEntries();
            var args = {
                entries: entries,
                getTopOffsetSlack: dojo.hitch(this, function() {
                    // we need to add more slack at the top for the TOC if status mesage is shown
                    if (this.getHeader().statusClosed) {
                        return 0;
                    } else {
                        // get the height of the message box
                        var messageBoxH = dojo.marginBox(this.getHeader().statusLineNode.domNode).h;
                        return messageBoxH;
                    }
                }),
                // override onTrackToNewPos method in StationaryPane to validate the bottom position
                // to avoid overlapping between TOC and bottom status bar
                onTrackToNewPos: dojo.hitch(this, function(bottomPos) {
                	var bottomMessage = dojo.position(this.getHeader().viewHeaderBottomNode, true);
                    return bottomPos < bottomMessage.y;
                })
            };
            //store the latest selected secction if applied
            if (this._tocWidget) {
                var curSelectedSection = this._tocWidget.getSelectedEntry();
                if (curSelectedSection) {
                    this.restoreLastSelectedSection = curSelectedSection.tag;
                }
            }
            Utility.destroyWidgetsFromNode(this._tocNode);

            // only add all ancillary entries when we really have the
            // sections information. We will be updating the TOC once
            // the sections info is fetched. This is just to create the
            // TOC with a 'loading...' placeholder.
            if (this._sections && this._sections.length > 0) {
                // add separate entries for the artifact's alternate content tabs.
                if (!this.isNew() && vTabAlign) {
                    var sepEntries = [];
                    if(this.isSnapshotSupported()){
	                    sepEntries.push({
	                        title: Constants.getMessage("labelViewSnapshots"),
	                        tag: 'snapshot',
	                        callback: dojo.hitch(this.getHeader(), "_selectAltContent")
	                    });
                    }
                    sepEntries.push({
                        title: Constants.getMessage("labelViewHistory"),
                        tag: 'history',
                        callback: dojo.hitch(this.getHeader(), "_selectHistoryContent")
                    });
                    args.separateEntries = sepEntries;
                }
                if (this._editorConfig.isTemplated && this.isEditable()) {
                    args.manageEntriesAction = {
                        title: Constants.getMessage("labelManageSectionsTitle"),
                        tag: 'manageSections',
                        image: ImageCache.MANAGE_SECTIONS,
                        alt: Constants.getMessage("labelManageSectionsTitle"),
                        callback: dojo.hitch(this, "_showManageSectionsDialog")
                    };
                }
                args.showAll = (showAll == true);
                args.showAllCallback = dojo.hitch(this, "setSectionDisplayMode");   
            }
            this._tocWidget = new DirectoryPane(args);
            dojo.empty(domNode);
            			
			domNode.appendChild(this._tocWidget.domNode);
			//attempt to restore teh latest selected section.
			if (this.restoreLastSelectedSection) {
				this._tocWidget.selectEntryByTag(this.restoreLastSelectedSection);
			} else {
				this._tocWidget.selectEntry(this._getFirstSectionEntryIndex());   //select/highlight the first section
			}
			if (this._doneResizeTOC !== true) {
			    // resize the TOC only if it is not yet done
			    this._resizeMaxCount = 10;
                this._doneResizeTOC = false;
			    this._resizeTOC();
			}
		},
        
		_getFirstSectionEntryIndex: function() {
		    if (this.diffMergeEnabled && this.isMerging() && this.diffMergeController) {
		        // editor is in the process of merging, make sure don't select any leading chicklets
		        var index = 0;
		        var entry = this._tocWidget.getEntryByIndex(index);
		        while (entry) {
		            if (entry.isChicklet) {
		                index++;
		                entry = this._tocWidget.getEntryByIndex(index);
		            } else {
		                return index;
		            }
		        }
		    }
		    return 0;
		},
		
        _resizeTOC: function() {
            // make sure resize is only perform once
            if (!this._doneResizeTOC) {
                if (dojo.isDescendant(this._tocWidget.focusNode, document)) {
                    // check if the HTML document object is the parent which means
                    // are we added to the DOM tree yet or is the dimension set yet
                    var totalWidth = this._tocWidget.focusNode.scrollWidth;
                    // minimum width is 140px or customized locale preferred width
                    var width = (totalWidth > this.tocWidth) ? totalWidth + 26 : this.tocWidth;
                    
                    // the header hosts the TOC, set its appropriate width.
                    this.getHeader().setContentSelectorWidth(width);
                    dojo.style(this._tocWidget.domNode, 'width', width+'px');

                    // load the TOC entries after we've added to the dom tree
                    // This ensures that entries are wrapped correctly based on
                    // the proper size of the TOC.
                    this.updateTableOfContents(true);
                    
                    // resize once and only once
                    this._doneResizeTOC = true;
                } else {
                    // not yet added to the DOM tree, try again in half a second
                    // unless it exceed the max count
                    if (this._resizeMaxCount && (this._resizeMaxCount-- > 0)) {
                        setTimeout(dojo.hitch(this, "_resizeTOC"), 500);
                    }
                }
            }
        },
    
        updateTableOfContents: function(selectFirst) {
            var tocWidget = this.getTableOfContents();
            
            // print view doesn't have a toc
            if(!tocWidget) return;
        	
            // don't show the "Sections" header when in diff/merge
            dojo.style(tocWidget.focusNode, "display", this.isMerging() ? "none" : "block");
            
            //save the last selected section.
            if(!this.restoreLastSelectedSection) {
            	var curSelectedSection = this._tocWidget.getSelectedEntry();
            	if (curSelectedSection) {
            		this.restoreLastSelectedSection = curSelectedSection.tag;
            	}
            }
            
            var entries = this.getTocEntries();
            var sepEntries = null;
            var manageEntriesAction = null;
            
            // only add all ancillary entries when we really have the
            // sections information. We will be updating the TOC once
            // the sections info is fetched. This is just to create the
            // TOC with a loading... placeholder.
            if (this._sections && this._sections.length > 0 && !this.isMerging()) {
                // add other tabs entries into the TOC separate area.
                if (!this.isNew() && this._headerTabOrientation == 'vertical') {
                    sepEntries = [];
                    if(this.isSnapshotSupported()){
	                    sepEntries.push({
	                        title: Constants.getMessage("labelViewSnapshots"),
	                        tag: 'snapshot',
	                        callback: dojo.hitch(this.getHeader(), "_selectAltContent")
	                    });
                    }
                    sepEntries.push({
                        title: Constants.getMessage("labelViewHistory"),
                        tag: 'history',
                        callback: dojo.hitch(this.getHeader(), "_selectHistoryContent")
                    });
                }
                // add the manage action if this is configurable.
                if (this._editorConfig.isTemplated && this.isEditable()) {
                    manageEntriesAction = {
                        title: Constants.getMessage("labelManageSectionsTitle"),
                        image: ImageCache.MANAGE_SECTIONS,
                        alt: Constants.getMessage("labelManageSectionsTitle"),
                        tag: 'manageSections',
                        callback: dojo.hitch(this, "_showManageSectionsDialog")
                    };
                }
                // add the show all toggle.
                tocWidget.showAllCallback = dojo.hitch(this, "setSectionDisplayMode");
            }
            tocWidget.setEntries(entries, sepEntries, manageEntriesAction);
            
            //no need to change to a specific section if we saved a snapshot
            if(this.saveSnapshot){
            	tocWidget.highlightSelected(0,true); //highlight snapshot link 
            	return;
            }

            // attempt to restore the last selected section.
            // if the section is selected we are done. Otherwise
            // process the selection as normal.
            if(this.restoreLastSelectedSection) {
                var selected = tocWidget.selectEntryByTag(this.restoreLastSelectedSection);
                delete this.restoreLastSelectedSection;
                if(selected) {
                    return;
                }
            }
            
            if (!selectFirst && tocWidget.selectedIndex && tocWidget.selectedIndex < entries.length ) {
                tocWidget.selectEntry(tocWidget.selectedIndex);
            } else {
				var hash = window.location.hash;
				var matches = /[\#&]sectionId=([^&]+)/.exec(hash);
				if (matches && matches.length>1) {
					var sectionId = matches[1];
	        		tocWidget.selectEntryByTag(sectionId);
				} else {
					tocWidget.selectEntry(this._getFirstSectionEntryIndex());
				}
            }            
        },
        
        _onUpdateTabUri: function(oldUri, newUri){
			// remove sectionid from current id if present
			var currentUri = this._uri.replace(/&?sectionId=[^&]+/,"");
        	if (newUri!=null && newUri.indexOf(currentUri)==0) {
	            var tocWidget = this.getTableOfContents();
				var matches = /&?sectionId=([^&]+)/.exec(newUri);
				if (matches && matches.length>1) {
					var sectionId = matches[1];
					tocWidget.selectEntryByTag(sectionId);
				}
        	}
        },
        
		getTocEntries: function() {
            var entries = [];
			//if no sections, the editor is loading...show appropriate entry
			if (!this._sections || this._sections.length == 0) {
                entries.push({
                    title: LabelLoading,
                    callback: function(){}
                });	
				return entries;			
			}
			
			//create entries for each section, callback will set focus to the entry's node 
			var secLen = this._sections ? this._sections.length : 0;
            for (var i = 0; i < secLen; i++) {
                var section = this._sections[i];
                var sectionConfig = section.getConfig();
                if (this._isTopLevelSection(sectionConfig) && section.isVisible()) {
                    var sectionTitle = (section.getContainer() && section.getContainer().getDisplayTitle) ? section.getContainer().getDisplayTitle() : section.getDisplayTitle();
                    var sectionId = sectionConfig.id;
                    var entry = {
                        title: sectionTitle,
                        tag: sectionId,
                        node: section.getContainer()? section.getContainer().domNode : null,
                        callback: dojo.hitch(this, "setSectionFocus", sectionConfig.id)
                    };
                	// check if the editor is in diff/merge mode
                	if (this.isMerging() && this.diffMergeController) {
                	    var artifactSection = section.getSection();
                        entry.annotationClass = this._getSectionDiffAnnotationClass(artifactSection);
                        entry.annotationLabel = sectionTitle + this._getSectionDiffAnnotationLabel(artifactSection);
                       
                        if (artifactSection.isChicklet) {
                            // chicklet is a place holding section of the original position that is moved
                            entry.title = Constants.getMessage("msgSectionMoved", sectionTitle);
                            delete entry.callback;
                            entry.isChicklet = true;
                            // add attribute to have the DirectoryPane draw the connecting line with the
                            // corresponding section entry, which has the same id without the ".REORDERED"
                            entry.connectedEntryId = sectionId.replace(".REORDERED", "");
                        } else if (artifactSection.hasChicklet) {
                            // add attribute to draw the connecting line on hover with the corresponding
                            // chicklet, which has the same id with the appended ".REORDERED"
                            entry.hasChicklet = true;
                            entry.connectedEntryId = sectionId + ".REORDERED";
                        }
                	}
                    entries.push(entry);
                }
            }
			return entries;
		},
		
		_getSectionDiffAnnotationClass: function(section) {
		    var changeType = section.changeType;
			if (changeType == Constants.SECTION_CHANGE_TYPE_ADDED) {
				return DirectoryPane.ADDED;
			} else if (changeType == Constants.SECTION_CHANGE_TYPE_REMOVED) {
				return DirectoryPane.REMOVED;
			} else if (changeType == Constants.SECTION_CHANGE_TYPE_MODIFIED) {
				return DirectoryPane.MODIFIED;
            } else if (changeType == Constants.SECTION_CHANGE_TYPE_UNMODIFIED) {
                return section.reordered ? DirectoryPane.REORDERED : DirectoryPane.UNMODIFIED;
            } else if (changeType == Constants.SECTION_CHANGE_TYPE_REORDERED) {
                return DirectoryPane.CHICKLET;
            }
			return null;
		},
        
		// non-NLS annotation label used for A11Y aria label.  Perhaps consider use as tool-tip?
        _getSectionDiffAnnotationLabel: function(section) {
            var changeType = section.changeType;
            if (changeType == Constants.SECTION_CHANGE_TYPE_ADDED) {
                return "- section does not exist in the compared artifact";
            } else if (changeType == Constants.SECTION_CHANGE_TYPE_REMOVED) {
                return "- section does not exist in this artifact";
            } else if (changeType == Constants.SECTION_CHANGE_TYPE_MODIFIED) {
                if (section.reordered) {
                    return "- section content is different and location is also different";
                } else {
                    return "- section content is different";
                }
            } else if (changeType == Constants.SECTION_CHANGE_TYPE_UNMODIFIED) {
                if (section.reordered) {
                    return "- section location is different";
                } else {
                    return "- section has no difference from the compared artifact";
                }
            } else if (changeType == Constants.SECTION_CHANGE_TYPE_REORDERED) {
                return "- location of the section of the compared artifact";
            }
            return null;
        },
        
        getTableOfContents: function() {        
            return this._tocWidget;
        },
        
        setSectionFocus: function(sectionId) {
            //set display mode
            this.setSectionDisplayMode(this._tocWidget.showAll, sectionId);
            
            //expand the selected section, if necessary
            var section = this.getSection(sectionId);            
            var container = section.getContainer();       
            
            // Make sure the container is not destroyed or is being destroyed before using
            // it. When initialize is called due to reload of the content, the table of content
            // is could be refreshed multiple times and every time it's refresh/reload the focus
            // on an entry is called which resulted in calling this method. However, the sections
            // could be in rebuilding mode when this call is made. Thus, we have to guard against
            // the container is being destroyed here. 
            // 
            // Longer term we need to examine the editor initialization path to avoid accessing 
            // items that can be in rebuild mode.
            //
            var containerIsGood = container && !(container._beingDestroyed || container._destroyed);
            
            if (containerIsGood && container && !container.open) {
                container._onTitleClick();
            }
			
			if( container && container.setDisplayTitle && containerIsGood) {
                // notify the diffMergeController the section is in focus
                if (this.isMerging() && this.diffMergeController) {
                    this.diffMergeController.sectionInDisplay(section);
                }
				setTimeout( dojo.hitch(this, function() {
				    // make sure the after the timeout the container is still good.
				    if(!(container._beingDestroyed || container._destroyed)) {
				        container.setDisplayTitle( container.getDisplayTitle() );

				        // call the section's activated method for any processing
				        // when it's being made active.
				        if(section.onActivated && dojo.isFunction(section.onActivated))
				            section.onActivated();
				    }
                }), 200 );
			}
			
            //do not select/focus section if main content is not selected
            if (!this.getHeader().isMainContentSelected() && this._headerTabOrientation == 'vertical') {
                this.getHeader()._selectMainContent();
            }			
            
            //If header title is not editing, then focus to Section  
			if (!this.getHeader().viewEditableTitle.inEdit && container && containerIsGood) {
				container.setFocus();
			}
        },
        
        _initDiffMerge: function() {
            if (!this.diffMergeType) {
                throw new Error("\"diffMergeType\" must be defined in " + this.declaredClass); // NON_NLS
            }
            
            var artifact = this.getArtifact();
            var artifactType = this.getArtifactType();
            var selectLabelKey = "labelSelect" + artifactType.replace(/\ /g, ""); // remove space
            var params = {
                title: Constants.getMessage(selectLabelKey),
                showQueryFilters: true,
                itemType: artifactType,
                onOk: dojo.hitch(this, "_onMergeSourceSelected"),
                allowSelectAll: false,
                isSingleSelect: true,
                multipleSelection: false,
                disabledItems: [{
                    id: artifact.id,
                    itemId: artifact.itemId,
                    versionableItemId: artifact.versionableItemId
                }]
            };
            var selectDialog = new SelectItemTableDialog(params);
            selectDialog.show();
        },
        
        // initialize for merge from concurrent modification
        _initializeStaleMerge: function() {
            if (this.diffMergeController && this.diffMergeController.isStaleMerge && this.staleMergeInitNeeded) {
                // Walk through the sections to manually remove or add sections to
                // match the current displayed artifact.  Otherwise those sections
                // won't be dirty and upon save the sections list will pick up what
                // the newer verion has instead of what was displayed to the user.
                for (var i = 0; i < this._sections.length; i++) {
                    var section = this._sections[i];
                    var sectionId = section.getConfig().id;
                    var artifactSection = section.getSection();
                    var changeType = artifactSection ? artifactSection.changeType : null;
                    if (changeType) {
                        if (changeType == Constants.SECTION_CHANGE_TYPE_ADDED) {
                            // The section is already removed in the newer version for concurrent modification,
                            // need to add the section unless the user "Accept" to keep it removed.
                            section.setNewSection(true);
                            section.setDirty();
                            this.changedSections = true;
                            this.localEditorDirty = true;
                        } else if (changeType == Constants.SECTION_CHANGE_TYPE_REMOVED) {
                            // The section is added in the newer version for concurrent modification,
                            // need to remove the section unless the user "Accept" to keep it added.
                            if (!this._sectionsRemoved) {
                                this._sectionsRemoved = [];
                            }
                            // add section to be removed upon save
                            this._sectionsRemoved.push(sectionId);
                            this.localEditorDirty = true;
                            section.setDirty();
                        }
                    }
                }
                delete this.staleMergeInitNeeded;
            }
        },
        
        _onMergeSourceSelected: function(artifacts, isStaleMerge) {
            if (artifacts && artifacts.length == 1) {
                var artifact = artifacts[0];
                var artifactModel = new ArtifactModel(this.getArtifactType());
                var args = {
                    model: artifactModel,
                    _isReadOnly: true,
                    _isMerging: true,
                    isMergeSource: true,                    
                    kwArgs: { 
                    	id: artifact.id 
                    },       
                    parentController: this.parentController
                };
                
                // create the controller to invoke the diff/merge
                var editorClass = eval(this.declaredClass);
                if(isStaleMerge){
                	this.draftItemId = artifact.draftItemId;
                	this._currentStateItemId = artifact.currentStateId;
                	this.updateLocalArtifactAttributes();
                	this.staleMergeInitNeeded = true;
                }
                var mergeSourceEditor = new editorClass(args);                
                this.diffMergeController = new DiffMergeController({
                    itemType: this.diffMergeType,
                    mergeSource: mergeSourceEditor,
                    isStaleMerge: isStaleMerge,
                    mergeTarget: this
                });                
                this.diffMergeController.invokeDiffMerge();
            }
        },
        
        _exitDiffMerge: function(restoreSavedSections) {
            this.setMerging(false);
            if(this._staleMergeInProgress && this.draftItemId){
            	//Clean up the draft created in server (if any)
            	var responseHandler = new ServiceResponseHandler({
    				success: function() { 
    					//nothing to do, just an internal call
    				},
    				error: function(e) {
    					console.dir(e);
    				}
    			}, "success", "error");	
            	DiffMergeClient.postDeleteDraftContainer(responseHandler, {
            		itemId: this.draftItemId
            	});
            }
            if(this._currentStateItemId){
            	delete this._currentStateItemId;
            }
            if(this.draftItemId){
            	delete this.draftItemId;
            }
            if (this.diffMergeController) {
                this.diffMergeController.destroy(restoreSavedSections);
                delete this.diffMergeController;
            }
            this._cancelButton.setDisabled(true);
        },
        
        isMerging: function() {
            return this._isMerging;
        },
        
        isStaleMergeInProgress: function(){
        	return this._staleMergeInProgress;
        },
        
        //returns the currentdraftItemId (if any)
        getDraftItemId: function(){
        	return this.draftItemId;
        },
        
        // NOTE: for  diff/merge usage, 
        //This will have the currentState id ONLY if a draft has been created, otherwise this method will return null,  
        getCurrentStateItemId: function(){
        	return this._currentStateItemId;
        },
        
        setMerging: function(merging) {
            this._isMerging = merging;
        },
        
        repositionArtifactInfoToMergeSection: function() {
            var header = this.getHeader();
            var section = new com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection({
                collapsible: false,
                open: true,
                showSelectedOnFocus: false,
                bgShading: false
            });
            section.showTitleOnly();
            dojo.place(header.viewHeaderLeft, section.contentNode);
            dojo.place(header.attributesSummaryInnerContainerNode, section.contentNode);
            dojo.forEach([header.viewID, header.viewNonEditableTitle, header.viewSubTitle, header.viewEditableTitle.textbox], function(textNode) {
                if (textNode) {
                    dojo.style(textNode, "fontSize", "12pt");
                }
            });
            return section;
        },
        
        restoreArtifactInfoHeader: function() {
            var header = this.getHeader();
            dojo.empty(header.titleOutterContainerNode);
            dojo.place(header.viewHeaderLeft, header.titleOutterContainerNode);
            dojo.place(header.attributesSummaryInnerContainerNode, header.attributesSummaryOutterContainerNode);
            dojo.forEach([header.viewID, header.viewNonEditableTitle, header.viewSubTitle, header.viewEditableTitle.textbox], function(textNode) {
                if (textNode) {
                    dojo.style(textNode, "fontSize", "14pt");
                }
            });
        },
        
        setSectionDisplayMode: function(showAll, selectedSectionId) { 
			this._selectedSectionId = selectedSectionId;     
			var secLen =  this._sections ? this._sections.length : 0;
            for (var i = 0; i < secLen; i++) {
                var section = this._sections[i];
                var config = section.getConfig();
                if(section.getContainer() && section.getContainer().domNode){
	                if (!showAll && selectedSectionId != config.id && this._isTopLevelSection(config)) {
	                    dojo.addClass(section.getContainer().domNode, "hidden");
	                } else if (!section.isVisible()) {
	                    dojo.addClass(section.getContainer().domNode, "hidden");
	                } else {
	                    dojo.removeClass(section.getContainer().domNode, "hidden");
	                    if (showAll && this.isMerging() && this.diffMergeController) {
                            // notify the diffMergeController the section is in display
	                        this.diffMergeController.sectionInDisplay(section);
	                    }
	                }
                }
            }
            this.scrollToSection(selectedSectionId);
        },
		
		getSelectedSection: function() {
			return this._selectedSectionId || null;
		},

        scrollToSection: function(sectionId) {
            //focus on the section
            if (this._tocWidget && this._tocWidget.showAll) {
            	var sectionBookmark = dojo.byId(sectionId);
            	var target = dojo.position(sectionBookmark);
            	target.y -= 32;
                var scroll = dojox.fx.smoothScroll({
                	target: target,
                    win: window,
                    duration: 1000,
                    easing: dojo.fx.easing.easeOut
                });
                scroll.play();
            }else{
				var scroll = dojox.fx.smoothScroll({
					node: dojo.byId("net-jazz-ajax-WorkbenchRoot"),
                    win: window,
                    duration: 500,
                    easing: dojo.fx.easing.easeOut
                });
                scroll.play();
			}            
        },   
        
        isCustomSection: function(/* REQUIRED */sectionId) {
            //is the section id part of the template ? if not, its custom
            var sections = this._editorSections;
			var secLen =  sections ? sections.length : 0;
            for (var i = 0; i < secLen; i++) {                
                if (sections[i].id == sectionId) {
                    return false;
                }
            }
            return true;
        },
		
		setCSHelpButtonLabel: function(/* REQUIRED */ cshelpLabel) {
			this.getHeader().setCSHelpButtonLabel(cshelpLabel);
		},

        setCSHelpId: function(/* REQUIRED */ cshelpId) {
			this._cshelpId = cshelpId;
            this.getHeader().setCSHelpId(this._cshelpId);
		},

        getCSHelpId: function() {
			return this._cshelpId;
		},
		
		// Summary:
    	//    set the status message in the header. Optionally, provide a type "1", "2",
    	//    or "3" parameter to qualify the status. 
		// "1" means "Success"; "2" means "Error"; "3" means "Info"
		setHeaderStatus: function(status, type, /*optional*/details) {
			this.getHeader().setStatus(status, type, details);
		},
		
		clearStatus: function() {
			this.getHeader().clearStatus();
		},
		
        showTemplateSelect: function() {
            if (!this.isNew() || this.isCopy()) {
                return;
            }

 			if (this._templateSelectContainer) {
				//template container has simply been removed from the dom; add it back
				this.getHeader().getExtraAttributesNode().appendChild(this._templateSelectContainer);
			} else {            
    			
	            if (this._compositeDTO) {
	                this._setTemplatesSelect(this._compositeDTO.templates);
	            } else {
                    var self = this;
                    var handler = {
                        success: function(templates) {
    	                	self._setTemplatesSelect(templates);
    	                },
    	                failure: function(e) {
    	                    self._error(e);
    	                }
    	            };
    	            var srh = new ServiceResponseHandler(handler, "success", "failure");
    	            TemplateClient.getTemplates(srh, {editorId: this.getEditorId(), includeSections: false});
	            }
			}
        },
        
        _setTemplatesSelect: function(templates) {
            if (!this.isClosing()) {
                // continue only if the editor is not closing
                var tempLen = templates ? templates.length : 0;
                if (tempLen > 1){
                    this._templateSelect = new AbstractArtifactEditor.TemplatePicker({
                        templates: templates,
                        value: this.getTemplateId(),
                        onSelect: dojo.hitch(this, "_onTemplateChange")
                    });
                    this._templateSelectContainer = document.createElement("span");
                    this._templateSelectContainer.appendChild(this._templateSelect.domNode);
                    this._templateSelectContainer.appendChild(document.createElement("br"));
                    this.getHeader().getExtraAttributesNode().appendChild(this._templateSelectContainer);
                }
			}
        },
        
        _onTemplateChange: function(templateId) {
            if (templateId) {
                var itemId = templateId;
                if (itemId != this.getTemplateId()) {
					// WI 40195: Saving name & description previously typed, if any
					this.previousTitle = this._header.getTitle();
					this.previousDescription = this._header.getSummary();
					this.previousTemplateId = this.getTemplateId();
					if (this._isAlertWhenChangeTemplate) {
						var self = this;
						var args = {
							primaryTitle: Constants.getMessage("labelConfirmation"),
							message: Constants.getMessage("msgConfirmChangeTemplate"),
							yesCallback: function(){
								//otherwise, reset editor with new template
								self.setTemplateId(itemId);
								self.setTemplate(null);
								self.changingTemplate = true; //flag to indicate tell the inline editor not to change the focus nodes
								self.templateChanged = true; // Flag added to indicate the artifact has changed template
								self.getSaveContext().clearParticipant();
								if (self.isRolePermitsEdit() || self.isRolePermitsArchive() || self.isRolePermitsLock() || self.isRolePermitsUnlock()) {
									self._artifactModel.getSaveContext().addParticipant(self);
									self._artifactModel.setArtifact(self.getArtifact());
								}
                                // clear container as well. need to recreate it
                                self._templateSelect = null;
                                self._templateSelectContainer = null;
								self.initialize();
								return true;
							},
							noCallback: function(){
								if (self.isDirty()) 
									self._templateSelect.set("value", self.previousTemplateId);
								return false;
							}
						};
						var dialog = new YesNoDialog(args);
						dialog.open();
					}
					else {
						//reset editor with new template directly
                        
                        // clear container as well. need to recreate it
                        this._templateSelect = null;
                        this._templateSelectContainer = null;
						this.setTemplateId(itemId);
						this.changingTemplate = true; //flag to indicate tell the inline editor not to change the focus nodes
						this.templateChanged = true; // Flag added to indicate the artifact has changed template
						this.setTemplate(null);
						this.getSaveContext().clearParticipant();
						if (this.isRolePermitsEdit() || this.isRolePermitsArchive() || this.isRolePermitsLock() || this.isRolePermitsUnlock()) {
							this._artifactModel.getSaveContext().addParticipant(this);
							this._artifactModel.setArtifact(this.getArtifact());
						}
						this.initialize();
						return true;
					}
                }
            }
        },		
		
        ////////////////////////////////////////////////////////////////////////////////////////////////////
        //                                   INTERNAL SECTION UTILITIES                                   //
        ////////////////////////////////////////////////////////////////////////////////////////////////////        		
        _showManageSectionsDialog: function() {
			var editorSections = this._filterBlocked(this._editorSections);
			var temp = this.getTemplate();
            var templateSections = (temp && temp.sections) ? temp.sections : [];
            var customSections = this._getCustomSections();
			
            var allAvailable = editorSections.concat(customSections);
            var templateAvailable = templateSections.concat(customSections) ;
			
			var selectedSections = [];
			var allSections = this.getSections();
			var secLen = allSections ? allSections.length : 0;
			var removedSectionIds = this._sectionsRemoved;
			if (secLen) {
				for (var i = 0; i < secLen; i++) {
					var section = allSections[i];
					var removed = false;
					var removedLen = removedSectionIds ? removedSectionIds.length : 0;
					if (removedLen) {
						for (var j = 0; j < removedLen; j++) {
							if (section.getConfig().id == removedSectionIds[j]) {
								removed = true;
								break;
							}
						}
					}
					if (!removed) {
						selectedSections.push(section.getConfig());
					}
				}
			}
			
            this.sectionDialog = new ManageSectionsDialog({
                onOk: dojo.hitch(this, "_manageSectionsDialogOnOK"),
                allSections: allAvailable, 
				templateSections: templateAvailable,
                selectedSections: selectedSections,
				comparedSections: templateSections,
				enableCreate: this.isRolePermitsCreateSection(),
				parentEditor: this
            });           
        },
        
        //update sections for the artifacts that are not intitialized by composite service
        _getEditorSections: function() {
			var self = this;
			var handlerObj = {
				success: function(sections) {
					self._editorSections = sections;
				},
				failure: function(e) {
					self._error(e);
				}
			};
            var responseHandler = new ServiceResponseHandler(handlerObj, "success", "failure");
            TemplateClient.getSections(responseHandler, {editorId: this.getEditorId()});        	
        },        
		
		_filterBlocked: function(sections) {
			var updatedSections = [];
			var secLen = (sections = sections || []).length;
            for (var i = 0; i < secLen; i++) {
				var section = sections[i];
				if (!this.isBlocked(section.id)) {
					updatedSections.push(section);
				}
            }
			return updatedSections;
		},
		
        _manageSectionsDialogOnOK: function(newSections) {
			var existingSections = this.getSections();	
			var getExisting = function(sectionId) {         
			    var secLen = existingSections ? existingSections.length : 0; 
	            for (var i = 0; i < secLen; i++) {
					var section = existingSections[i]; 
	                if (section.getSection().id == sectionId) {
	                    return section;
	                }
	            }
            };
            var areSectionsEqual = function(existingSections, newSections){            	
            	var lenNew = newSections?newSections.length:0;
            	var lenExisting = existingSections?existingSections.length:0;
            	if(lenExisting!= lenNew){
            		return false;
            	}
            	for(var i=0;i<lenNew; i++){
            		var sectionNew = newSections[i];
            		var sectionExisting = existingSections[i];
            		if(sectionNew.id != sectionExisting.id){
            			return false;
            		}
            	}
            	return true;
            };
            if(!areSectionsEqual(existingSections, newSections)){
            	this.changedSections = true;	
            }
			var templateSections = this.getTemplate().sections;
            var getTemplateSection = function(sectionId) {    
			    var secLen = templateSections ? templateSections.length : 0;
                for (var i = 0; i < secLen; i++) {
					var section = templateSections[i];
                    if (section.id == sectionId) {
                        return section;
                    }
                }
            };
            //remove sections        
			this._sectionsRemoved = []; 
			var existLen = existingSections ? existingSections.length : 0; 
            for (var i = 0; i < existLen; i++){
                //this section been removed if 'newSections' does not contain it
				var section = existingSections[i];
                if (!this._contains(newSections, section.getSection())) {
					section.setVisible(false);
                    this._sectionsRemoved.push(section.getSection().id);
                }
            }
							
			//re-display the sections, using existing widgets if available
            this._sections = [];        
            dojox.xml.parser.removeChildren(this._sectionsNode);
            var doc = document;
			var sectionsNode = doc.createDocumentFragment();
			var newLen = newSections ? newSections.length : 0;
            var resetWidgets = [];
            for (var i = 0; i < newLen; i++) {
				var newSection = newSections[i];
                var existingWidget = getExisting(newSection.id);
				if (existingWidget) {
					existingWidget.setVisible(true);
					this._sections.push(existingWidget);
	                var bookmark = doc.createElement("div");
	                bookmark.id = newSection.id;
	                sectionsNode.appendChild(bookmark);
	                sectionsNode.appendChild(existingWidget.getContainer().domNode);
	                if (i == 0 && !existingWidget.getContainer().open) {
	                    existingWidget.getContainer()._onTitleClick();
	                }
					if(existingWidget.reset)
						resetWidgets.push(existingWidget);
				} else {
					var templateSection = getTemplateSection(newSection.id);
					var newSectionImpl = this.appendSection(templateSection ? templateSection : newSection,false,sectionsNode, true);
                    
                    // this is a new section. If a section is new, we have to
                    // make sure that its content is save for the first time,
                    // to make it stick. If the user didn't add any changes to
                    // the section, the new section would not be saved.
                    if (newSectionImpl) {
                        newSectionImpl.setSectionDirty(true);
                    }
				}
            }    
			this._sectionsNode.appendChild(sectionsNode);    
            
            // If the section is a dynamic section (rich text section), reset will re-create
            // the rich text editor. However, we have to do this after the section node 
            // has added to the dom tree. Because the editor will try to reference's refNode's parentNode
            // and that would be null if the sections has not been added yet. 
            dojo.forEach(resetWidgets, function(widget) {
                widget.reset();
            });
            if (this._tocNode != null) {
                this.loadTableOfContents(this._tocNode);
            }		
			this.setDirty(true);
			this.localEditorDirty = true;
        },
        
        /*
         * Determines whether the given Section/SectionGroup DTO is a top level
         *    section.  Groups and Sections that are not associated with a 
         *    Group are considered top level sections, and will be displayed
         *    in a full EditorSection as opposed to a sub section. 
         */        
        _isTopLevelSection: function(/* Section/Group DTO*/ sectionConfig) {
            return (sectionConfig.sections || !sectionConfig.groupId);  
        },
        
        _isSectionGroup: function(/* Section/Group DTO*/ sectionConfig) {
            return (sectionConfig.sections && !sectionConfig.groupId);  
        },        
        
        //NOTE: assumes js class already loaded (via load_async)
		//but handles missing classes (somewhat) gracefully (logs error to console) 
        _createSectionProvider: function(/* Section/Group (DTO) */sectionConfig) {
            if (this.diffMergeEnabled && this.isMerging() && this.diffMergeController) {
                var configId = sectionConfig.id;
                var targetSection = this.diffMergeController._getTargetSection(configId);
                var artifactSection = this.getArtifactSection(configId);
                if (targetSection && artifactSection) {
                    // Reuse the section already created before started the diff/merge.  Just need
                    // to update the config and artifact section that included diff/merge info.
                    targetSection.config = sectionConfig;
                    targetSection.setSection(artifactSection);
                    return targetSection;
                }
            }
            //determine the proper widget for this section
			var sectionConstructor = null;
            if (this._isSectionGroup(sectionConfig)) {
                sectionConstructor = SectionGroup;
				
            } else if (sectionConfig.jsClass) {
                sectionConstructor = dojo.getObject(sectionConfig.jsClass);
				if (!sectionConstructor || sectionConstructor == null) {
					console.error("Unable to load contributed section for: [" + sectionConfig.jsClass + "]");
					return null;
				}
				
            } else  {
				var attLen = sectionConfig && sectionConfig.attributes ? sectionConfig.attributes.length : 0;
				var propLen = sectionConfig && sectionConfig.properties ? sectionConfig.properties.length : 0;
				if (attLen > 0) {
					//From the template, atributes tell you if this is grid type or rich text type
					for (var i = 0; i < attLen; i++) {
						if (sectionConfig.attributes[i].attributeType == "GRID" || sectionConfig.attributes[i].type == "grid"){
							sectionConstructor = DynamicGridSection;
							break;
						}
					}
				} else if (propLen > 0){
					//From the section, properties has entry for type					
					for (var i = 0; i < propLen; i++) {
						var property = sectionConfig.properties[i];
						if (property.key == "type" && (property.value == "GRID" || property.value == "grid")){
							sectionConstructor = DynamicGridSection;
							break;
						}
					}
				}
				//Default is Rich text
				if (sectionConstructor == null) sectionConstructor = DynamicSection;
            }
			//create the contributed section widget
            var contributedWidget = null;
			try {
	            var parentEditor = this;
	            var widgetArgs = {
	                parentController: parentEditor.parentController,
	                parentEditor: parentEditor,
	                config: sectionConfig ,
	                _compositeDTO: this._compositeDTO,
	                summaryEditable: !this.isReadOnly() && this.isCustomSection(sectionConfig.id)
	            };
				contributedWidget = new sectionConstructor(widgetArgs);	
			} catch(e) {
				console.error(this.declaredClass + ": Error loading widget for section: [Id: " + sectionConfig.id + "; WidgetClass: " + sectionConfig.jsClass + "] --> " + e.message);
			}
			//log status of loading the contributed widget
		    if (contributedWidget != null) {
                //console.debug(this.declaredClass + ": Successfully loaded section widget: [Id: " + sectionConfig.id + "; WidgetClass: " + sectionConfig.jsClass + "]");
            }   else {
                console.error(this.declaredClass + ": Unable to load widget for section: [Id: " + sectionConfig.id + "; WidgetClass: " + sectionConfig.jsClass + "]");
            }
            return contributedWidget;
            
        },        
        
        /*
         * Creates a new EditorSection container widget instance based on the given
         * AbstractArtifactEditorSection.  Uses the AbstractArtifactEditorSection's API
         * to set up the various sections of the container.
         */
        _createSectionWidget: function(/* AbstractArtifactEditorSection */ sectionProvider, skipMergeCheck){
            var args = {
                title: sectionProvider.getDisplayTitle(),
                titleValue: sectionProvider.getTitle(),
                titleEditable: sectionProvider.isTitleEditable(),
				onTitleEdited: dojo.hitch(this, function() {
					sectionProvider.setDirty();
		            this.setDirty(true);
		            this.updateTableOfContents(false);					
				}),
				collapsible: sectionProvider.isSectionCollapsible(),
				showSectionFrame: sectionProvider.showSectionFrame(),
                actionDisplay: EditorSection.ACTION_LABEL_AND_ICON,
                hideToolbarOnReadOnly: false,
                editable: this.isEditable(),
				sectionProvider: sectionProvider ,
				summaryValue: sectionProvider.getSummaryContent(this.isEditable())				
            };
            var sectionConfig = sectionProvider.getConfig(); 
            if (this._isTopLevelSection(sectionConfig)) {
                if (this.isPrintView()) {
                	return new EditorSectionPrintView(args);
                } else {
                	if (this.isMerging() && this.diffMergeController && !skipMergeCheck) {
                        // get the widget from the diffMergeController if merging
                	    return this.diffMergeController.getDiffMergeSectionWidget(args);
                	} else {
                		return new EditorSection(args);
                	}
    			}
            } else {
                return new EditorSubSection(args);
            }
        },
        
        /*
         * Called by the 'updateSections' method, which is typically called during
         * saveFinshed, to allow sections the opportunity to update themselves based on
         * the result of the global save operation.
         */
        _updateEditorSection: function(/* AbstractArtifactEditorSection */ sectionProvider){
            if (sectionProvider.getContainer()) {
                sectionProvider.getContainer().renderContent();			 
			}            
        },
        
        _getCustomSections: function() {
            var sections = [];
			var predefSections = this.getTemplate() ? this.getTemplate().sections : this._editorSections;
            if (this.getArtifact()) {
                var persisted = this.getArtifact().sections;
				var persistLen = persisted ? persisted.length : 0;
                for (var i = 0; i < persistLen; i++) {
					var section = persisted[i];    
                    if (!this._contains(predefSections, section)) {
                        sections.push(section);
                    }
                }
            }
			// add new added and not saved custom section 
			var secLen = this._sections ? this._sections.length : 0;
			for (var i = 0; i < secLen; i++) {
				var section = this._sections[i].getSection();
				if (!this._contains(predefSections, section) && !this._contains(sections, section)) {
                    sections.push(section);
                }
			}
            return sections;
        },        
        
        _hasPersistedSection: function(/* REQUIRED */sectionId) {
            if (this.getArtifact()) {
                var persisted = this.getArtifact().sections;
				var persistLen = persisted ? persisted.length : 0;
                for (var i = 0; i < persistLen; i++) {
                    if (sectionId == persisted[i].id) {
                        return true;
                    }
                }
            }
            return false;
        },        
        
        _contains: function(/* REQUIRED */sections, /* REQUIRED */ section) {
			var secLen = sections ? sections.length : 0;
            for (var i = 0; i < secLen; i++) {                
                if (sections[i].id == section.id) {
                    return true;
                }
            }
            return false;
        },
        
        _containsValue: function(/* REQUIRED */values, /* REQUIRED */ value) {
			var valLen = values ? values.length : 0;
            for (var i = 0; i < valLen; i++) {                
                if (values[i] == value) {
                    return true;
                }
            }
            return false;
        },		
        
        _pushAll: function(/* REQUIRED */array, /* REQUIRED */ elements) {
            array = array ? array : [];
			var len = elements ? elements.length : 0;
            for (var i = 0; i < len; i++) {
                array.push(elements[i]);
            }
        },
        
        _publishArtifactUriChanged: function() {
            var artifactUri = this._getArtifactUri();
            
            if(artifactUri) {
                dojo.publish(GlobalEvents.UpdateTabUri, [window.location.hash, artifactUri]);                    
            }
            else {
                console.debug("Unknown artifact type - " + this.getArtifactModel().getArtifactType() + " Cannot update the artifact URI");
            }
        },
        
        _publishArtifactAdded: function() {
            dojo.publish(GlobalEvents.ArtifactsAdded, [ this.getArtifactType(), [ this.getArtifact() ], this._getArtifactUri() ]);
        },
        
       
        _publishArtifactUpdated: function() {
            dojo.publish(GlobalEvents.ArtifactsUpdated, [ this.getArtifactType(), [ this.getArtifact() ], this._getArtifactUri() ]);
        },
        
        _publishSelfClosing: function() {
            var artifactUri = this._getArtifactUri();
            
            if (artifactUri) {
                dojo.publish(GlobalEvents.CloseTab, [artifactUri]);
            } else {
                console.debug("Unknown artifact type - " + this.getArtifactModel().getArtifactType() + " Cannot close artifact");
            }
        },
        
        _getArtifactUri: function() {
            var artifactType = this.getArtifactModel().getArtifactType();
            
            switch(artifactType){
                case Constants.TYPE_PLAN:
                    return Utility.getTestPlanURI({id: this.getArtifact().id});   
                case Constants.TYPE_CASE:
                    return Utility.getTestCaseURI(this.getArtifact().id);
                case Constants.TYPE_SCRIPT:
                    return Utility.getTestScriptURI(this.getArtifact().id);
				case Constants.TYPE_SUITE:
                    return Utility.getTestSuiteURI(this.getArtifact().id);
				case Constants.TYPE_KEYWORD:
                    return Utility.getViewKeywordURI(this.getArtifact().itemId);
				case Constants.TYPE_EWI:
					return PlanningUtility.getEwiURI(this.getArtifact().id);
				case Constants.TYPE_SER:
					return PlanningUtility.getSERURI(this.getArtifact().id);
				case Constants.TYPE_SUITE_RESULT:
					return PlanningUtility.getSuiteResultURI(this.getArtifact().id);
                default:
                    break;
            }
            return null;      
        },
		
		_onChange: function() {
			//console.debug("dirty");
			this.localEditorDirty = true;
            this.setDirty(true);
		},
        
        _onTitleChange: function() {
            this._titleModified = true;
            this._onChange();
        },
		
        _onCurrentRevisionClick: function() {
            if (dojo.isFunction(this.onCurrentRevision) && this.getArtifact()) {
				this.onCurrentRevision(this.getArtifactType(), this.getArtifact().id);
			}
        },		
        
        _initPermissionsAndPreferences: function() {
            var artifactType = this.getArtifactType();
            var operationId = this.mapArtifactTypeToOperationId(artifactType);
            var snapshotOperation =  this.mapArtifactTypeToOperationSnapshotId(artifactType);
			// load permissions
            if (operationId) {
                var permission = PermissionsClient.getStoredPermission(operationId);                
                if (permission) {
                    this.setRolePermitsEdit(permission[PermissionsClient.ACTION_EDIT]);
                    this.setRolePermitsArchive(permission[PermissionsClient.ACTION_EDIT]);
					this.setRolePermitsLock(permission[PermissionsClient.ACTION_LOCK]);
					this.setRolePermitsUnlock(permission[PermissionsClient.ACTION_UNLOCK]);
					this.setRolePermitsCreateSection(permission[PermissionsClient.ACTION_CREATE_SECTION]);
					this.setReadOnly(!this.isRolePermitsEdit());
                }
            }                        
            
            if(snapshotOperation){
            	var snapPermission = PermissionsClient.getStoredPermission(snapshotOperation);
            	if(snapPermission){
            		this.setRolePermitsSnapshot(snapPermission[PermissionsClient.ACTION_CREATE]);            		
            	}
            }            
        },
        
        _loadError: function(e) {
            // this.domNode should be defined to use the error page but just in case use the header domNode
            var pageDomNode = this.domNode || (this.getHeader() ? this.getHeader().domNode : null);
            var artifactType = this.getArtifactType();
            if (!artifactType) {
            	artifactType = Constants.getMessage("labelArtifactLowerCase");
            }
            com.ibm.asq.common.web.ui.internal.util.Utility.handleArtifactLoadError(artifactType, e.message, pageDomNode);
        },
        
		getSectionNameByWorkItem: function(/*workitem url*/ url){
			var artifact = this.getArtifact();
			var workItems = artifact.workItems ? artifact.workItems : [];
			var len = workItems.length;
			for(var i=0; i<len; i++){
				if(url == workItems[i].summary){
					return this.getSectionNameBySectionId(workItems[i].section);
				}
			}
			
		},
		getSectionNameBySectionId: function(sectionId){
			var artifact = this.getArtifact();
			var sections = artifact.sections? artifact.sections: [];
			if(!sectionId || sectionId=="")
				return "";
			var len = sections.length;
			for(var i=0;i<len; i++){
				if(sections[i].id == sectionId){
					return Constants.getMessage(sections[i].name);
				}
			}
			
		},
		
		// Summary:
	    //    Given an artifact type, returns the id of the save operation for it.
	    //
	    mapArtifactTypeToOperationId: function(artifactType) {
            switch(artifactType){
                case Constants.TYPE_PLAN: return PermissionsClient.OP_TEST_PLAN;  
                case Constants.TYPE_CASE: return PermissionsClient.OP_TEST_CASE;
                case Constants.TYPE_DATAPOOL: return PermissionsClient.OP_DATAPOOL;
                case Constants.TYPE_SCRIPT: return PermissionsClient.OP_TEST_SCRIPT;
                case Constants.TYPE_SUITE: return PermissionsClient.OP_TEST_SUITE;
                case Constants.TYPE_KEYWORD: return PermissionsClient.OP_KEYWORD;
                case Constants.MODEL_TYPE_TESTCASE_EXECUTION_RECORD: return PermissionsClient.OP_EXECUTION_EWI;
                case Constants.MODEL_TYPE_SUITE_EXECUTION_RECORD: return PermissionsClient.OP_EXECUTION_TSER;
                case Constants.MODEL_TYPE_SUITE_LOG: return PermissionsClient.OP_SUITE_RESULT;
            }
            return null;
	    },
	    
	    mapArtifactTypeToOperationSnapshotId: function(artifactType) {
            switch(artifactType){
                case Constants.TYPE_PLAN: return PermissionsClient.ACTION_CREATE_SNAPSHOT_PLAN;  
                case Constants.TYPE_CASE: return PermissionsClient.ACTION_CREATE_SNAPSHOT_CASE;               
                case Constants.TYPE_SCRIPT: return PermissionsClient.ACTION_CREATE_SNAPSHOT_SCRIPT;
                case Constants.TYPE_SUITE: return PermissionsClient.ACTION_CREATE_SNAPSHOT_PLAN_SUITE;
            }
            return null;
	    },
		
		isWorkItemAllClosed: function(callback, soft) {
			
			var artifactType = this.getArtifactType();
			var isUnderReview = WorkflowManager.stateBelongsToUnderReview(this.getStateValue(), artifactType);
			if (!soft && !isUnderReview) {
				callback();
				return;
			}
			
			ConstraintsUtil.isConstraintEnabled(ConstraintsUtil.ReadyForReview, artifactType, this.getTeamAreaItemId(), dojo.hitch(this, function(isConstraintEnabled) {
				
				if (!isConstraintEnabled) {
					callback();
					return;
				}
				
				var artifact = this.getArtifact();
				var workItems = artifact && artifact.workItems || [];
				
				WorkItemUtils.getNotClosedWorkItems(workItems, 
					/* callback: */ 
					dojo.hitch(this, function(unClosedWIs) {
						var count = unClosedWIs.length;
						if (count > 0) {
	                        // convert the array of URLs to HTML string of links
	                        var workitemsString = "";
	                        // with no display info in the URL use "Work Item %1" as the labels
	                        for (var i = 0; i < count; i++) {
	                            if (i > 0) {
	                                workitemsString += ", ";
	                            }
	                            var link = "<a href='" + unClosedWIs[i] + "' target=_blank>" + this.getSectionNameByWorkItem(unClosedWIs[i]) + "</a>";
	                            workitemsString += link;
	                        }
							var errorMessage = Constants.getMessage("msgCanNotUnderReview", workitemsString);
							if (!soft) {
								this.setHeaderStatus(errorMessage, Constants.HEADER_STATUS_ERROR, errorMessage);
							} else {
								callback(errorMessage);
							}
						} else {
							callback();
						}
					}), 
					/* errorCallback: */ 
					dojo.hitch(this, function(error) {
	                    console.debug(error);
						this.setHeaderStatus(error, Constants.HEADER_STATUS_ERROR, error);
	                })
                );
			}));
		},
		
		// Provides maximize control API for sections that need maximize support
		maximizeCenterContent: function(maximize, sectionId) {
		    var header = this.getHeader();
		    header.maximizeContentArea(maximize, true);
		    
		    var showAll = (this._tocWidget && this._tocWidget.showAll)? this._tocWidget.showAll: false;
		    if(showAll){
		        this.setSectionDisplayMode(showAll && !maximize, sectionId);	
		    }
		    this.inMaximize = maximize;
		    this.maximizedSectionId = maximize ? sectionId : null;
		},
		
		updateWorkflowIconNode: function(node, icon, isAction) {
			var newImg = null;
			if (icon) {
				newImg = dojo.create("img", {
					src: icon,
					alt : "",
					className: "attributes-entry-label",
					style: {
						height: "16px",
						width: "16px"
					}
				});
			} else {
				newImg = dojo.create("span", {
					style: {
						height: "16px",
						width: "16px"
					}
				});
			}
			var style = dojo.style;
			if (isAction) {
				style(node, "float", "right");
			} else {
				style(node, "verticalAlign", "top");
				style(node, "clear", "both");
			}
			dojo.empty(node);
			node.appendChild(newImg);
		}
        
    });
    
})();
