<?xml version="1.0" encoding="utf-8"?>
<!-- 
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xalan="http://xml.apache.org/xalan"
    xmlns:rqm="http://jazz.net/xmlns/alm/qm/v0.1/"
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:alm="http://jazz.net/xmlns/alm/v0.1/"
    xmlns:result="http://jazz.net/xmlns/alm/qm/v0.1/executionresult/v0.1"
    xmlns:exslt="http://exslt.org/common"
    xmlns:HttpClientExtension="com.ibm.rqm.print.render.fop.xml.xslt.extension.http.HttpClientExtension"
    xmlns:proxy="com.ibm.rqm.print.render.fop.xml.xslt.extension.proxy.TestsuiteLogProxy"
    xmlns:log="xalan://com.ibm.rqm.print.render.fop.xml.xslt.extension.LoggingExtension"
    xmlns:utils="xalan://com.ibm.rqm.print.render.fop.xml.xslt.extension.UtilsExtension"
    exclude-result-prefixes="xsl xalan rqm dc alm result exslt HttpClientExtension proxy log">
    
    <!-- included stylesheets -->
    <xsl:import  href="cache://stylesheets/prep/abstract-prep-handler.xsl"/>
    <xsl:include href="cache://stylesheets/_util/replaceAll.xsl"/>
    
    <!-- params -->
    <xsl:param name="artifact"/>
    <xsl:param name="repoService"/>
    <xsl:param name="exeResultService"/>
    <xsl:param name="catTypeRestService"/>
    
    <!-- proxy definition -->
    <xalan:component prefix="proxy">
        <xalan:script lang="javaclass" src="xalan://com.ibm.rqm.print.render.fop.xml.xslt.extension.proxy.TestsuiteLogProxy"/>
    </xalan:component>
    
    <xsl:variable name="item" select="proxy:new($artifact, $repoService, $exeResultService, $catTypeRestService)"/>
     
    <!-- templates -->
    <xsl:template match="rqm:testsuitelog">
        <xsl:copy>
        	<xsl:apply-templates select="*"/>
            <xsl:apply-templates mode="expand" select="rqm:testphase"/>
            <xsl:apply-templates mode="expand" select="rqm:buildrecord"/>
        </xsl:copy>
    </xsl:template>
        
    <xsl:template mode="expand" match="rqm:testphase">
        <xsl:copy-of select="HttpClientExtension:get($restClient, @href, 'fields=feed/entry/content/testphase/(identifier|webId|title)')"/>
    </xsl:template>
    
    <xsl:template mode="expand" match="rqm:buildrecord[@href]">
        
        <xsl:copy-of select="HttpClientExtension:get($restClient, @href, 'fields=feed/entry/content/buildrecord/(identifier|title|webId)')"/>

		<!-- Resolve the build definition associated with the build record: -->
		<xsl:variable name="buildDefinitionFeed">
            
            <xsl:variable name="buildRecordFilter">buildrecord[@href="<xsl:value-of select="utils:encodeUri( @href)"/>"]</xsl:variable>
            
            <xsl:call-template name="restGET">
                <xsl:with-param name="path"  select="'../builddefinition'"/>
                <xsl:with-param name="query" select="concat('fields=/feed/entry/content/builddefinition/(', $buildRecordFilter, '|identifier|title)')"/>
            </xsl:call-template>    
        </xsl:variable>
        
        <xsl:copy-of select="exslt:node-set($buildDefinitionFeed)//rqm:builddefinition"/>
    </xsl:template>
</xsl:stylesheet>