/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.web.ui.internal.common.viewer.plan.DropDownCell");

dojo.require("com.ibm.jdojo.lang.Runtime");
dojo.require("com.ibm.team.apt.web.client.internal.items.process.Iteration");
dojo.require("com.ibm.team.apt.web.client.internal.items.workitem.Category");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.AttributeCell");
dojo.require("com.ibm.team.apt.web.ui.internal.widgets.ListSelectionDialogContent");
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.GridMenu");
dojo.require("dojo.i18n");
dojo.require("jazz.ui.Dialog");

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal.common.viewer.plan", "Messages");

(function() {
var Messages= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal.common.viewer.plan", "Messages");

var jdojo= com.ibm.jdojo.lang.Runtime;
var team= com.ibm.team;
var web= team.apt.web;
var items= web.client.internal.items;
var Iteration= items.process.Iteration;
var Category= items.workitem.Category;
var internal= web.ui.internal;
var AttributeCell= internal.common.viewer.plan.AttributeCell;
var ListSelectionDialogContent= internal.widgets.ListSelectionDialogContent;
var GridMenu= team.rtc.foundation.web.ui.gridviewer.GridMenu;
var keys= dojo.keys;
var Dialog= jazz.ui.Dialog;

var DropDownCell= dojo.declare("com.ibm.team.apt.web.ui.internal.common.viewer.plan.DropDownCell", AttributeCell, {

	//fContainer: null,

	//fSelectionDialog: null,

	//fDialog: null,

	constructor: function(attribute, column, rowEntry, viewer) {
		this.inherited(arguments, [attribute, column, rowEntry, viewer]);
	},

	doCreateCellContent: function(cellContainer) {
		this.fContainer= dojo.create("div", null, cellContainer);
		if (this.isDropDownEnabled()) {
			dojo.addClass(this.fContainer, DropDownCell.DROP_DOWN_CONTAINER_CLASS);
		}
		this.inherited("doCreateCellContent", arguments, [this.fContainer]);
	},

	isDropDownEnabled: function() {
		return !this.isReadOnly();
	},

	onMouseClick: function(event) {
		if (!this.isDropDownEnabled() || this.isReadOnly()) {
			return true;
		}
		var gridMenu= new GridMenu(this.fViewer);
		this.doFillGridMenu(gridMenu);
		gridMenu.open(this);
		return true;
	},

	getNullValue: function() {
		var valueSet= this.fAttribute.getValueSet(this.fRowEntry.getElement());
		return valueSet.getNullValue();
	},

	doFillGridMenu: function(menu) {
		var valueSet= this.fAttribute.getValueSet(this.fRowEntry.getElement());
		var allValues= valueSet.getAllValues();
		var nullValue= this.getNullValue();
		var shouldAddNullValue= nullValue != null && jdojo.implementsInterface(nullValue, "com.ibm.team.apt.api.common.IUIItem") && dojo.indexOf(allValues, nullValue) === -1;
		var count= 0, max= DropDownCell.MAXIMUM_SIZE - (shouldAddNullValue ? 0 : 1);
		var shouldAddMoreValue= allValues.length > max;
		var $subject= allValues;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var value= $subject[$count];
			if (jdojo.implementsInterface(value, "com.ibm.team.apt.api.common.IUIItem")) {
				if (++count > DropDownCell.MAXIMUM_SIZE) {
					break;
				}
				if ((value instanceof Iteration) && !value.hasDeliverable()) {
					continue;
				}
				if ((value instanceof Category) && value.isArchived()) {
					continue;
				}
				this.addMenuEntry(menu, value);
			}
		}
		if (shouldAddNullValue) {
			this.addMenuEntry(menu, nullValue);
			allValues= allValues.concat(nullValue);
		}
		if (shouldAddMoreValue) {
			var dialogValues= allValues;
			menu.addEntry(null, Messages.DropDownCell_MORE_ITEMS, null, dojo.hitch(this, function() {
				var listSelectionParams= {};
				listSelectionParams.fIsMultiselect= false;
				listSelectionParams.fItems= dialogValues;
				listSelectionParams.fOnCancel= dojo.hitch(this, function() {
					if (this.fDialog != null) {
						this.fDialog.close(null);
						this.fDialog.destroy(false);
					}
					if (this.fSelectionDialog != null) 
						this.fSelectionDialog.destroy(false);
					return false;
				});
				listSelectionParams.fOnOK= dojo.hitch(this, function() {
					if (this.fSelectionDialog != null) {
						var selection= this.fSelectionDialog.getSelection();
						if (selection.length !== 1) 
							return false;
						var planElement= this.fRowEntry.getElement();
						planElement.setAttributeValue(this.fAttribute, selection[0]);
					}
					listSelectionParams.fOnCancel();
					return false;
				});
				this.fSelectionDialog= new ListSelectionDialogContent(listSelectionParams);
				var dialogParams= {};
				dialogParams.primaryTitle= this.fAttribute.getDescription().getLabel();
				dialogParams.closable= true;
				dialogParams.closeOnEsc= true;
				dialogParams.onOpen= dojo.hitch(this, function() {
					if (this.fSelectionDialog != null) 
						this.fSelectionDialog.focus();
					return false;
				});
				dialogParams.contentNode= this.fSelectionDialog.domNode;
				this.fDialog= new Dialog(dialogParams);
			}));
		}
	},

	addMenuEntry: function(menu, uiItem) {
		menu.addEntry(uiItem.getItemId(), uiItem.getLabel(), uiItem.getIconUri(), dojo.hitch(this, function() {
			var planElement= this.fRowEntry.getElement();
			planElement.setAttributeValue(this.fAttribute, uiItem);
		}));
	},

	onMouseEnter: function(element) {
		if (!this.isReadOnly()) {
			dojo.addClass(this.fContainer, "hover");
		}
		return true;
	},

	onMouseLeave: function(element) {
		if (!this.isReadOnly()) {
			dojo.removeClass(this.fContainer, "hover");
		}
		return true;
	},

	onKeyDown: function(event) {
		if (event.keyCode === keys.F2 || event.keyCode === keys.ENTER) {
			if (!this.isDropDownEnabled() || this.isReadOnly()) 
				return true;
			var gridMenu= new GridMenu(this.fViewer);
			this.doFillGridMenu(gridMenu);
			gridMenu.open(this);
			event.preventDefault();
			return true;
		}
		return false;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IKeyboardHandler': true,
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IMouseClickHandler': true,
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IMouseOverListener': true
	}
});

DropDownCell.MAXIMUM_SIZE= 10;
DropDownCell.DROP_DOWN_CONTAINER_CLASS= "dropdown";

})();
