/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.views.ArtifactListView"); //$NON-NLS-1$

dojo.require("com.ibm.jdojox.util.ArrayList"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.Destroyable"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.EventSource"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.model.Bindable"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.model.Bindings"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.model.Label"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.model.ListBindings"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.Theme"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.util.Sprites"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.util.animations.Animations"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.util.sprite.ImageSource"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.views.ImagePool"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.views.View"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.views.controller.CLabel"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.views.controller.Defaults"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.rtc.foundation.web.ui.views", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var Messages= dojo.i18n.getLocalization("com.ibm.team.rtc.foundation.web.ui.views", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

var ArrayList= com.ibm.jdojox.util.ArrayList;
var web= com.ibm.team.rtc.foundation.web;
var Destroyable= web.Destroyable;
var EventSource= web.EventSource;
var model2= web.model;
var Bindable= model2.Bindable;
var Bindings= model2.Bindings;
var Label= model2.Label;
var ListBindings= model2.ListBindings;
var ui= web.ui;
var Theme= ui.Theme;
var util= ui.util;
var Sprites= util.Sprites;
var Animations= util.animations.Animations;
var ImageSource= util.sprite.ImageSource;
var views= ui.views;
var ImagePool= views.ImagePool;
var View= views.View;
var controller= views.controller;
var CLabel= controller.CLabel;
var Defaults= controller.Defaults;
var keys= dojo.keys;

var ArtifactListView= dojo.declare("com.ibm.team.rtc.foundation.web.ui.views.ArtifactListView", View, { //$NON-NLS-1$

	templatePath: dojo.moduleUrl("com.ibm.team.rtc.foundation.web.ui", "views/templates/ArtifactListView.html"), //$NON-NLS-1$ //$NON-NLS-2$

	//_messages: null,

	//valueAdded: null,

	//valueRemoved: null,

	//valueModified: null,

	//_valueNode: null,

	//_statusNode: null,

	//_headerNode: null,

	//_listFooter: null,

	//_valueElements: null,

	//_isEditable: null,

	//_isShown: null,

	//_noValues: null,

	constructor: function(params, parentDom) {
		this._messages= Messages;
		this.valueAdded= new EventSource();
		this.valueRemoved= new EventSource();
		this.valueModified= new EventSource();
		this._valueElements= new ArrayList();
		this._isEditable= false;
		this._isShown= true;
		this._noValues= Messages.ArtifactListView_NO_VALUES;
	},

	postCreate: function() {
		this.inherited("postCreate", arguments, []); //$NON-NLS-1$
		this.connect(this._headerNode, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			this.wipe(!this._isShown);
		}));
		this.own(Bindings.bindWithHandler(this._model().readOnly, dojo.hitch(this, function(isReadOnly) {
			dojo.toggleClass(this.domNode, "DynamicReadOnly", isReadOnly); //$NON-NLS-1$
		})));
		this.own(Bindings.bindWithHandler(this._model().compact, dojo.hitch(this, function(compact) {
			dojo.toggleClass(this.domNode, Theme.border, compact);
			dojo.toggleClass(this.domNode, "CompactMode", compact); //$NON-NLS-1$
			this._updateActionsWidth();
		})));
		this.own(Bindings.bindWithHandler(this._model().header, dojo.hitch(this, function(header) {
			if (header.getLabel() === "") { //$NON-NLS-1$
				return ;
			}
			var fragment= dojo.doc.createDocumentFragment();
			if (header.getIconUrl() != null) {
				fragment.appendChild(Sprites.create(ImageSource.fromIconUri(header.getIconUrl()), {className: "AnchorIcon"})); //$NON-NLS-1$
			}
			fragment.appendChild(dojo.doc.createTextNode(header.getLabel()));
			dojo.place(fragment, this._headerNode, 'only'); //$NON-NLS-1$
			dojo.addClass(this.domNode, "Collapsible"); //$NON-NLS-1$
		})));
		this.own(ListBindings.bindWithHandler(this._model().values, dojo.hitch(this, function(callbackArg) {
			switch(callbackArg.type) {
				case 'insert': //$NON-NLS-1$
					var documentFragment= dojo.doc.createDocumentFragment();
					for (var i= 0; i < callbackArg.count; i++){
						var index= callbackArg.index + i;
						documentFragment.appendChild(this._createValueElement(index, this._model().values.at(index)).parent);
					}
					if (callbackArg.index < this._valueNode.childNodes.length) {
						this._valueNode.insertBefore(documentFragment, this._valueNode.childNodes.item(callbackArg.index));
					} else {
						this._valueNode.appendChild(documentFragment);
					}
					break;
				case 'modify': //$NON-NLS-1$
					this._valueElements.at(callbackArg.index).setValue(this._model().values.at(callbackArg.index));
					break;
				case 'remove': //$NON-NLS-1$
					for (var i= callbackArg.count - 1; i >= 0; i--){
						this._remove(callbackArg.index + i);
					}
					break;
				default:
					break;
			}
			this._updateStatus();
			this.wipe(true);
		})));
	},

	wipe: function(expand) {
		if (expand === this._isShown) {
			return ;
		}
		this._isShown= expand;
		Animations.fx().wipe('height', expand).play(this._valueNode); //$NON-NLS-1$
		dojo.toggleClass(this.domNode, "Shown", expand); //$NON-NLS-1$
	},

	showInlineAddAction: function() {
		this.addAction(ImagePool.EDIT, Messages.ArtifactListView_CREATE_NEW_VALUE, dojo.hitch(this, function() {
			this.valueAdded.fire(new Label("")); //$NON-NLS-1$
			var valueElement= this._valueElements.at(this._valueElements.size() - 1);
			if (!this._isEditable) {
				this._connectEdit(valueElement);
			}
			valueElement.setEditable(true);
		}));
	},

	addAction: function(actionIcon, actionName, actionInvoked) {
		var actionElement= dojo.create("div", {className: "AnchorCommand", tabIndex: "0"}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		var fragment= dojo.doc.createDocumentFragment();
		this.connect(actionElement, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			dojo.stopEvent(event);
			if (!this._model().readOnly.getValue()) {
				actionInvoked();
			}
		}));
		this.connect(actionElement, 'keyup', dojo.hitch(this, function(event) { //$NON-NLS-1$
			if (event.keyCode === keys.ENTER || event.keyCode === keys.SPACE) {
				dojo.stopEvent(event);
				if (!this._model().readOnly.getValue()) {
					actionInvoked();
				}
			}
		}));
		if (actionIcon != null) {
			fragment.appendChild(Sprites.create(actionIcon, {className: "AnchorIcon"})); //$NON-NLS-1$
		}
		fragment.appendChild(dojo.doc.createTextNode(actionName));
		actionElement.appendChild(fragment);
		dojo.place(actionElement, this._listFooter, 'first'); //$NON-NLS-1$
		this._updateActionsWidth();
	},

	_updateActionsWidth: function() {
		var children= this._listFooter.childNodes;
		var actionWidth= Math.floor(((100 / children.length)|0)) + "%"; //$NON-NLS-1$
		for (var i= 0; i < children.length; i++){
			var child= children.item(i);
			child.style.width= this._model().compact.getValue() ? actionWidth : ""; //$NON-NLS-1$
		}
	},

	setEditable: function(editable) {
		this._isEditable= editable;
		dojo.toggleClass(this._valueNode, "Editable", editable); //$NON-NLS-1$
	},

	_updateStatus: function() {
		dojo.place(dojo.doc.createTextNode(this._model().values.size() > 0 ? "" : this._noValues), this._statusNode, 'only'); //$NON-NLS-1$ //$NON-NLS-2$
	},

	_createValueElement: function(index, initialValue) {
		var valueElement= this.own(new ValueElement(initialValue))[0];
		this.connect(valueElement.removeIcon, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			dojo.stopEvent(event);
			this.valueRemoved.fire({index: this._valueElements.indexOf(valueElement)});
		}));
		if (this._isEditable) {
			this._connectEdit(valueElement);
		}
		this._valueElements.addAt(index, valueElement);
		return valueElement;
	},

	_connectEdit: function(valueElement) {
		var index= dojo.hitch(this, function() {
			return this._valueElements.indexOf(valueElement);
		});
		this.connect(valueElement.parent, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			if (this._model().readOnly.getValue() || !this._isEditable) {
				return ;
			}
			valueElement.setEditable(true);
		}));
		this.connect(valueElement.input, 'blur', dojo.hitch(this, function(event) { //$NON-NLS-1$
			var newValue= valueElement.input.value;
			var value= index();
			if (dojo.isChrome && value === -1) {
				return ;
			}
			valueElement.setEditable(false);
			if (newValue === "") { //$NON-NLS-1$
				this.valueRemoved.fire({index: value});
			} else if (newValue !== valueElement.value.getValue().getLabel()) {
				this.valueModified.fire({index: value, value: new Label(newValue)});
			}
		}));
		this.connect(valueElement.input, 'keyup', function(event) { //$NON-NLS-1$
			dojo.stopEvent(event);
		});
		this.connect(valueElement.input, 'keydown', dojo.hitch(this, function(event) { //$NON-NLS-1$
			switch(event.keyCode) {
				case keys.DOWN_ARROW:
				case keys.UP_ARROW:
				case keys.TAB:
				case keys.ENTER:
					if (this._isEditable) {
						var currentIndex= index();
						if ((event.shiftKey && event.keyCode === keys.TAB) || event.keyCode === keys.UP_ARROW) {
							if (currentIndex > 0) {
								dojo.stopEvent(event);
								this._valueElements.at(currentIndex - 1).setEditable(true);
							}
						} else if (currentIndex < this._valueElements.size() - 1) {
							dojo.stopEvent(event);
							this._valueElements.at(currentIndex + 1).setEditable(true);
						}
						break;
					}
				case keys.ESCAPE:
					valueElement.setEditable(false);
					break;
				default:
					break;
			}
		}));
	},

	_remove: function(index) {
		var toRemove= this._valueElements.removeAt(index);
		toRemove.destroy();
		this._valueNode.removeChild(toRemove.parent);
	},

	_empty: function() {
		for (var $it= this._valueElements.iterator(); $it.hasNext();) {
			var valueElement= $it.next();
			this._valueNode.removeChild(valueElement.parent);
		}
		dojo.empty(this._valueNode);
		this._valueElements= new ArrayList();
	},

	destroy: function(preserveDom) {
		if (!this._destroyed) {
			this._empty();
		}
		this.inherited("destroy", arguments, [preserveDom]); //$NON-NLS-1$
	},

	_model: function() {
		return this.inherited("_model", arguments, []); //$NON-NLS-1$
	}
});
var ValueElement= dojo.declare("com.ibm.team.rtc.foundation.web.ui.views.ArtifactListView.ValueElement", Destroyable, { //$NON-NLS-1$

	//parent: null,

	//input: null,

	//removeIcon: null,

	//value: null,

	//_isEditable: null,

	constructor: function(labelElement) {
		this.inherited(arguments, []);
		this.value= new Bindable(labelElement);
		this.parent= dojo.create("div", {className: "ValueDiv"}); //$NON-NLS-1$ //$NON-NLS-2$
		this.input= dojo.create("input", {className: "ValueInput"}, null); //$NON-NLS-1$ //$NON-NLS-2$
		this.removeIcon= dojo.create("span", {className: "ValueIcon " + ValueElement._deleteIconClass, title: Messages.ArtifactListView_DELETE}, null); //$NON-NLS-1$ //$NON-NLS-2$
		var label= this.own(CLabel.create().renderer(Defaults.renderer()).value(this.value).compact(new Bindable(true)).bind());
		var labelView= label.getView().domNode;
		dojo.addClass(labelView, "ValueElement"); //$NON-NLS-1$
		var fragment= dojo.doc.createDocumentFragment();
		fragment.appendChild(labelView);
		fragment.appendChild(this.input);
		fragment.appendChild(this.removeIcon);
		dojo.place(fragment, this.parent, 'only'); //$NON-NLS-1$
		this.setValue(labelElement);
	},

	setValue: function(newValue) {
		this.value.setValue(newValue);
		this.input.value= newValue.getLabel();
	},

	setEditable: function(editable) {
		if (editable === this._isEditable) {
			return ;
		}
		this._isEditable= editable;
		dojo.toggleClass(this.parent, "Editable", editable); //$NON-NLS-1$
		if (editable) {
			this.input.focus();
			this.input.selectionEnd= this.input.selectionStart= this.input.value.length;
		}
	}
});

ArtifactListView.NEW_VALUE= ""; //$NON-NLS-1$
ValueElement._deleteIconClass= Sprites.cssClassName(ImagePool.REMOVE);

})();
