/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2009, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.scm.web.ui.internal.page.ScmPageController");

dojo.require("com.ibm.jdojo.util.Assert");
dojo.require("com.ibm.team.repository.web.client.internal.AdminClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.scm.web.client.internal.ScmClient");
dojo.require("com.ibm.team.scm.web.client.util");
dojo.require("com.ibm.team.scm.web.client.utilNative");
dojo.require("dojo.string");
dojo.require("net.jazz.ajax.ui.PlatformUI");

(function() {
var Assert= com.ibm.jdojo.util.Assert;
var team= com.ibm.team;
var web= team.repository.web;
var AdminClient= web.client.internal.AdminClient;
var ServiceResponseHandler= web.transport.ServiceResponseHandler;
var client= team.scm.web.client;
var ScmClient= client.internal.ScmClient;
var util= client.util;
var utilNative= client.utilNative;
var PlatformUI= net.jazz.ajax.ui.PlatformUI;

dojo.declare("com.ibm.team.scm.web.ui.internal.page.ScmPageController", null, {
	"-chains-": { constructor: "manual" },

	//contextChangesetPair: null,

	//DEFAULT_PAGE_SIZE: null,

	//messages: null,

	//_view: null,

	//_currentOperation: null,

	//_streamList: null,

	//view: null,

	constructor: function(params) {
		this.contextChangesetPair= {};
		this.DEFAULT_PAGE_SIZE= 25;
		this.messages= utilNative.messages;
		this._view= params.scmView;
		this._streamList= [];
	},

	createOperation: function(name, id) {
		if (!(name != null)) Assert.fail("name != null", "ScmPageController:108");
		if (!(id != null)) Assert.fail("id != null", "ScmPageController:109");
		var result= {};
		result.name= name;
		result.id= id;
		return result;
	},

	startOperation: function(operation) {
		this._currentOperation= operation;
		PlatformUI.getWorkbench().showMessage(operation.name);
	},

	finishOperation: function(operation) {
		if (operation != null && operation === this._currentOperation) {
			PlatformUI.getWorkbench().hideMessageArea();
			this._currentOperation= null;
		}
	},

	_setPageTitle: function(title) {
		PlatformUI.getWorkbench().setTitle(title);
	},

	_setHistoryPageSize: function(n) {
		this._view.setHistoryPageSize(n);
	},

	_handleError: function(message) {
		this._view.displayError(message);
	},

	displayPageStatusMessage: function(message, statusType, parentNode) {
		this._view.displayStatusMessage(message, statusType, parentNode);
	},

	clearStatusMessage: function() {
		this._view.clearStatusMessage();
	},

	showWorkspaces: function() {
		this._view.showWorkspacesLandingPage();
	},

	showStreams: function() {
		this._view.showStreamsLandingPage();
	},

	showLocks: function() {
		this._view.showLocksLandingPage();
	},

	advancedSearch: function(kwArgs) {
		this._view.showSearchPage(kwArgs);
	},

	runSearch: function(kwArgs) {
		this._view.showSearchResultPage(kwArgs);
	},

	welcome: function(params) {
		this.reset(this.contextChangesetPair);
		this._setPageTitle(this.messages.ScmPageController_0);
		this._view._showMainPage(params);
	},

	browseStream: function(kwArgs) {
		var params= {};
		params.contextType= "com.ibm.team.scm.Stream";
		params.contextItemId= kwArgs.id;
		params.tab= kwArgs.tab;
		this._view.showContextView(params);
	},

	browseWorkspace: function(kwArgs) {
		var params= {};
		params.contextType= "com.ibm.team.scm.Workspace";
		params.contextItemId= kwArgs.id;
		params.tab= kwArgs.tab;
		this._view.showContextView(params);
	},

	browseSnapshot: function(kwArgs) {
		var params= {};
		params.contextType= "com.ibm.team.scm.BaselineSet";
		params.contextItemId= kwArgs.id;
		params.ownerId= kwArgs.ownerId;
		params.ownerType= kwArgs.ownerType;
		params.tab= kwArgs.tab;
		this._view.showContextView(params);
	},

	test: function() {
		this._view.showTestView();
	},

	compareContexts: function(kwArgs) {
		var params= {};
		params.itemId1= kwArgs.itemId1;
		params.itemId2= kwArgs.itemId2;
		params.itemType1= kwArgs.itemType1;
		params.itemType2= kwArgs.itemType2;
		params.itemOwner1= kwArgs.itemOwner1;
		params.itemOwner2= kwArgs.itemOwner2;
		params.ownerType1= kwArgs.ownerType1;
		params.ownerType2= kwArgs.ownerType2;
		this._view.showCompareContextsView(params);
	},

	browseElement: function(kwArgs) {
		if (!(kwArgs != null)) Assert.fail("kwArgs != null", "ScmPageController:299");
		if (!(kwArgs.componentItemId != null)) Assert.fail("kwArgs.componentItemId != null", "ScmPageController:300");
		if (!(kwArgs.path != null || kwArgs.itemId != null)) Assert.fail("kwArgs.path != null || kwArgs.itemId != null", "ScmPageController:301");
		this.reset(this.contextChangesetPair);
		var vpArgs= {};
		vpArgs.componentItemId= kwArgs.componentItemId;
		vpArgs.path= kwArgs.path;
		vpArgs.itemId= kwArgs.itemId;
		vpArgs.itemType= kwArgs.itemType;
		if (kwArgs.workspaceItemId !== undefined) {
			vpArgs.workspaceItemId= kwArgs.workspaceItemId;
		}
		if (kwArgs.snapshotItemId !== undefined) {
			vpArgs.snapshotItemId= kwArgs.snapshotItemId;
		}
		var tabArgs= {};
		if (kwArgs.tab !== undefined) 
			tabArgs.tab= kwArgs.tab;
		if (kwArgs.n !== undefined) 
			tabArgs.n= kwArgs.n;
		if (kwArgs.first !== undefined) 
			tabArgs.first= kwArgs.first;
		if (kwArgs.last !== undefined) 
			tabArgs.last= kwArgs.last;
		var op= this.createOperation(this.messages.ScmPageController_30, "browse item, view content");
		this.startOperation(op);
		var responseHandler= new ServiceResponseHandler({'onSuccess': dojo.hitch(this, function(versionablePlusDTO) {
			var subElements= versionablePlusDTO.versionableDTO;
			versionablePlusDTO.versionableDTO= null;
			subElements.versionablePlusDTO= versionablePlusDTO;
			if (vpArgs.path !== "/") {
				this._setPageTitle(subElements.versionable.name);
				this._displayElement(subElements, "item", tabArgs);
			} else {
				this._setPageTitle(subElements.component.name);
				this._displayElement(subElements, "component", tabArgs);
			}
			this.finishOperation(op);
		}), 'onFailure': dojo.hitch(this, function(error) {
			if (error.message !== "") {
				this._handleError(dojo.string.substitute(this.messages.ScmPageController_12, [error.message, "" + error.status]));
			} else {
				this._handleError(this.messages.ScmPageController_13);
			}
			this.finishOperation(op);
		})}, 'onSuccess', 'onFailure');
		ScmClient.getVersionablePlus(responseHandler, ScmClient.createVersionablePath(vpArgs));
	},

	reset: function(pair) {
		pair.contextItemId= null;
		pair.contextItemType= null;
		pair.changesetId= null;
	},

	viewComponent: function(kwArgs) {
		if (!(kwArgs.itemId != null)) Assert.fail("kwArgs.itemId != null", "ScmPageController:383");
		var params= {};
		params.itemId= kwArgs.itemId;
		params.name= kwArgs.name;
		params.owner= kwArgs.owner;
		this._view.showComponent(params);
	},

	viewComponentHistory: function(kwArgs) {
		if (!(kwArgs != null)) Assert.fail("kwArgs != null", "ScmPageController:405");
		if (!(kwArgs.workspaceItemId != null)) Assert.fail("kwArgs.workspaceItemId != null", "ScmPageController:406");
		if (!(kwArgs.componentItemId != null)) Assert.fail("kwArgs.componentItemId != null", "ScmPageController:407");
		this.reset(this.contextChangesetPair);
		var workspaceItemId= kwArgs.workspaceItemId;
		var componentItemId= kwArgs.componentItemId;
		var op= this.createOperation(this.messages.ScmPageController_31, "view component history");
		this.startOperation(op);
		var responseHandler= new ServiceResponseHandler({'onSuccess': dojo.hitch(this, function(historyPlusDTO) {
			if (historyPlusDTO !== undefined) {
				this._setPageTitle(historyPlusDTO.context.name);
				this._displayComponentHistory(historyPlusDTO);
				this.finishOperation(op);
			} else {
				window.alert(dojo.string.substitute(this.messages.ScmPageController_14, [componentItemId]));
			}
		}), 'onFailure': dojo.hitch(this, function(error) {
			if (error.message !== "") {
				this._handleError(dojo.string.substitute(this.messages.ScmPageController_15, [error.message, "" + error.status]));
			} else {
				this._handleError(this.messages.ScmPageController_16);
			}
			this.finishOperation(op);
		})}, 'onSuccess', 'onFailure');
		var extraArgs= {};
		var pageSize= kwArgs.n !== undefined ? kwArgs.n : this.DEFAULT_PAGE_SIZE;
		this._setHistoryPageSize(pageSize);
		extraArgs.n= "" + pageSize;
		if (kwArgs.first !== undefined) {
			extraArgs.first= kwArgs.first;
		}
		if (kwArgs.last !== undefined) {
			extraArgs.last= kwArgs.last;
		}
		var vParms= {};
		vParms.workspaceItemId= workspaceItemId;
		vParms.componentItemId= componentItemId;
		ScmClient.getHistoryPlus(responseHandler, ScmClient.createVersionablePath(vParms), extraArgs);
	},

	viewItemHistory: function(kwArgs) {
		if (!(kwArgs != null)) Assert.fail("kwArgs != null", "ScmPageController:475");
		if (!(kwArgs.workspaceItemId != null)) Assert.fail("kwArgs.workspaceItemId != null", "ScmPageController:476");
		if (!(kwArgs.componentItemId != null)) Assert.fail("kwArgs.componentItemId != null", "ScmPageController:477");
		if (!(kwArgs.oid != null)) Assert.fail("kwArgs.oid != null", "ScmPageController:478");
		this.reset(this.contextChangesetPair);
		var workspaceItemId= kwArgs.workspaceItemId;
		var componentItemId= kwArgs.componentItemId;
		var oid= kwArgs.oid;
		var op= this.createOperation(this.messages.ScmPageController_32, "view item history");
		this.startOperation(op);
		var responseHandler= new ServiceResponseHandler({'onSuccess': dojo.hitch(this, function(historyPlusDTO) {
			if (historyPlusDTO !== undefined) {
				this._setPageTitle(historyPlusDTO.context.name);
				this._displayComponentHistory(historyPlusDTO);
				this.finishOperation(op);
			} else {
				window.alert(dojo.string.substitute(this.messages.ScmPageController_14, [oid]));
			}
		}), 'onFailure': dojo.hitch(this, function(error) {
			if (error.message !== "") {
				this._handleError(dojo.string.substitute(this.messages.ScmPageController_17, [error.message, "" + error.status]));
			} else {
				this._handleError(this.messages.ScmPageController_18);
			}
			this.finishOperation(op);
		})}, 'onSuccess', 'onFailure');
		var vParms= {};
		vParms.workspaceItemId= workspaceItemId;
		vParms.componentItemId= componentItemId;
		ScmClient.getHistoryPlus(responseHandler, ScmClient.createVersionablePath(vParms), null);
	},

	viewChangeSet: function(kwArgs) {
		if (!(kwArgs != null)) Assert.fail("kwArgs != null", "ScmPageController:544");
		if (!(kwArgs.changeSetItemId != null)) Assert.fail("kwArgs.changeSetItemId != null", "ScmPageController:545");
		if (!util.hasValue(kwArgs.contextItemId)) {
			kwArgs.contextItemId= null;
		}
		var contextItemId= kwArgs.contextItemId;
		var contextItemType= kwArgs.contextItemType;
		if (!util.hasValue(contextItemId) && !util.hasValue(contextItemType) && util.hasValue(kwArgs.workspaceItemId)) {
			contextItemId= kwArgs.workspaceItemId;
			contextItemType= util.WORKSPACE_TYPE;
		}
		var changeSetItemId= kwArgs.changeSetItemId;
		var maxChanges= util.hasValue(kwArgs.maxChanges) ? kwArgs.maxChanges : util.MAX_CHANGES;
		if (util.hasValue(kwArgs.diffId) && contextItemId === this.contextChangesetPair.contextItemId && contextItemType === this.contextChangesetPair.contextItemType && changeSetItemId === this.contextChangesetPair.changesetId & !kwArgs.refresh) {
			this._scrollToDiff(kwArgs.diffId);
		} else {
			this.contextChangesetPair.contextItemId= contextItemId;
			this.contextChangesetPair.contextItemType= contextItemType;
			this.contextChangesetPair.changesetId= changeSetItemId;
			var op= this.createOperation(this.messages.ScmPageController_33, "view change set");
			this.startOperation(op);
			var self= this;
			var responseHandler= new ServiceResponseHandler({'onSuccess': dojo.hitch(this, function(changeSetPlusDTO) {
				if (changeSetPlusDTO !== undefined) {
					var changeSetDTO= changeSetPlusDTO.changeSetDTO;
					var title= this.messages.ScmPageController_UnknownWorkspace;
					if (changeSetDTO.workspace !== undefined) {
						title= changeSetDTO.workspace.name;
					}
					this._setPageTitle(title);
					this._displayChangeSet(changeSetPlusDTO, self.contextChangesetPair);
					if (kwArgs.diffId !== undefined) {
						this._scrollToDiff(kwArgs.diffId);
					}
					this.finishOperation(op);
					this._currentOperation= null;
				} else {
					window.alert(dojo.string.substitute(this.messages.ScmPageController_14, [changeSetItemId]));
				}
			}), 'onFailure': dojo.hitch(this, function(error) {
				if (error.message !== "") {
					this._handleError(dojo.string.substitute(this.messages.ScmPageController_19, [error.message, "" + error.status]));
				} else {
					this._handleError(this.messages.ScmPageController_20);
				}
				this.finishOperation(op);
				this._currentOperation= null;
			})}, 'onSuccess', 'onFailure');
			var parms= {};
			parms.contextItemType= contextItemType;
			parms.contextItemId= contextItemId;
			parms.changeSetItemId= changeSetItemId;
			ScmClient.getChangeSetPlus(responseHandler, ScmClient.createChangeSetPath(parms), maxChanges);
		}
	},

	viewChangeSetItem: function(kwArgs) {
		if (!(kwArgs != null)) Assert.fail("kwArgs != null", "ScmPageController:641");
		if (!(kwArgs.componentItemId != null)) Assert.fail("kwArgs.componentItemId != null", "ScmPageController:642");
		if (!(kwArgs.itemType != null)) Assert.fail("kwArgs.itemType != null", "ScmPageController:643");
		if (!(kwArgs.itemId != null)) Assert.fail("kwArgs.itemId != null", "ScmPageController:644");
		this.reset(this.contextChangesetPair);
		var contextItemId= util.hasValue(kwArgs.contextItemId) ? kwArgs.contextItemId : null;
		var contextItemType= util.hasValue(kwArgs.contextItemType) ? kwArgs.contextItemType : null;
		var componentItemId= kwArgs.componentItemId;
		var itemType= kwArgs.itemType;
		var itemId= kwArgs.itemId;
		var oid= itemId;
		var stateId= null;
		if (kwArgs.stateId !== undefined) {
			stateId= kwArgs.stateId;
			oid= oid + "/" + stateId;
		}
		var op= this.createOperation(this.messages.ScmPageController_34, "Open file or folder in changeset");
		this.startOperation(op);
		var responseHandler= new ServiceResponseHandler({'onSuccess': dojo.hitch(this, function(versionablePlusDTO) {
			if (versionablePlusDTO !== undefined) {
				var versionableDTO= versionablePlusDTO.versionableDTO;
				versionablePlusDTO.versionableDTO= null;
				versionableDTO.versionablePlusDTO= versionablePlusDTO;
				var ws= versionableDTO.workspace;
				var title= ws != null ? ws.name : this.messages.ScmPageController_UnknownWorkspace;
				this._setPageTitle(title);
				if (kwArgs.stateId !== undefined) {
					this._displayStateContent(versionableDTO);
				} else {
					this._displayElement(versionableDTO, "item", null);
				}
				this.finishOperation(op);
			} else {
				if (kwArgs.stateId !== undefined) {
					window.alert(dojo.string.substitute(this.messages.ScmPageController_21, [kwArgs.stateId, kwArgs.itemId]));
				} else {
					window.alert(dojo.string.substitute(this.messages.ScmPageController_22, [kwArgs.itemId]));
				}
			}
		}), 'onFailure': dojo.hitch(this, function(error) {
			if (error.message !== "") {
				this._handleError(dojo.string.substitute(this.messages.ScmPageController_23, [error.message, "" + error.status]));
			} else {
				this._handleError(this.messages.ScmPageController_24);
			}
			this.finishOperation(op);
		})}, 'onSuccess', 'onFailure');
		var vParms= {};
		vParms.contextItemId= contextItemId;
		vParms.contextItemType= contextItemType;
		vParms.componentItemId= componentItemId;
		vParms.itemType= itemType;
		vParms.itemId= itemId;
		vParms.itemState= stateId;
		ScmClient.getVersionablePlus(responseHandler, ScmClient.createVersionablePath(vParms));
	},

	updateLockForce: function(kwArgs, force) {
		if (!(kwArgs != null)) Assert.fail("kwArgs != null", "ScmPageController:746");
		if (!(kwArgs.versionableDTO != null)) Assert.fail("kwArgs.versionableDTO != null", "ScmPageController:747");
		var versionableDTO= kwArgs.versionableDTO;
		var operation= "";
		if (versionableDTO.versionable['com.ibm.team.repository.typeName'] === "com.ibm.team.scm.Folder") {
			operation= kwArgs.toLock ? "acquire_subtree" : (force ? "destroy" : "release_subtree");
		} else {
			operation= kwArgs.toLock ? "acquire" : (force ? "destroy" : "release");
		}
		PlatformUI.getWorkbench().showMessage(kwArgs.toLock ? this.messages.StreamWorkspaceView_66 : this.messages.StreamWorkspaceView_67);
		var d= new dojo.Deferred();
		var args= {};
		args.componentId= [versionableDTO.component.itemId];
		args.operation= [operation];
		args.streamId= [versionableDTO.workspace.itemId];
		args.versionableNamespace= ["com.ibm.team.filesystem"];
		args.versionableItemType= ["FileItem"];
		args.versionableItemId= [versionableDTO.versionable.itemId];
		var responseHandler= new ServiceResponseHandler({'onSuccess': dojo.hitch(this, function(response) {
			PlatformUI.getWorkbench().hideMessageArea();
			this.onUpdateLocks(kwArgs);
			d.callback(true);
		}), 'onFailure': function(error) {
			if (error.message !== "") {
				window.alert(error.message);
			}
			PlatformUI.getWorkbench().hideMessageArea();
			d.errback(error);
		}}, 'onSuccess', 'onFailure');
		ScmClient.postUpdateLocks(responseHandler, args);
		return d;
	},

	updateLock: function(view, kwArgs) {
		if (!(kwArgs != null)) Assert.fail("kwArgs != null", "ScmPageController:798");
		if (!(kwArgs.versionableDTO != null)) Assert.fail("kwArgs.versionableDTO != null", "ScmPageController:799");
		this.view= view;
		var versionableDTO= kwArgs.versionableDTO;
		var operation= "";
		if (versionableDTO.versionable['com.ibm.team.repository.typeName'] === "com.ibm.team.scm.Folder") {
			operation= kwArgs.toLock ? "acquire_subtree" : "release_subtree";
		} else {
			operation= kwArgs.toLock ? "acquire" : "release";
		}
		PlatformUI.getWorkbench().showMessage(kwArgs.toLock ? this.messages.StreamWorkspaceView_66 : this.messages.StreamWorkspaceView_67);
		var d= new dojo.Deferred();
		var args= {};
		args.componentId= [versionableDTO.component.itemId];
		args.operation= [operation];
		args.streamId= [versionableDTO.workspace.itemId];
		args.versionableNamespace= ["com.ibm.team.filesystem"];
		args.versionableItemType= ["FileItem"];
		args.versionableItemId= [versionableDTO.versionable.itemId];
		var returnValue= new Array(1);
		var responseHandler= new ServiceResponseHandler({'onSuccess': dojo.hitch(this, function(response) {
			PlatformUI.getWorkbench().hideMessageArea();
			this.onUpdateLocks(kwArgs);
			d.callback(true);
		}), 'onFailure': dojo.hitch(this, function(error) {
			if (error.message !== "" && !kwArgs.toLock) {
				var confirm= window.confirm(dojo.string.substitute(this.messages.ScmPageController_36, [ error.message ]) );
				if (confirm) {
					PlatformUI.getWorkbench().hideMessageArea();
					this.clearStatusMessage();
					returnValue[0]= this.updateLockForce(kwArgs, confirm);
					return ;
				}
			}
			PlatformUI.getWorkbench().hideMessageArea();
			d.errback(error);
		})}, 'onSuccess', 'onFailure');
		ScmClient.postUpdateLocks(responseHandler, args);
		if (returnValue[0] != null) {
			return returnValue[0];
		}
		return d;
	},

	handleAdvancedSearchAction: function() {
		window.location.href= util.getAdvancedSearchURI();
	},

	handleRunSearchAction: function(searchText, type, ownerId, ownerType, componentId, workspaceId) {
		if (!(searchText != null)) Assert.fail("searchText != null", "ScmPageController:869");
		searchText= searchText.replace(new RegExp("\'/g"), "");
		var quoteLess= dojo.trim(searchText);
		window.location.href= util.getRunSearchURI(type, searchText, ownerId, ownerType, null, componentId, workspaceId, null, undefined, undefined, undefined, null, null, null, null, undefined);
	},

	handleUserNameSearchAction: function(text, callback, errorCallback) {
		var args= {};
		args.searchTerm= text;
		args.pageSize= 250;
		var responseHandler= new ServiceResponseHandler({'onSuccess': dojo.hitch(this, function(result) {
			var contributorResults= [];
			if (result !== undefined && result.elements !== undefined) {
				contributorResults= this._createContributorResults(result.elements);
			}
			callback(contributorResults);
		}), 'onFailure': function(error) {
			errorCallback(error);
		}}, 'onSuccess', 'onFailure');
		AdminClient.getContributors(args, responseHandler);
	},

	_createContributorResults: function(contributors) {
		var results= [];
		for (var i= 0; i < contributors.length; i++){
			results.push(this._createContributorResult(contributors[i]));
		}
		return results;
	},

	_createContributorResult: function(contributorDTO) {
		var result= {};
		result.label= contributorDTO.name;
		result.handler= function() {
			window.location.href= util.getSimpleLockSearchURI(contributorDTO.itemId, contributorDTO.name);
		};
		return result;
	},

	_scrollToDiff: function(diffId) {
		this._view.scrollToDiffInChangeset(diffId);
	},

	_displayChangeSet: function(changeSetPlusDTO, pair) {
		this._view.showChangeSetView(changeSetPlusDTO, pair.contextItemId, pair.contextItemType);
	},

	_displayElement: function(subElements, elementType, tabArgs) {
		this._view.showElementView(subElements, elementType, tabArgs);
	},

	_displayComponentHistory: function(historyPlusDTO) {
		this._view.showComponentHistory(historyPlusDTO);
	},

	_displayItemHistory: function(historyPlusDTO) {
		this._view.showItemHistory(historyPlusDTO);
	},

	_displayStateContent: function(versionableDTO) {
		this._view.showStateContent(versionableDTO);
	},

	onUpdateLocks: function(args) {
		if (this.view != null) {
			this.view.removeValidationMessage();
		}
	},

	onUpdateStream: function(args) {
	}
});

})();
