/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.scm.web.ui.internal.view.browse.FileFolderContentView");

dojo.require("com.ibm.jdojo.util.Assert");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.scm.web.client.internal.ScmClient");
dojo.require("com.ibm.team.scm.web.client.util");
dojo.require("com.ibm.team.scm.web.client.utilNative");
dojo.require("com.ibm.team.scm.web.ui.internal.widgets.SectionHeading");
dojo.require("com.ibm.team.scm.web.ui.internal.widgets.dojoWebEditor.WebEditor");
dojo.require("com.ibm.team.scm.web.ui.internal.widgets.resourcesEditor.ResourceEditor");
dojo.require("dijit._Templated");
dojo.require("dijit._Widget");
dojo.require("dojo.io.iframe");
dojo.require("dojo.string");
dojo.require("jazz.client.xhr");
dojo.require("jazz.ui.HoverPopup");
dojo.require("jazz.ui.MessageBox");
dojo.require("jazz.ui.SimpleToolbar");
dojo.require("jazz.ui.StyledTable");
dojo.require("jazz.util.date");
dojo.require("net.jazz.ajax.ui.PlatformUI");

(function() {
var Assert= com.ibm.jdojo.util.Assert;
var team= com.ibm.team;
var ServiceResponseHandler= team.repository.web.transport.ServiceResponseHandler;
var web= team.scm.web;
var client= web.client;
var ScmClient= client.internal.ScmClient;
var util= client.util;
var utilNative= client.utilNative;
var widgets= web.ui.internal.widgets;
var SectionHeading= widgets.SectionHeading;
var WebEditor= widgets.dojoWebEditor.WebEditor;
var ResourceEditor= widgets.resourcesEditor.ResourceEditor;
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;
var HoverPopup= jazz.ui.HoverPopup;
var MessageBox= jazz.ui.MessageBox;
var SimpleToolbar= jazz.ui.SimpleToolbar;
var StyledTable= jazz.ui.StyledTable;
var date= jazz.util.date;
var PlatformUI= net.jazz.ajax.ui.PlatformUI;

dojo.declare("com.ibm.team.scm.web.ui.internal.view.browse.FileFolderContentView", [ _Widget, _Templated], {

	templatePath: dojo.moduleUrl("com.ibm.team.scm.web", "ui/internal/view/browse/templates/FileFolderContentView.html"),

	widgetsInTemplate: true,

	//pageController: null,

	//_pageStatus: null,

	//messages: null,

	//MAX_FILE_CONTENT_DISPLAY_SIZE: null,

	//MAX_FILE_CONTENT_DISPLAY_LINES: null,

	//versionableDTO: null,

	//_inlineEditors: null,

	//_actionsBars: null,

	//_hidingActionsBars: null,

	//_hovers: null,

	//_overlayIcons: null,

	//_contentMessage: null,

	//isComponent: null,

	//_folderContentTable: null,

	//_folderContent: null,

	//_fileContentHeading: null,

	//_fileContent: null,

	//webEditor: null,

	constructor: function(args) {
		this.MAX_FILE_CONTENT_DISPLAY_SIZE= 32 * 1024 * 1024;
		this.MAX_FILE_CONTENT_DISPLAY_LINES= 100000;
		this._hidingActionsBars= false;
		this.pageController= args.controller;
		this._pageStatus= args.pageStatusDiv;
		this.messages= utilNative.messages;
		this.versionableDTO= null;
		this._inlineEditors= {};
		this._actionsBars= [];
		this._hovers= [];
		this._overlayIcons= [];
	},

	postCreate: function() {
		this.connect(this.pageController, "onUpdateLocks", dojo.hitch(this, function(event) {
			this._updateFileLockInfo(event);
		}));
		this.inherited("postCreate", arguments, []);
	},

	destroy: function(preserveDom) {
		this._clear();
		this.inherited("destroy", arguments, [preserveDom]);
	},

	_clear: function() {
		if (this.webEditor != null) {
			this.webEditor.destroy(false);
			this.webEditor= null;
		}
		if (this._folderContentTable != null) {
			this._folderContentTable.destroy(false);
			this._folderContentTable= null;
		}
		dojo.empty(this._folderContent);
		if (this._fileContentHeading != null) {
			this._fileContentHeading.destroy(false);
			this._fileContentHeading= null;
		}
		dojo.empty(this._fileContent);
		this._fileContent.style.visibility= "hidden";
		for (var i= 0; i < this._actionsBars.length; i++){
			this._actionsBars[i].destroy(undefined);
		}
		this._actionsBars= [];
		for (var i= 0; i < this._hovers.length; i++){
			this._hovers[i].destroy(undefined);
		}
		this._hovers= [];
		for (var i= 0; i < this._overlayIcons.length; i++){
			this._overlayIcons[i].destroy(undefined);
		}
		this._overlayIcons= [];
		if (this._contentMessage != null) {
			this._contentMessage.destroyRecursive();
			this._contentMessage= null;
		}
	},

	showWidget: function(subElements, args) {
		this.versionableDTO= subElements;
		this.isComponent= args.isComponent;
		this.refresh();
	},

	reload: function() {
		if (this.versionableDTO == null) 
			return ;
		var d= ScmClient.fetchVersionableDTOWithId(this.versionableDTO.workspace.itemId, this.versionableDTO.component.itemId, this.versionableDTO.versionable['com.ibm.team.repository.typeName'], this.versionableDTO.versionable.itemId, null);
		d.addCallback(dojo.hitch(this, function(result) {
			this.setVersionableDTO(result);
			this.refresh();
			return result;
		}));
	},

	setVersionableDTO: function(versionableDTO) {
		this.versionableDTO= versionableDTO;
	},

	refresh: function() {
		if (this.versionableDTO == null) 
			return ;
		this._clear();
		if (this.versionableDTO.versionable['com.ibm.team.repository.typeName'] === util.FILE_TYPE_ID) {
			this._displayFileItemContent();
		} else if (this.versionableDTO.versionable['com.ibm.team.repository.typeName'] === util.SYMBOLIC_LINK_TYPE_ID) {
			var versionable= this.versionableDTO.versionable;
			this._displaySymbolicLink(versionable.name, versionable.target);
		} else {
			if (this.versionableDTO.children !== undefined) {
				this._displaySubElements(this.versionableDTO);
			} else {
				this._displayEmptyDirectory(this.versionableDTO.versionable.name, this.isComponent);
			}
		}
	},

	_displayFileItemContent: function() {
		this._fileContent.style.visibility= "visible";
		var sectionHeadingParams= {};
		this._fileContentHeading= new SectionHeading(sectionHeadingParams);
		this._fileContent.appendChild(this._fileContentHeading.domNode);
		if (this._hasTextContentType(this.versionableDTO.versionable)) {
			this.getFileContents();
		} else if (this._isWebImage(this.versionableDTO.versionable)) {
			var params= {};
			params.contextItemType= util.getVersionableDTOContextItemType(this.versionableDTO);
			params.contextItemId= util.getVersionableDTOContextItemId(this.versionableDTO);
			params.componentItemId= this.versionableDTO.component.itemId;
			params.fileName= this.versionableDTO.versionable.name;
			params.fileItemId= this.versionableDTO.versionable.itemId;
			params.fileStateId= this.versionableDTO.versionable.stateId;
			var src= util.getFileDownloadURI(params);
			var div= window.document.createElement("div");
			div.className= "imageDiv";
			var table= window.document.createElement("table");
			var tr= window.document.createElement("tr");
			var td= window.document.createElement("td");
			var img= window.document.createElement("img");
			img.src= src;
			img.title= this.versionableDTO.versionable.name;
			td.appendChild(img);
			tr.appendChild(td);
			table.appendChild(tr);
			div.appendChild(table);
			this._fileContent.appendChild(div);
			this._updateFileContentHeaderRow(false, 0);
		} else {
			var fileParams= {};
			fileParams.contextItemType= util.getVersionableDTOContextItemType(this.versionableDTO);
			fileParams.contextItemId= util.getVersionableDTOContextItemId(this.versionableDTO);
			fileParams.componentItemId= this.versionableDTO.component.itemId;
			fileParams.fileName= this.versionableDTO.versionable.name;
			fileParams.fileItemId= this.versionableDTO.versionable.itemId;
			fileParams.fileStateId= this.versionableDTO.versionable.stateId;
			var downloadHref= util.getFileDownloadURI(fileParams);
			var m= dojo.string.substitute(this.messages.FileFolderContentView_notText, [downloadHref]);
			var isApplicationUnknown= util.isUnKnownContentType(this.versionableDTO.versionable);
			var anchorLink= "#show_" + this.versionableDTO.versionable.itemId;
			var anchorId= anchorLink;
			if (isApplicationUnknown) {
				m= dojo.string.substitute(this.messages.FileFolderContentView_applicationUnknown, [anchorLink, downloadHref]);
			}
			var messageDiv= window.document.createElement("div");
			messageDiv.innerHTML= m;
			if (isApplicationUnknown) {
				var showAsTextAnchor= util.findElement("a", anchorId, messageDiv);
				this.connect(showAsTextAnchor, "onclick", dojo.hitch(this, function(event) {
					event.preventDefault();
					this._fileContent.removeChild(messageDiv);
					this.getFileContents();
				}));
			}
			this._fileContent.appendChild(messageDiv);
			this._updateFileContentHeaderRow(false, 0);
		}
	},

	/**
	 * Retrieve and display the file content.  Caller needs to verify that content 
	 * can be shown as text.
	 */
	getFileContents: function() {
		var size= this.versionableDTO.versionable.content.size;
		var op= this.pageController.createOperation(this.messages.ScmPageController_30, "retrieve file content");
		var args= {};
		args.url= "../../service/com.ibm.team.filesystem.common.IFileContentService/content/" + this.versionableDTO.versionable.itemId + "/" + this.versionableDTO.versionable.stateId;
		args.headers= {};
		args.headers["accept-charset"]= "utf-8";
		args.load= dojo.hitch(this, function(response, ioArgs) {
			this.pageController.finishOperation(op);
			var content= response;
			var tooBig= false;
			if (size > this.MAX_FILE_CONTENT_DISPLAY_SIZE) {
				var displayLength= (((content.length * this.MAX_FILE_CONTENT_DISPLAY_SIZE / size))|0);
				content= content.substring(0, displayLength);
				tooBig= true;
			}
			var lines= this._parseTextFileLines(content);
			var lineCount= lines.length;
			if (lineCount > this.MAX_FILE_CONTENT_DISPLAY_LINES) {
				lines= lines.slice(0, this.MAX_FILE_CONTENT_DISPLAY_LINES);
				tooBig= true;
			}
			if (tooBig) {
				var fileParams= {};
				fileParams.contextItemType= util.getVersionableDTOContextItemType(this.versionableDTO);
				fileParams.contextItemId= util.getVersionableDTOContextItemId(this.versionableDTO);
				fileParams.componentItemId= this.versionableDTO.component.itemId;
				fileParams.fileName= this.versionableDTO.versionable.name;
				fileParams.fileItemId= this.versionableDTO.versionable.itemId;
				fileParams.fileStateId= this.versionableDTO.versionable.stateId;
				var downloadHref= util.getFileDownloadURI(fileParams);
				var args= [util.getSizeDisplay(size, false), (lineCount).toString(), downloadHref];
				var m= dojo.string.substitute(this.messages.StreamWorkspaceView_file_size_too_big, args);
				this.pageController.displayPageStatusMessage(m, 'WARNING', this._pageStatus);
			}
			this._displayFileContent(lines);
		});
		args.error= dojo.hitch(this, function(response, ioArgs) {
			this.pageController.finishOperation(op);
			var errorMessage= null;
			if (ioArgs.xhr.responseText != null) {
				var errorObj= dojo.fromJson(ioArgs.xhr.responseText);
				errorMessage= (errorObj != null && errorObj.errorMessage != null) ? errorObj.errorMessage : ioArgs.xhr.statusText;
			}
			this._displayStatus('INFO', ioArgs.xhr.status, errorMessage, null);
		});
		this.pageController.startOperation(op);
		jazz.client.xhrGet(args);
	},

	_displayStatus: function(type, code, msg, detail) {
		if (this._contentMessage !== undefined && this._contentMessage != null) {
			this._contentMessage.destroyRecursive();
			this._contentMessage= null;
		}
		this._contentMessage= new MessageBox();
		var parms= {summary: dojo.string.substitute(this.messages.FileFolderContentView_contentNotDisplayable, [msg, (code).toString()])};
		parms.type= type;
		if (detail != null) 
			parms.details= [{message: detail}];
		this._contentMessage.showMessage(parms);
		var tr= window.document.createElement("tr");
		var td= window.document.createElement("td");
		tr.appendChild(td);
		this._fileContent.appendChild(tr);
		td.appendChild(this._contentMessage.domNode);
	},

	_displaySymbolicLink: function(name, targetPath) {
		this._fileContent.style.visibility= "visible";
		var sectionHeadingParams= {};
		this._fileContentHeading= new SectionHeading(sectionHeadingParams);
		this._fileContent.appendChild(this._fileContentHeading.domNode);
		var text= window.document.createTextNode(name);
		this._fileContentHeading.getHeading().appendChild(text);
		var div= window.document.createElement("div");
		div.appendChild(window.document.createTextNode(targetPath));
		this._fileContent.appendChild(div);
	},

	/**
	 * Display an empty directory.
	 * 
	 * @param {Object} path
	 */
	_displayEmptyDirectory: function(path, isComponent) {
		this._fileContent.style.visibility= "visible";
		var sectionHeadingParams= {};
		this._fileContentHeading= new SectionHeading(sectionHeadingParams);
		this._fileContent.appendChild(this._fileContentHeading.domNode);
		var text= window.document.createTextNode(path);
		this._fileContentHeading.getHeading().appendChild(text);
		var div= window.document.createElement("div");
		div.innerHTML= isComponent ? this.messages.FilesFoldersView_ComponentEmptyMessage : this.messages.FileFolderContentView_emptyDirectory;
		this._fileContent.appendChild(div);
	},

	/**
	 * Display the lines of a file.
	 * 
	 * @param {Object} lines
	 * @param {Object} tbody
	 */
	_displayFileContent: function(lines) {
		var params= {};
		params.parent= this._fileContent;
		params.loaded= dojo.hitch(this, function(editor) {
			var text= "";
			for (var i= 0; i < lines.length; i++){
				text+= lines[i];
				if (i < lines.length - 1) {
					text+= "\r\n";
				}
			}
			editor.onInputChange(null, text, null, false);
			utilNative.highlightSyntax(this.versionableDTO.versionable.name, editor.getTextView());
		});
		this.webEditor= new WebEditor(params);
		this._updateFileContentHeaderRow(true, lines.length);
	},

	_parseTextFileLines: function(encodedContent) {
		var lines= null;
		var crnl= encodedContent.indexOf("\r\n");
		if (crnl > -1) 
			lines= encodedContent.split("\r\n");
		else {
			var cr= encodedContent.indexOf("\r");
			if (cr > -1) 
				lines= encodedContent.split("\r");
			else {
				var nl= encodedContent.indexOf("\n");
				if (nl > -1) 
					lines= encodedContent.split("\n");
			}
		}
		if (lines == null) 
			lines= [encodedContent];
		return lines;
	},

	/**
	 * Display the contents of a component or folder.
	 * 
	 * @param {Object} subElements
	 */
	_displaySubElements: function(subElements) {
		var contextItemType= util.getVersionableDTOContextItemType(subElements);
		var contextItemId= util.getVersionableDTOContextItemId(subElements);
		var isStream= subElements.workspace !== undefined && subElements.workspace.stream;
		var column1= {};
		column1.label= this.messages.FileFolderProp_Name;
		column1.className= "fileName";
		var column2= {};
		column2.label= this.messages.FileFolderProp_Size;
		column2.className= "fileSizeColumn";
		var column3= {};
		column3.label= this.messages.FileFolderProp_LastMod;
		var column4= {};
		column4.label= this.messages.FileFolderProp_ModBy;
		var column5= {};
		column5.label= this.messages.FileFolderProp_Actions;
		column5.className= "actions";
		var columns= [column1, column2, column3, column4, column5];
		var tableParams= {};
		tableParams.columns= columns;
		this._folderContentTable= new StyledTable(tableParams);
		dojo.addClass(this._folderContentTable.domNode, "folderContentTable");
		this._folderContentTable._setShowHoverAttr(true);
		this._folderContentTable.setTrim(4);
		this._folderContent.appendChild(this._folderContentTable.domNode);
		var tbody= this._folderContentTable.tbody;
		var children= subElements.versionablePlusDTO.childrenPlus;
		for (var i= 0; i < children.length; i++){
			var x= children[i];
			var versionable= x.versionable;
			var isFolder= versionable['com.ibm.team.repository.typeName'] === util.FOLDER_TYPE_ID;
			var isFile= versionable['com.ibm.team.repository.typeName'] === util.FILE_TYPE_ID;
			var isSymlink= versionable['com.ibm.team.repository.typeName'] === util.SYMBOLIC_LINK_TYPE_ID;
			var lockedBy= x.lockedBy;
			var isLocked= lockedBy !== undefined && lockedBy != null;
			var contributor= util.getLoggedInContributor();
			var lockedByMe= isLocked && lockedBy.itemId === contributor.itemId;
			var lockedByOtherName= isLocked ? lockedBy.name : null;
			var tr= window.document.createElement("tr");
			tbody.appendChild(tr);
			var nameTD= window.document.createElement("td");
			nameTD.versionable= versionable;
			nameTD.isSymLink= isSymlink;
			nameTD.isFolder= isFolder;
			nameTD.fileName= versionable.name;
			nameTD.isLocked= isLocked;
			nameTD.lockedBy= lockedBy;
			var params= {};
			if (isSymlink) {
				params.iconSrc= util.SYMLINK;
			} else if (isFolder) {
				params.iconSrc= util.FOLDER;
			} else {
				params.iconSrc= util.FILE;
			}
			params.fileName= versionable.name;
			params.isLockedByMe= lockedByMe;
			params.isLockedByOther= !lockedByMe && lockedByOtherName != null;
			var overlayIcon= util.createOverlayIcon(params);
			this._overlayIcons.push(overlayIcon);
			var img= overlayIcon.domNode;
			dojo.addClass(img, "com-ibm-team-scm-FileFolderContentView-overlayIcon");
			nameTD.icon= img;
			var anchor= window.document.createElement("a");
			var slashName= "/" + encodeURIComponent(versionable.name);
			var uriParams= {};
			uriParams.contextItemType= contextItemType;
			uriParams.contextItemId= contextItemId;
			uriParams.componentItemId= subElements.component.itemId;
			uriParams.itemId= versionable.itemId;
			uriParams.itemType= versionable['com.ibm.team.repository.typeName'];
			anchor.href= util.getBrowseElementURI(uriParams);
			var text= window.document.createTextNode(versionable.name);
			anchor.appendChild(text);
			nameTD.appendChild(img);
			nameTD.appendChild(anchor);
			var hoverInfo= {};
			hoverInfo.parentNode= nameTD;
			hoverInfo.lockedByMe= lockedByMe;
			hoverInfo.lockedByOtherName= lockedByOtherName;
			hoverInfo.subElements= subElements;
			hoverInfo.versionable= versionable;
			nameTD.hoverInfo= hoverInfo;
			this._hookHover(hoverInfo);
			tr.appendChild(nameTD);
			var sizeTD= window.document.createElement("td");
			dojo.addClass(sizeTD, "fileSizeColumn");
			sizeTD.style.paddingTop= "5px";
			if (isFolder || isSymlink) {
				sizeTD.innerHTML= "&nbsp;";
			} else {
				var size= versionable.content.size;
				sizeTD.innerHTML= util.getSizeDisplay(size, false);
			}
			tr.appendChild(sizeTD);
			var lastModTD= window.document.createElement("td");
			lastModTD.style.paddingTop= "5px";
			var value= null;
			if (!isFolder) {
				value= util.getVersionablePropertyValue(versionable, isSymlink ? "scm.LinkTimestamp" : "fileTimestamp");
				if (value != null) {
					lastModTD.innerHTML= util.getDateStringFromLong(parseInt(value));
				}
			}
			if (value == null) 
				lastModTD.innerHTML= "&nbsp;";
			tr.appendChild(lastModTD);
			var modByTD= window.document.createElement("td");
			if (isFolder) 
				modByTD.innerHTML= "&nbsp";
			else 
				modByTD.appendChild(util.createContributorElement(x.modifiedBy));
			tr.appendChild(modByTD);
			var actionsTD= this._createActionsColumnElement(versionable, contextItemId, isStream, subElements, slashName, isFolder, isLocked, isFile, nameTD, tr);
		}
	},

	_createActionsColumnElement: function(versionable, contextItemId, isStream, subElements, slashName, isFolder, isLocked, isFile, nameTD, parentNode) {
		var actionsTD= window.document.createElement("TD");
		parentNode.appendChild(actionsTD);
		actionsTD._itemId= versionable.itemId;
		actionsTD.itemType= versionable['com.ibm.team.repository.typeName'];
		actionsTD.workspaceId= contextItemId;
		actionsTD.componentId= subElements.component.itemId;
		actionsTD.path= subElements.path === "/" ? slashName : subElements.path + slashName;
		actionsTD.isFolder= isFolder;
		actionsTD.isLocked= isLocked;
		var actionsBar= new SimpleToolbar();
		this._actionsBars.push(actionsBar);
		actionsTD.appendChild(actionsBar.domNode);
		dojo.addClass(actionsBar.domNode, "floatRight");
		var args;
		if (isStream && !isFolder && isFile) {
			args= {};
			args.imgSrc= util.getIconSrc("lockdownload_co");
			args.label= this.messages.StreamWorkspaceView_68;
			actionsBar.addButton(null, dojo.hitch(this, function() {
				this._handleLockAndDownloadClick(actionsTD);
			}), args);
		}
		if (!isFolder && isFile) {
			args= {};
			args.imgSrc= util.getIconSrc("download_co");
			args.label= this.messages.StreamWorkspaceView_55;
			actionsBar.addButton(null, dojo.hitch(this, function() {
				this._handleDownloadClick(actionsTD);
			}), args);
		}
		if (isStream && !isFolder && isFile) {
			args= {};
			args.imgSrc= util.getIconSrc("upload_co");
			args.label= this.messages.StreamWorkspaceView_60;
			actionsBar.addButton(null, dojo.hitch(this, function() {
				this._hideActionsBars(actionsBar);
				this._openInlineEditor(actionsTD, "SINGLE_FILE_UPLOAD");
			}), args);
		}
		if (isStream && !isFolder) {
			actionsTD.name= nameTD;
			args= {};
			args.imgSrc= util.getIconSrc("locks");
			args.label= this.messages.StreamWorkspaceView_64;
			actionsBar.addButton(null, dojo.hitch(this, function() {
				this._handleFileLockClick(actionsTD);
			}), args);
			args= {};
			args.imgSrc= util.getIconSrc("unlock");
			args.label= this.messages.StreamWorkspaceView_65;
			actionsBar.addButton(null, dojo.hitch(this, function() {
				this._handleFileUnlockClick(actionsTD);
			}), args);
		}
		if (isStream) {
			var mode= isFolder ? "SINGLE_FOLDER_DELETE" : "SINGLE_FILE_DELETE";
			args= {};
			args.imgSrc= util.getIconSrc("delete_edit");
			args.label= this.messages.StreamWorkspaceView_61;
			actionsBar.addButton(null, dojo.hitch(this, function() {
				this._hideActionsBars(actionsBar);
				this._openInlineEditor(actionsTD, mode);
			}), args);
		}
		actionsBar.domNode.style.visibility= "hidden";
		this.connect(actionsTD.parentNode, 'mouseover', dojo.hitch(this, function(event) {
			if (!this._hidingActionsBars) {
				actionsBar.domNode.style.visibility= "";
			}
		}));
		this.connect(actionsTD.parentNode, 'mouseout', function(event) {
			actionsBar.domNode.style.visibility= "hidden";
		});
		return actionsTD;
	},

	_hideActionsBars: function(actionsBar) {
		this._hidingActionsBars= true;
		actionsBar.domNode.style.visibility= "hidden";
	},

	_showActionsBars: function() {
		this._hidingActionsBars= false;
	},

	/**
	 * Display extra information about the given resource Lock status / Image
	 * thumbnail for web images Info arguments: 1. parentNode - html dom node
	 * that will be our parent via the parentNode.hover attribute 2. lockedByMe
	 * - true if locked by me, false otherwise 3. lockedByOtherName - name of
	 * the person who owns the lock, null if locked by me or not locked
	 * (resource is not locked if lockedByMe and lockedByOther are undefined) 4.
	 * subElements - used to show image thumbnail 5. versionable - used to show
	 * image thumbnail
	 * 
	 * Hook a hover on the given parent node or does nothing if there is no
	 * information to display in the hover.
	 */
	_hookHover: function(info) {
		if (info.parentNode.hover !== undefined && info.parentNode.hover != null) {
			info.parentNode.hover.destroy(undefined);
			info.parentNode.hover= null;
		}
		var webImage= this._isWebImage(info.versionable);
		if (!webImage && !info.lockedByMe && info.lockedByOtherName == null) {
			return ;
		}
		var args= {};
		args.around= [info.parentNode];
		args.createContents= dojo.hitch(this, function(hoverPopup) {
			var result= window.document.createElement("div");
			if (info.lockedByMe) {
				result.appendChild(window.document.createTextNode(this.messages.LockedByMeLabel));
			} else if (info.lockedByOtherName != null) {
				result.appendChild(window.document.createTextNode(dojo.string.substitute(this.messages.LockedByLabel, [info.lockedByOtherName])));
			}
			var subElements= info.subElements;
			var versionable= info.versionable;
			if (webImage) {
				if (info.lockedByMe || info.lockedByOtherName != null) {
					result.appendChild(window.document.createElement("br"));
				}
				var uriParams= {};
				uriParams.contextItemType= util.getVersionableDTOContextItemType(subElements);
				uriParams.contextItemId= util.getVersionableDTOContextItemId(subElements);
				uriParams.componentItemId= subElements.component.itemId;
				uriParams.fileName= versionable.name;
				uriParams.fileItemId= versionable.itemId;
				uriParams.fileStateId= versionable.stateId;
				var src= util.getFileDownloadURI(uriParams);
				var img= window.document.createElement("img");
				img.className= "com-ibm-team-scm-FilesFoldersView-Hover";
				img.src= src;
				img.title= subElements.versionable.name;
				result.appendChild(img);
			}
			return result;
		});
		args.orientation= "R";
		var hover= new HoverPopup(args);
		info.parentNode.hover= hover;
		this._hovers.push(hover);
	},

	_openInlineEditor: function(col, mode) {
		this.pageController.clearStatusMessage();
		var itemId= col._itemId;
		var row= col.parentNode;
		dojo.addClass(row, "double-row");
		var widget= this._inlineEditors[col._itemId + mode];
		var newRow= row.parentNode.insertRow(row.sectionRowIndex + 1);
		var newCol= window.document.createElement("td");
		newCol.className= "folderContent_td";
		newCol.colSpan= row.childNodes.length;
		col.parentRow= row;
		col.row= newRow;
		var args= {};
		args.mode= mode;
		args.workspaceId= col.workspaceId;
		args.componentId= col.componentId;
		args.path= col.path;
		args.itemId= col._itemId;
		args.itemType= col.itemType;
		args.pageController= this.pageController;
		args.onResourceEditorSaved= dojo.hitch(this, function(newPath) {
			this.reload();
			this._showActionsBars();
		});
		args.onResourceEditorClose= dojo.hitch(this, function() {
			this.hideInlineEditor(col);
			this._showActionsBars();
		});
		var editor= new ResourceEditor(args);
		editor.startup();
		this._inlineEditors[itemId + mode]= editor;
		newCol.appendChild(editor.domNode);
		newRow.appendChild(newCol);
	},

	hideInlineEditor: function(col) {
		col.row.style.display= "none";
		dojo.removeClass(col.parentRow, "double-row");
	},

	deleteItem: function(col) {
		var editorRow= col.row;
		if (editorRow !== undefined && editorRow.parentNode !== undefined) 
			this._deleteTableRow(editorRow.parentNode, editorRow.sectionRowIndex);
		var itemRow= col.parentRow;
		if (itemRow !== undefined && itemRow.parentNode !== undefined) 
			this._deleteTableRow(itemRow.parentNode, itemRow.sectionRowIndex);
		this._inlineEditors["InlineFileFolderEditor-" + col._itemId]= null;
	},

	_deleteTableRow: function(table, rowIndexValue) {
		var rows= table.rows;
		for (var i= 0; i < rows.length; i++){
			if (rows.item(i).sectionRowIndex === rowIndexValue) {
				table.deleteRow(i);
				return ;
			}
		}
	},

	_hasTextContentType: function(versionable) {
		var contentType= util.getVersionablePropertyValue(versionable, "contentType");
		return contentType != null && util.isKnownTextContentType(contentType);
	},

	_isWebImage: function(versionable) {
		var ext= util.getExtension(versionable.name).toLowerCase();
		return ext === "gif" || ext === "jpg" || ext === "jpeg" || ext === "png";
	},

	_handleFileLockClick: function(col) {
		this.pageController.clearStatusMessage();
		if (col.isLocked) 
			return ;
		var versionableDTO= col.versionableDTO;
		if (versionableDTO === undefined) {
			var type= col.isFolder ? util.FOLDER_TYPE_ID : util.FILE_TYPE_ID;
			var d= ScmClient.fetchVersionableDTOWithId(col.workspaceId, col.componentId, type, col._itemId, null);
			d.addCallback(dojo.hitch(this, function(result) {
				col.versionableDTO= result;
				this._handleFileLockClick(col);
				return result;
			}));
		} else {
			this._doUpdateLock(col, true);
		}
	},

	_handleFileUnlockClick: function(col) {
		this.pageController.clearStatusMessage();
		if (!col.isLocked) 
			return ;
		var versionableDTO= col.versionableDTO;
		if (versionableDTO === undefined) {
			var type= col.isFolder ? util.FOLDER_TYPE_ID : util.FILE_TYPE_ID;
			var d= ScmClient.fetchVersionableDTOWithId(col.workspaceId, col.componentId, type, col._itemId, null);
			d.addCallback(dojo.hitch(this, function(result) {
				col.versionableDTO= result;
				this._handleFileUnlockClick(col);
				return result;
			}));
		} else {
			this._doUpdateLock(col, false);
		}
	},

	_doUpdateLock: function(col, toLock) {
		var params= {};
		params.versionableDTO= col.versionableDTO;
		params.toLock= toLock;
		params.updateEvent= col;
		return this.pageController.updateLock(null, params);
	},

	/**
	 * col - the table cell clicked.
	 */
	_handleLockAndDownloadClick: function(col) {
		this.pageController.clearStatusMessage();
		var versionableDTO= col.versionableDTO;
		if (versionableDTO === undefined) {
			var type= col.isFolder ? util.FOLDER_TYPE_ID : util.FILE_TYPE_ID;
			var d= ScmClient.fetchVersionableDTOWithId(col.workspaceId, col.componentId, type, col._itemId, null);
			d.addCallback(dojo.hitch(this, function(result) {
				col.versionableDTO= result;
				this._handleLockAndDownloadClick(col);
				return result;
			}));
		} else {
			this._doUpdateLock(col, true).addCallback(dojo.hitch(this, function(object) {
				var params= {};
				params.contextItemType= util.getVersionableDTOContextItemType(versionableDTO);
				params.contextItemId= util.getVersionableDTOContextItemId(versionableDTO);
				params.componentItemId= versionableDTO.component.itemId;
				params.fileName= versionableDTO.versionable.name;
				params.fileItemId= versionableDTO.versionable.itemId;
				params.fileStateId= null;
				params.iframe= true;
				var href= util.getFileDownloadURI(params);
				var sendParams= {};
				sendParams.url= href;
				sendParams.timeout= 2000;
				sendParams.handle= dojo.hitch(this, function(response, ioArgs) {
					if (response != null) {
						this._downloadResponseHandler(response, versionableDTO);
					}
				});
				dojo.io.iframe.send(sendParams);
				return true;
			}));
		}
	},

	/**
	 * col - the table cell clicked.
	 */
	_handleDownloadClick: function(col) {
		this.pageController.clearStatusMessage();
		var versionableDTO= col.versionableDTO;
		if (versionableDTO === undefined) {
			var type= col.isFolder ? util.FOLDER_TYPE_ID : util.FILE_TYPE_ID;
			var d= ScmClient.fetchVersionableDTOWithId(col.workspaceId, col.componentId, type, col._itemId, null);
			d.addCallback(dojo.hitch(this, function(result) {
				col.versionableDTO= result;
				this._handleDownloadClick(col);
				return result;
			}));
		} else {
			var params= {};
			params.contextItemType= util.getVersionableDTOContextItemType(versionableDTO);
			params.contextItemId= util.getVersionableDTOContextItemId(versionableDTO);
			params.componentItemId= versionableDTO.component.itemId;
			params.fileName= versionableDTO.versionable.name;
			params.fileItemId= versionableDTO.versionable.itemId;
			params.fileStateId= null;
			params.iframe= true;
			var href= util.getFileDownloadURI(params);
			var args= {};
			args.url= href;
			args.timeout= 2000;
			args.handle= dojo.hitch(this, function(response, ioArgs) {
				if (response != null) {
					this._downloadResponseHandler(response, versionableDTO);
				}
			});
			dojo.io.iframe.send(args);
		}
	},

	_downloadResponseHandler: function(response, versionable) {
		var resp= String(response);
		var index= resp.indexOf(util.DOWNLOAD_CONTENT_DELETED_ERROR_PREFIX);
		if (index === 0) {
			var status= resp.substring(util.DOWNLOAD_CONTENT_DELETED_ERROR_PREFIX.length);
			status= dojo.string.substitute(this.messages.FileFolderContentView_contentNotDownloadable, [versionable.versionable.name, status]);
			this.pageController.displayPageStatusMessage(status, 'INFO', null);
		}
	},

	_updateFileLockInfo: function(args) {
		if (args.updateEvent === undefined || args.versionableDTO.versionable.itemId !== args.updateEvent._itemId) 
			return ;
		var nameCol= args.updateEvent.name;
		var isLocked= args.toLock;
		args.updateEvent.isLocked= isLocked;
		nameCol.isLocked= isLocked;
		nameCol.lockedBy= null;
		var overlayIcon= nameCol.icon !== undefined ? dijit.byNode(nameCol.icon) : null;
		if (overlayIcon != null) {
			overlayIcon.destroy(undefined);
		}
		var params= {};
		if (nameCol.isSymLink) {
			params.iconSrc= util.SYMLINK;
		} else if (nameCol.isFolder) {
			params.iconSrc= util.FOLDER;
		} else {
			params.iconSrc= util.FILE;
		}
		params.fileName= nameCol.fileName;
		params.isLockedByMe= isLocked;
		overlayIcon= util.createOverlayIcon(params);
		this._overlayIcons.push(overlayIcon);
		var img= overlayIcon.domNode;
		dojo.addClass(img, "com-ibm-team-scm-FileFolderContentView-overlayIcon");
		nameCol.icon= img;
		nameCol.insertBefore(img, nameCol.firstChild);
		var info= nameCol.hoverInfo;
		if (info != null) {
			if (info.parentNode.hover != null) {
				info.parentNode.hover.close();
			}
			info.lockedByMe= isLocked;
			info.lockedByOtherName= null;
			this._hookHover(info);
		}
	},

	retrieveVersionable: function(workspaceId, componentId, path, successCallback) {
		if (!(workspaceId != null)) Assert.fail("workspaceId != null", "FileFolderContentView:1298");
		if (!(componentId != null)) Assert.fail("componentId != null", "FileFolderContentView:1299");
		if (!(path != null)) Assert.fail("path != null", "FileFolderContentView:1300");
		PlatformUI.getWorkbench().showMessage(this.messages.FetchingItem);
		var responseHandler= new ServiceResponseHandler({'onSuccess': function(versionablePlusDTO) {
			PlatformUI.getWorkbench().hideMessageArea();
			if (versionablePlusDTO !== undefined && versionablePlusDTO.versionableDTO !== undefined) {
				var versionableDTO= versionablePlusDTO.versionableDTO;
				versionablePlusDTO.versionableDTO= null;
				versionableDTO.versionablePlusDTO= versionablePlusDTO;
				successCallback(versionableDTO);
			}
		}, 'onFailure': dojo.hitch(this, function(error) {
			PlatformUI.getWorkbench().hideMessageArea();
			if (this.pageController != null) {
				if (error.message !== "") {
					this.pageController._handleError(dojo.string.substitute(this.messages.ScmPageController_12, [error.message, "" + error.status]));
				} else {
					this.pageController._handleError(this.messages.ScmPageController_13);
				}
			}
		})}, 'onSuccess', 'onFailure');
		var parms= {};
		parms.workspaceItemId= workspaceId;
		parms.componentItemId= componentId;
		parms.path= path;
		ScmClient.getVersionablePlus(responseHandler, ScmClient.createVersionablePath(parms));
	},

	/**
	 * On the header row: number of lines, size, content type, line delimiter
	 * and encoding Show in tooltip: last modified by who at when
	 * 
	 * @param {Object} numOfLines
	 */
	_updateFileContentHeaderRow: function(isText, numOfLines) {
		var span= null;
		if (isText) {
			var numOfLinesLabel= numOfLines > 1 ? dojo.string.substitute(this.messages.FileNumOfLines, ["" + numOfLines]) : dojo.string.substitute(this.messages.FileNumOfLine, ["" + numOfLines]);
			span= window.document.createElement("span");
			span.innerHTML= numOfLinesLabel;
			dojo.addClass(span, "property");
			this._fileContentHeading.getHeading().appendChild(span);
		}
		var fileItem= this.versionableDTO.versionable;
		span= window.document.createElement("span");
		var size= fileItem.content.size > this.MAX_FILE_CONTENT_DISPLAY_SIZE ? this.MAX_FILE_CONTENT_DISPLAY_SIZE : fileItem.content.size;
		span.innerHTML= util.getSizeDisplay(size, false);
		dojo.addClass(span, "property");
		this._fileContentHeading.getHeading().appendChild(span);
		var executable= this.versionableDTO.versionable.executable;
		span= window.document.createElement("span");
		var ex= executable ? this.messages.FileFolderPropName_Executable : this.messages.FileFolderPropName_NotExecutable;
		span.appendChild(window.document.createTextNode(ex));
		dojo.addClass(span, "property");
		this._fileContentHeading.getHeading().appendChild(span);
		var value= util.getVersionablePropertyValue(fileItem, "contentType");
		if (value != null) {
			span= window.document.createElement("span");
			var ct= dojo.string.substitute(this.messages.FileFolderPropName_ContentType, [value]);
			span.appendChild(window.document.createTextNode(ct));
			dojo.addClass(span, "property");
			this._fileContentHeading.getHeading().appendChild(span);
		}
		if (isText) {
			var lineDelimiterSetting= fileItem.content.lineDelimiterSetting;
			if (lineDelimiterSetting >= 0 && lineDelimiterSetting <= 4) {
				if (lineDelimiterSetting === util.LINE_DELIMITER_NONE) 
					value= this.messages.UploadItem_cbLdNoneBinary;
				else if (lineDelimiterSetting === util.LINE_DELIMITER_LF) 
					value= this.messages.UploadItem_cbLdLFUnix;
				else if (lineDelimiterSetting === util.LINE_DELIMITER_CR) 
					value= this.messages.UploadItem_cbLdCRMac;
				else if (lineDelimiterSetting === util.LINE_DELIMITER_CRLF) 
					value= this.messages.UploadItem_cbLdCRLFWindows;
				else if (lineDelimiterSetting === util.LINE_DELIMITER_PLATFORM) 
					value= this.messages.UploadItem_cbPlatform;
				span= window.document.createElement("span");
				span.innerHTML= dojo.string.substitute(this.messages.FileFolderPropName_LineDelim, [value]);
				dojo.addClass(span, "property");
				this._fileContentHeading.getHeading().appendChild(span);
			}
		}
		if (isText) {
			if (fileItem.content.characterEncoding !== undefined) {
				span= window.document.createElement("span");
				var encoding= dojo.string.substitute(this.messages.FileFolderPropName_Encoding, [fileItem.content.characterEncoding]);
				span.appendChild(window.document.createTextNode(encoding));
				dojo.addClass(span, "property");
				this._fileContentHeading.getHeading().appendChild(span);
			}
		}
		var timeStamp= util.getVersionablePropertyValue(fileItem, "fileTimestamp");
		var modTime= new Date(parseInt(timeStamp));
		var time= date.formatDif(modTime, true, true);
		this._fileContentHeading.getHeading().title= dojo.string.substitute(this.messages.FilesFoldersView_LastModifiedBy_Who_When, [this.versionableDTO.creator.name, time]);
	}
});

})();
