/*******************************************************************************
 * Licensed Materials - Property of IBM
 *  Copyright IBM Corporation 2009, 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.scm.web.ui.internal.view.browse.FilesFoldersView");

dojo.require("com.ibm.jdojo.lang.Runtime");
dojo.require("com.ibm.team.scm.web.client.util");
dojo.require("com.ibm.team.scm.web.client.utilNative");
dojo.require("com.ibm.team.scm.web.ui.internal.EventConstants");
dojo.require("com.ibm.team.scm.web.ui.internal.view.browse.FileFolderContentView");
dojo.require("com.ibm.team.scm.web.ui.internal.view.browse.HistoryView");
dojo.require("com.ibm.team.scm.web.ui.internal.widgets.HeaderView");
dojo.require("com.ibm.team.scm.web.ui.internal.widgets.resourcesEditor.ResourceEditor");
dojo.require("dijit._Templated");
dojo.require("dijit._Widget");
dojo.require("dojo.io.iframe");
dojo.require("dojo.string");
dojo.require("jazz.ui.SimpleToolbar");
dojo.require("net.jazz.ajax.ui.PlatformUI");

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var web= com.ibm.team.scm.web;
var client= web.client;
var util= client.util;
var utilNative= client.utilNative;
var internal= web.ui.internal;
var EventConstants= internal.EventConstants;
var widgets= internal.widgets;
var HeaderView= widgets.HeaderView;
var ResourceEditor= widgets.resourcesEditor.ResourceEditor;
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;
var SimpleToolbar= jazz.ui.SimpleToolbar;
var PlatformUI= net.jazz.ajax.ui.PlatformUI;

var FilesFoldersView= dojo.declare("com.ibm.team.scm.web.ui.internal.view.browse.FilesFoldersView", [ _Widget, _Templated], {

	templatePath: dojo.moduleUrl("com.ibm.team.scm.web", "ui/internal/view/browse/templates/FilesFoldersView.html"),

	//pageController: null,

	//messages: null,

	//_tabViewParts: null,

	//_toolbar: null,

	//editBrowser: null,

	//_breadcrumb: null,

	//_pageStatus: null,

	//header1stRow: null,

	//headerView: null,

	//validationMessage: null,

	//validationMessageSpan: null,

	//validationMessageIcon: null,

	//_tabLinkContainer: null,

	//_currentTabContainer: null,

	//_currentTab: null,

	//breadcrumbWidget: null,

	//_overviewWidget: null,

	//_historyView: null,

	//versionableDTO: null,

	//contentArgs: null,

	//_isFolder: null,

	//_isStream: null,

	//_toolbarButtons: null,

	constructor: function(args) {
		this.messages= utilNative.messages;
		this.pageController= args.controller;
		this._toolbarButtons= {};
		this._tabViewParts= [];
	},

	postCreate: function() {
		this.connect(this.pageController, "onUpdateLocks", "_updateFileLockIconStatus");
		this.inherited("postCreate", arguments, []);
	},

	destroy: function(preserveDom) {
		this._clear();
		this.inherited("destroy", arguments, [preserveDom]);
	},

	_clear: function() {
		dojo.empty(this.editBrowser);
		if (this.breadcrumbWidget != null) {
			this.breadcrumbWidget.destroy(undefined);
		}
		if (this.headerView != null) {
			this.headerView.destroy(undefined);
		}
		if (this._overviewWidget != null) {
			this._overviewWidget.destroy(undefined);
		}
		if (this._historyView != null) {
			this._historyView.destroy(undefined);
		}
	},

	setContent: function(args, subElements) {
		this.versionableDTO= subElements;
		this.contentArgs= args;
		this._isFolder= this.versionableDTO.versionable['com.ibm.team.repository.typeName'] === "com.ibm.team.scm.Folder";
		this._isStream= this.versionableDTO.workspace !== undefined && this.versionableDTO.workspace.stream;
		this.refresh();
		this._pageLoaded();
	},

	_pageLoaded: function() {
		var param= {};
		if (this.contentArgs.isComponent === true) {
			param.label= this.versionableDTO.component.name;
			param.iconUri= util.getIconUrl(util.COMPONENT, null);
			param.type= util.SCM_VIEW_HISTORY_TYPE;
		} else if (this._isFolder === true) {
			param.label= this.versionableDTO.versionable.name;
			param.iconUri= util.getIconUrl(util.FOLDER, null);
			param.type= util.SCM_FILES_FOLDERS_VIEW_HISTORY_TYPE;
		} else {
			param.label= this.versionableDTO.versionable.name;
			param.iconUri= util.getIconUrl(util.FILE, util.getExtension(this.versionableDTO.versionable.name));
			param.type= util.SCM_FILES_FOLDERS_VIEW_HISTORY_TYPE;
		}
		var args= {};
		args.contextItemType= util.getVersionableDTOContextItemType(this.versionableDTO);
		args.contextItemId= util.getVersionableDTOContextItemId(this.versionableDTO);
		args.componentItemId= this.versionableDTO.component.itemId;
		args.path= this.versionableDTO.path;
		args.itemId= this.versionableDTO.versionable.itemId;
		args.itemType= this.versionableDTO.versionable['com.ibm.team.repository.typeName'];
		param.data= util.getBrowseElementURI(args);
		param.uri= util.getProjectAreaURI() + param.data;
		dojo.publish(EventConstants.PAGE_LOADED_EVENT, [param]);
	},

	refresh: function() {
		if (this.versionableDTO == null) 
			return ;
		this._clear();
		if (this.breadcrumbWidget != null) {
			this.breadcrumbWidget.destroy(false);
		}
		this.breadcrumbWidget= util.createBreadcrumbsForVersionableDTO(this.versionableDTO);
		this._breadcrumb.appendChild(this.breadcrumbWidget.domNode);
		this._setTitleAndToolbar(this.versionableDTO);
		this._setTabs(this.versionableDTO, this.contentArgs);
		if (this.contentArgs.tab === undefined || this.contentArgs.tab == null) 
			this.showTab(FilesFoldersView.TAB_NAME_OVERVIEW, this.versionableDTO, this.contentArgs);
		else 
			this.showTab(this.contentArgs.tab, this.versionableDTO, this.contentArgs);
	},

	_setTitleAndToolbar: function(versionableDTO) {
		if (this.headerView != null) {
			this.headerView.destroy(undefined);
		}
		this.headerView= null;
		this._toolbar= new SimpleToolbar();
		var args= {};
		args.imgSrc= String(dojo.moduleUrl(FilesFoldersView.BUTTON_CONTEXT, FilesFoldersView.ADD_FILE_IMAGE));
		args.label= this.messages.StreamWorkspaceView_62;
		this._toolbarButtons[FilesFoldersView.ADD_FILE_BUTTON]= this._toolbar.addButton(this, dojo.hitch(this, function() {
			this._handleFileAddBrowserClick();
		}), args);
		args= {};
		args.imgSrc= String(dojo.moduleUrl(FilesFoldersView.BUTTON_CONTEXT, FilesFoldersView.NEW_TEXT_FILE_IMAGE));
		args.label= this.messages.StreamWorkspaceView_69;
		this._toolbarButtons[FilesFoldersView.NEW_TEXT_FILE_BUTTON]= this._toolbar.addButton(this, dojo.hitch(this, function() {
			this._handleNewTextFileBrowserClick();
		}), args);
		args= {};
		args.imgSrc= String(dojo.moduleUrl(FilesFoldersView.BUTTON_CONTEXT, FilesFoldersView.ADD_FOLDER_IMAGE));
		args.label= this.messages.StreamWorkspaceView_63;
		this._toolbarButtons[FilesFoldersView.ADD_FOLDER_BUTTON]= this._toolbar.addButton(this, dojo.hitch(this, function() {
			this._handleFolderAddBrowserClick();
		}), args);
		args= {};
		args.imgSrc= String(dojo.moduleUrl(FilesFoldersView.BUTTON_CONTEXT, FilesFoldersView.LOCK_DOWNLOAD_IMAGE));
		args.label= this.messages.StreamWorkspaceView_68;
		this._toolbarButtons[FilesFoldersView.LOCK_AND_DOWNLOAD_BUTTON]= this._toolbar.addButton(this, dojo.hitch(this, function() {
			this._handleLockAndDownloadClick();
		}), args);
		args= {};
		args.imgSrc= String(dojo.moduleUrl(FilesFoldersView.BUTTON_CONTEXT, FilesFoldersView.DOWNLOAD_IMAGE));
		args.label= this.messages.StreamWorkspaceView_55;
		this._toolbarButtons[FilesFoldersView.DOWNLOAD_BUTTON]= this._toolbar.addButton(this, undefined, args);
		args= {};
		args.imgSrc= String(dojo.moduleUrl(FilesFoldersView.BUTTON_CONTEXT, FilesFoldersView.UPLOAD_IMAGE));
		args.label= this.messages.StreamWorkspaceView_60;
		this._toolbarButtons[FilesFoldersView.UPLOAD_BUTTON]= this._toolbar.addButton(this, dojo.hitch(this, function() {
			this._handleUploadBrowserClick();
		}), args);
		args= {};
		args.imgSrc= String(dojo.moduleUrl(FilesFoldersView.BUTTON_CONTEXT, FilesFoldersView.EDIT_TEXT_FILE_IMAGE));
		args.label= this.messages.StreamWorkspaceView_70;
		this._toolbarButtons[FilesFoldersView.EDIT_TEXT_FILE_BUTTON]= this._toolbar.addButton(this, dojo.hitch(this, function() {
			this._handleEditTextFileBrowserClick();
		}), args);
		args= {};
		args.imgSrc= String(dojo.moduleUrl(FilesFoldersView.BUTTON_CONTEXT, FilesFoldersView.RENAME_ITEM_IMAGE));
		args.label= this.messages.StreamWorkspaceView_71;
		this._toolbarButtons[FilesFoldersView.RENAME_ITEM_BUTTON]= this._toolbar.addButton(this, dojo.hitch(this, function() {
			this._handleRenameItemBrowserClick();
		}), args);
		args= {};
		args.imgSrc= String(dojo.moduleUrl(FilesFoldersView.BUTTON_CONTEXT, FilesFoldersView.LOCK_IMAGE));
		args.label= this.messages.StreamWorkspaceView_64;
		this._toolbarButtons[FilesFoldersView.LOCK_BUTTON]= this._toolbar.addButton(this, dojo.hitch(this, function() {
			this._handleFileLockClick();
		}), args);
		args= {};
		args.imgSrc= String(dojo.moduleUrl(FilesFoldersView.BUTTON_CONTEXT, FilesFoldersView.UNLOCK_IMAGE));
		args.label= this.messages.StreamWorkspaceView_65;
		this._toolbarButtons[FilesFoldersView.UNLOCK_BUTTON]= this._toolbar.addButton(this, dojo.hitch(this, function() {
			this._handleFileUnlockClick();
		}), args);
		args= {};
		args.imgSrc= String(dojo.moduleUrl(FilesFoldersView.BUTTON_CONTEXT, FilesFoldersView.DELETE_IMAGE));
		args.label= this.messages.StreamWorkspaceView_61;
		this._toolbarButtons[FilesFoldersView.DELETE_BUTTON]= this._toolbar.addButton(this, dojo.hitch(this, function() {
			this._handleFileDeleteBrowserClick();
		}), args);
		this._setToolbarButtonVisible(false, null);
		dojo.empty(this.validationMessage);
		dojo.removeClass(this.validationMessageSpan, "validationMessageWarning");
		dojo.addClass(this.validationMessageSpan, "validationMessageEmpty");
		var fromStream= versionableDTO.workspace !== undefined && versionableDTO.workspace.stream;
		var lockedBy= versionableDTO.versionablePlusDTO.lockedBy;
		var isLocked= lockedBy !== undefined;
		var loggedInContributor= util.getLoggedInContributor();
		var isLockedByMe= lockedBy !== undefined && lockedBy.itemId === loggedInContributor.itemId;
		var isLockedByOther= lockedBy !== undefined && lockedBy.itemId !== loggedInContributor.itemId;
		var hvParams= {};
		hvParams.toolbar= this._toolbar;
		var coiParams= {};
		hvParams.createOverlayIconParams= coiParams;
		coiParams.isLockedByMe= isLockedByMe;
		coiParams.isLockedByOther= isLockedByOther;
		if (this.contentArgs.isComponent) {
			hvParams.label= versionableDTO.component.name;
			coiParams.iconSrc= util.COMPONENT;
			if (fromStream) 
				this._setToolbarButtonVisible(true, [FilesFoldersView.ADD_FILE_BUTTON, FilesFoldersView.NEW_TEXT_FILE_BUTTON, FilesFoldersView.ADD_FOLDER_BUTTON]);
		} else if (versionableDTO.versionable['com.ibm.team.repository.typeName'] === "com.ibm.team.scm.Folder") {
			hvParams.label= versionableDTO.versionable.name;
			coiParams.iconSrc= util.FOLDER;
			if (fromStream) 
				this._setToolbarButtonVisible(true, [FilesFoldersView.ADD_FILE_BUTTON, FilesFoldersView.NEW_TEXT_FILE_BUTTON, FilesFoldersView.ADD_FOLDER_BUTTON, FilesFoldersView.RENAME_ITEM_BUTTON, FilesFoldersView.DELETE_BUTTON]);
		} else if (versionableDTO.versionable['com.ibm.team.repository.typeName'] === "com.ibm.team.filesystem.FileItem") {
			hvParams.label= versionableDTO.versionable.name;
			coiParams.iconSrc= util.FILE;
			coiParams.fileName= versionableDTO.versionable.name;
			var fileParams= {};
			fileParams.contextItemType= util.getVersionableDTOContextItemType(versionableDTO);
			fileParams.contextItemId= util.getVersionableDTOContextItemId(versionableDTO);
			fileParams.componentItemId= versionableDTO.component.itemId;
			fileParams.fileName= versionableDTO.versionable.name;
			fileParams.fileItemId= versionableDTO.versionable.itemId;
			fileParams.fileStateId= versionableDTO.versionable.stateId;
			this._toolbarButtons[FilesFoldersView.DOWNLOAD_BUTTON].domNode.href= util.getFileDownloadURI(fileParams);
			if (fromStream) 
				this._setToolbarButtonVisible(true, [FilesFoldersView.LOCK_AND_DOWNLOAD_BUTTON, FilesFoldersView.DOWNLOAD_BUTTON, FilesFoldersView.UPLOAD_BUTTON, FilesFoldersView.EDIT_TEXT_FILE_BUTTON, FilesFoldersView.RENAME_ITEM_BUTTON, FilesFoldersView.LOCK_BUTTON, FilesFoldersView.UNLOCK_BUTTON, FilesFoldersView.DELETE_BUTTON]);
			else 
				this._setToolbarButtonVisible(true, [FilesFoldersView.DOWNLOAD_BUTTON]);
			if (isLocked && lockedBy.itemId !== util.getLoggedInContributor().itemId) {
				this._setLockedByOtherWarning(versionableDTO, lockedBy);
			}
		} else if (this.versionableDTO.versionable['com.ibm.team.repository.typeName'] === "com.ibm.team.filesystem.SymbolicLink") {
			hvParams.label= versionableDTO.versionable.name;
			coiParams.iconSrc= util.SYMLINK;
			if (fromStream) 
				this._setToolbarButtonVisible(true, [FilesFoldersView.LOCK_BUTTON, FilesFoldersView.UNLOCK_BUTTON, FilesFoldersView.DELETE_BUTTON]);
			if (isLocked && lockedBy.itemId !== util.getLoggedInContributor().itemId) {
				this._setLockedByOtherWarning(versionableDTO, lockedBy);
			}
		}
		this.headerView= new HeaderView(hvParams);
		this.header1stRow.appendChild(this.headerView.domNode);
	},

	_setLockedByOtherWarning: function(versionableDTO, lockedBy) {
		this.validationMessageIcon.src= String(dojo.moduleUrl(FilesFoldersView.BUTTON_CONTEXT, FilesFoldersView.WARNING_IMAGE));
		if (lockedBy.emailAddress !== undefined) {
			this.validationMessage.innerHTML= this.messages.FilesFoldersView_FileLocked_Warning_NoName;
			var userLink= window.document.createElement("a");
			dojo.addClass(userLink, "validationMessageWarningLink");
			userLink.href= "mailto:" + lockedBy.emailAddress + "?subject=" + dojo.string.substitute(this.messages.FilesFoldersView_FileLocked_Warning_MailSubject, [versionableDTO.component.name]);
			userLink.appendChild(window.document.createTextNode(lockedBy.name));
			if (lockedBy.name !== undefined && lockedBy.userId !== undefined) 
				userLink.title= dojo.string.substitute(this.messages.FilesFoldersView_FileLocked_Warning_Tooltip, [lockedBy.name, lockedBy.userId]);
			this.validationMessage.appendChild(userLink);
		} else {
			this.validationMessage.appendChild(window.document.createTextNode(dojo.string.substitute(this.messages.FilesFoldersView_FileLocked_Warning, [lockedBy.name])));
		}
		dojo.removeClass(this.validationMessageSpan, "validationMessageEmpty");
		dojo.addClass(this.validationMessageSpan, "validationMessageWarning");
	},

	/**
	 * Toogle the visibility of toolbar buttons.
	 * 
	 * @param {Object} visible
	 * @param {Object} buttonNames. If null this param will update all buttons
	 *        in the toolbar.
	 */
	_setToolbarButtonVisible: function(visible, buttonNames) {
		if (buttonNames != null) {
			for (var i= 0; i < buttonNames.length; i++){
				if (visible) {
					this._toolbar.showItem(this._toolbarButtons[buttonNames[i]]);
				} else {
					this._toolbar.hideItem(this._toolbarButtons[buttonNames[i]]);
				}
			}
		} else {
			var $subject= jdojo.getValues(this._toolbarButtons);
			var $length= $subject.length;
			for (var $count= 0; $count < $length; $count++){
				var button= $subject[$count];
				if (visible) {
					this._toolbar.showItem(button);
				} else {
					this._toolbar.hideItem(button);
				}
			}
		}
	},

	_setTabs: function(versionableDTO, contentArgs) {
		dojo.empty(this._tabLinkContainer);
		dojo.empty(this._currentTabContainer);
		this._createTabPart(FilesFoldersView.TAB_NAME_OVERVIEW, this.messages.FilesFoldersView_DefaultTabTitleOverview);
		this._createTabPart(FilesFoldersView.TAB_NAME_HISTORY, this.messages.FilesFoldersView_TabTitleHistory);
		var tabLinks= this._tabLinkContainer.getElementsByTagName("a");
		for (var index= 0; index < tabLinks.length; index++){
			var link= tabLinks.item(index);
			var args= {};
			args.contextItemType= util.getVersionableDTOContextItemType(versionableDTO);
			args.contextItemId= util.getVersionableDTOContextItemId(versionableDTO);
			args.componentItemId= versionableDTO.component.itemId;
			args.path= versionableDTO.path;
			args.itemId= versionableDTO.versionable.itemId;
			args.itemType= versionableDTO.versionable['com.ibm.team.repository.typeName'];
			args.n= contentArgs.n;
			args.first= contentArgs.first;
			args.last= contentArgs.last;
			var tabName= link["__jazzTabName"];
			if (tabName !== FilesFoldersView.TAB_NAME_OVERVIEW) {
				args.tab= tabName;
			}
			link.href= util.getBrowseElementURI(args);
		}
	},

	/**
	 * Create a subtab for the files folders view.
	 * 
	 * @param {String} logicalName this name to identify the editor part via
	 *        this._tabViewParts and also the name to specify which widget to
	 *        show in the viewWorkItem URL.
	 * @param {String} tabLinkLabel the label of the hyperlink that allows users
	 *        to view the particular tab.
	 */
	_createTabPart: function(logicalName, tabLinkLabel) {
		for (var i= 0; i < this._tabLinkContainer.childNodes.length; i++){
			var childNode= this._tabLinkContainer.childNodes.item(i);
			if (childNode !== undefined && childNode["__jazzTabName"] === logicalName) {
				return childNode;
			}
		}
		var link= window.document.createElement("a");
		dojo.addClass(link, "tab");
		link.href= "#";
		link["__jazzTabName"]= logicalName;
		link.title= tabLinkLabel;
		link.setAttribute("role", "tab");
		var innerWrapper= window.document.createElement("div");
		innerWrapper.className= "innerWrapper";
		var topWrapper= window.document.createElement("div");
		topWrapper.className= "topWrapper";
		var topBorderDiv= window.document.createElement("div");
		topBorderDiv.className= "topBorder";
		topWrapper.appendChild(topBorderDiv);
		var cornerDiv= window.document.createElement("div");
		cornerDiv.className= "corners";
		topWrapper.appendChild(cornerDiv);
		link.appendChild(topWrapper);
		var titleDiv= window.document.createElement("div");
		titleDiv.className= "title";
		titleDiv.innerHTML= tabLinkLabel;
		innerWrapper.appendChild(titleDiv);
		link.appendChild(innerWrapper);
		this._tabLinkContainer.appendChild(link);
		return link;
	},

	/**
	 * Displays the tab specified by <code>tabName</code>.
	 * 
	 * @param {String} tabName the logical name of the tab to display.
	 */
	showTab: function(tabName, versionableDTO, args) {
		tabName= tabName.toLowerCase();
		var tabViewPart= this._tabViewParts[tabName];
		if (tabViewPart !== undefined && tabViewPart["showWidget"] !== undefined) {
			tabViewPart["showWidget"].call(tabViewPart, versionableDTO, args);
		} else {
			if (tabName === FilesFoldersView.TAB_NAME_OVERVIEW) {
				var contentWidget= this._getOverviewWidget();
				var params= {};
				params.isComponent= args.isComponent;
				contentWidget.showWidget(versionableDTO, params);
				this._tabViewParts[FilesFoldersView.TAB_NAME_OVERVIEW]= contentWidget;
			} else if (tabName === FilesFoldersView.TAB_NAME_HISTORY) {
				var contentWidget= this._getHistoryView();
				var params= {};
				params.first= args.first;
				params.isComponent= args.isComponent;
				params.last= args.last;
				params.n= args.n;
				contentWidget.showWidget(versionableDTO, params);
				this._tabViewParts[FilesFoldersView.TAB_NAME_HISTORY]= contentWidget;
			}
		}
		if (this._currentTabContainer.firstChild !== undefined && this._currentTabContainer.firstChild != null) {
			this._currentTabContainer.replaceChild(this.domNode, this._currentTabContainer.firstChild);
		} else {
			this._currentTabContainer.appendChild(this._tabViewParts[tabName].domNode);
		}
		var links= this._tabLinkContainer.childNodes;
		for (var i= 0; i < links.length; i++){
			var link= links.item(i);
			if (link["__jazzTabName"] === tabName) 
				dojo.addClass(link, "Selected");
			else {
				dojo.removeClass(link, "Selected");
			}
		}
		this._currentTab= tabName;
	},

	_getOverviewWidget: function() {
		if (this._overviewWidget == null) {
			var params= {};
			params.controller= this.pageController;
			params.pageStatusDiv= this._pageStatus;
			this._overviewWidget= new com.ibm.team.scm.web.ui.internal.view.browse.FileFolderContentView(params);
		}
		return this._overviewWidget;
	},

	_getHistoryView: function() {
		if (this._historyView == null) {
			var params= {};
			params.controller= this.pageController;
			this._historyView= new com.ibm.team.scm.web.ui.internal.view.browse.HistoryView(params);
		}
		return this._historyView;
	},

	_handleUploadBrowserClick: function() {
		this.pageController.clearStatusMessage();
		if (this.editBrowser.hasChildNodes()) 
			return ;
		var params= {};
		params.mode= "SINGLE_FILE_UPLOAD";
		params.versionableDTO= this.versionableDTO;
		params.pageController= this.pageController;
		params.onResourceEditorSaved= dojo.hitch(this, function(newPath) {
			this.reload(null);
		});
		var editor= new ResourceEditor(params);
		editor.domNode.className= "resource-editor";
		this.editBrowser.appendChild(editor.domNode);
		editor.startup();
	},

	_handleEditTextFileBrowserClick: function() {
		this.pageController.clearStatusMessage();
		if (this.editBrowser.hasChildNodes()) 
			return ;
		var params= {};
		params.mode= "SINGLE_FILE_UPLOAD";
		params.hint= "TEXT_EDIT";
		params.versionableDTO= this.versionableDTO;
		params.pageController= this.pageController;
		params.onResourceEditorSaved= dojo.hitch(this, function(newPath) {
			this.reload(null);
		});
		var editor= new ResourceEditor(params);
		editor.domNode.className= "resource-editor";
		this.editBrowser.appendChild(editor.domNode);
		editor.startup();
	},

	_handleRenameItemBrowserClick: function() {
		this.pageController.clearStatusMessage();
		if (this.editBrowser.hasChildNodes()) 
			return ;
		var params= {};
		params.mode= this._isFolder ? "SINGLE_FOLDER_RENAME" : "SINGLE_FILE_RENAME";
		params.versionableDTO= this.versionableDTO;
		params.pageController= this.pageController;
		params.onResourceEditorSaved= dojo.hitch(this, function(newPath) {
			this.reload(null);
		});
		var editor= new ResourceEditor(params);
		editor.domNode.className= "resource-editor";
		this.editBrowser.appendChild(editor.domNode);
		editor.startup();
	},

	_handleFileAddBrowserClick: function() {
		this.pageController.clearStatusMessage();
		if (this.editBrowser.hasChildNodes()) 
			return ;
		var params= {};
		params.mode= "SINGLE_FILE_ADD";
		params.versionableDTO= this.versionableDTO;
		params.pageController= this.pageController;
		params.onResourceEditorSaved= dojo.hitch(this, function(newPath) {
			this.reload(null);
		});
		var editor= new ResourceEditor(params);
		editor.domNode.className= "resource-editor";
		this.editBrowser.appendChild(editor.domNode);
		editor.startup();
	},

	_handleNewTextFileBrowserClick: function() {
		this.pageController.clearStatusMessage();
		if (this.editBrowser.hasChildNodes()) 
			return ;
		var params= {};
		params.mode= "SINGLE_FILE_ADD";
		params.hint= "TEXT_EDIT";
		params.versionableDTO= this.versionableDTO;
		params.pageController= this.pageController;
		params.onResourceEditorSaved= dojo.hitch(this, function(newPath) {
			this.refreshTabs();
		});
		var editor= new ResourceEditor(params);
		editor.domNode.className= "resource-editor";
		this.editBrowser.appendChild(editor.domNode);
		editor.startup();
	},

	_handleFileDeleteBrowserClick: function() {
		this.pageController.clearStatusMessage();
		if (this.editBrowser.hasChildNodes()) 
			return ;
		var params= {};
		params.mode= this._isFolder ? "SINGLE_FOLDER_DELETE" : "SINGLE_FILE_DELETE";
		params.versionableDTO= this.versionableDTO;
		params.pageController= this.pageController;
		params.onResourceEditorSaved= dojo.hitch(this, function(newPath) {
			this.reload(this.versionableDTO.versionable.parentId);
		});
		var editor= new ResourceEditor(params);
		editor.domNode.className= "resource-editor";
		this.editBrowser.appendChild(editor.domNode);
		editor.startup();
	},

	_handleFolderAddBrowserClick: function() {
		this.pageController.clearStatusMessage();
		if (this.editBrowser.hasChildNodes()) 
			return ;
		var params= {};
		params.mode= "SINGLE_FOLDER_ADD";
		params.versionableDTO= this.versionableDTO;
		params.pageController= this.pageController;
		params.onResourceEditorSaved= dojo.hitch(this, function(newPath) {
			this.refreshTabs();
		});
		var editor= new ResourceEditor(params);
		editor.domNode.className= "resource-editor";
		this.editBrowser.appendChild(editor.domNode);
		editor.startup();
	},

	_handleFolderDeleteBrowserClick: function() {
		if (this.editBrowser.hasChildNodes()) 
			return ;
		var params= {};
		params.mode= "SINGLE_FOLDER_DELETE";
		params.versionableDTO= this.versionableDTO;
		params.pageController= this.pageController;
		params.onResourceEditorSaved= dojo.hitch(this, function(newPath) {
			this.reload(this.versionableDTO.versionable.parentId);
		});
		var editor= new ResourceEditor(params);
		editor.domNode.className= "resource-editor";
		this.editBrowser.appendChild(editor.domNode);
		editor.startup();
	},

	_handleFileLockClick: function() {
		this.pageController.clearStatusMessage();
		var params= {};
		params.versionableDTO= this.versionableDTO;
		params.toLock= true;
		return this.pageController.updateLock(this, params);
	},

	_handleFileUnlockClick: function() {
		this.pageController.clearStatusMessage();
		var params= {};
		params.versionableDTO= this.versionableDTO;
		params.toLock= false;
		return this.pageController.updateLock(this, params);
	},

	_handleLockAndDownloadClick: function() {
		this.pageController.clearStatusMessage();
		this._handleFileLockClick().addCallback(dojo.hitch(this, function(object) {
			var args= {};
			args.contextItemType= util.getVersionableDTOContextItemType(this.versionableDTO);
			args.contextItemId= util.getVersionableDTOContextItemId(this.versionableDTO);
			args.componentItemId= this.versionableDTO.component.itemId;
			args.fileName= this.versionableDTO.versionable.name;
			args.fileItemId= this.versionableDTO.versionable.itemId;
			args.fileStateId= null;
			args.iframe= true;
			var href= util.getFileDownloadURI(args);
			var sendParams= {};
			sendParams.url= href;
			sendParams.timeout= 2000;
			sendParams.handle= dojo.hitch(this, function(response, ioArgs) {
				if (response != null) {
					var resp= String(response);
					var index= resp.indexOf(util.DOWNLOAD_CONTENT_DELETED_ERROR_PREFIX);
					if (index === 0) {
						var status= resp.substring(util.DOWNLOAD_CONTENT_DELETED_ERROR_PREFIX.length);
						status= dojo.string.substitute(this.messages.FileFolderContentView_contentNotDownloadable, [this.versionableDTO.versionable.name, status]);
						this.pageController.displayPageStatusMessage(status, 'INFO', null);
					}
				}
			});
			dojo.io.iframe.send(sendParams);
			return true;
		}));
	},

	_updateFileLockIconStatus: function(args) {
		var versionable= args.versionableDTO.versionable;
		if (versionable.itemId !== this.versionableDTO.versionable.itemId) 
			return ;
		var coiParams= {};
		coiParams.fileName= versionable.name;
		if (this.contentArgs.isComponent) {
			coiParams.iconSrc= util.COMPONENT;
		} else if (versionable['com.ibm.team.repository.typeName'] === "com.ibm.team.scm.Folder") {
			coiParams.iconSrc= util.FOLDER;
		} else if (versionable['com.ibm.team.repository.typeName'] === "com.ibm.team.filesystem.FileItem") {
			coiParams.iconSrc= util.FILE;
			coiParams.fileName= this.versionableDTO.versionable.name;
		} else if (versionable['com.ibm.team.repository.typeName'] === "com.ibm.team.filesystem.SymbolicLink") {
			coiParams.iconSrc= util.SYMLINK;
		}
		coiParams.isLockedByMe= args.toLock;
		this.headerView.updateOverlay(coiParams);
	},

	refreshTabs: function() {
		this._getOverviewWidget().reload();
		this._getHistoryView().refresh();
	},

	reload: function(parentId) {
		if (this.versionableDTO == null) 
			return ;
		var params= {};
		params.contextItemType= util.getVersionableDTOContextItemType(this.versionableDTO);
		params.contextItemId= util.getVersionableDTOContextItemId(this.versionableDTO);
		params.componentItemId= this.versionableDTO.component.itemId;
		if (parentId != null) {
			params.itemType= "com.ibm.team.scm.Folder";
			params.itemId= parentId;
		} else {
			params.path= this.versionableDTO.path;
			params.itemType= this.versionableDTO.versionable['com.ibm.team.repository.typeName'];
			params.itemId= this.versionableDTO.versionable.itemId;
		}
		var href= util.getBrowseElementURI(params);
		if (this._stringEndsWith(window.location.href, href)) {
			PlatformUI.getWorkbench()._processUri(href.substring(1));
		} else {
			window.location.href= href;
		}
	},

	/**
	 * Returns true if string1 ends with string2
	 */
	_stringEndsWith: function(string1, string2) {
		var index= string1.indexOf(string2);
		return index >= 0 && string2.length === string1.length - index;
	},

	removeValidationMessage: function() {
		dojo.empty(this.validationMessage);
		dojo.removeClass(this.validationMessageSpan, "validationMessageWarning");
		dojo.addClass(this.validationMessageSpan, "validationMessageEmpty");
	}
});

FilesFoldersView.CSH_PAGE_STREAM_COMPONENT= "com.ibm.team.scm.web.page_stream_component";
FilesFoldersView.CSH_PAGE_WORKSPACE_COMPONENT= "com.ibm.team.scm.web.page_workspace_component";
FilesFoldersView.BUTTON_CONTEXT= "com.ibm.team.scm.web";
FilesFoldersView.ADD_FILE_IMAGE= "graphics/icons/addfile_co.gif";
FilesFoldersView.NEW_TEXT_FILE_IMAGE= "graphics/icons/createfile_co.gif";
FilesFoldersView.EDIT_TEXT_FILE_IMAGE= "graphics/icons/edit_co.gif";
FilesFoldersView.RENAME_ITEM_IMAGE= "graphics/icons/wi_preview.gif";
FilesFoldersView.ADD_FOLDER_IMAGE= "graphics/icons/createfolder_co.gif";
FilesFoldersView.DOWNLOAD_IMAGE= "graphics/icons/download_co.gif";
FilesFoldersView.UPLOAD_IMAGE= "graphics/icons/upload_co.gif";
FilesFoldersView.LOCK_IMAGE= "graphics/icons/locks.gif";
FilesFoldersView.UNLOCK_IMAGE= "graphics/icons/unlock.gif";
FilesFoldersView.DELETE_IMAGE= "graphics/icons/delete_edit.gif";
FilesFoldersView.LOCK_DOWNLOAD_IMAGE= "graphics/icons/lockdownload_co.gif";
FilesFoldersView.WARNING_IMAGE= "graphics/icons/warning_obj.gif";
FilesFoldersView.TAB_NAME_OVERVIEW= "overview";
FilesFoldersView.TAB_NAME_HISTORY= "history";
FilesFoldersView.TAB_NAME_PROPERTIES= "properties";
FilesFoldersView.PAGE_SIZE= 25;
FilesFoldersView.ADD_FILE_BUTTON= "addFileButton";
FilesFoldersView.NEW_TEXT_FILE_BUTTON= "newTextFileButton";
FilesFoldersView.ADD_FOLDER_BUTTON= "addFolderButton";
FilesFoldersView.LOCK_AND_DOWNLOAD_BUTTON= "lockAndDownloadButton";
FilesFoldersView.DOWNLOAD_BUTTON= "downloadButton";
FilesFoldersView.UPLOAD_BUTTON= "uploadButton";
FilesFoldersView.EDIT_TEXT_FILE_BUTTON= "editTextFileButton";
FilesFoldersView.RENAME_ITEM_BUTTON= "renameItemButton";
FilesFoldersView.LOCK_BUTTON= "lockButton";
FilesFoldersView.UNLOCK_BUTTON= "unlockButton";
FilesFoldersView.DELETE_BUTTON= "deleteButton";

})();
