/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.SecurityContextSelectionDialog"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.ExceptionHelper"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.widget.FilteredListBox"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "SecurityContextSelectionMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var SecurityContextSelectionMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "SecurityContextSelectionMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var team= com.ibm.team;
var ServiceResponseHandler= team.repository.web.transport.ServiceResponseHandler;
var web= team.workitem.web;
var internal= web.client.internal;
var ExceptionHelper= internal.ExceptionHelper;
var WorkItemClient= internal.WorkItemClient;
var FilteredListBox= web.ui2.internal.widget.FilteredListBox;
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;
var Dialog= jazz.ui.Dialog;

dojo.declare("com.ibm.team.workitem.web.ui.internal.view.editor.SecurityContextSelectionDialog", [ _Widget, _Templated], { //$NON-NLS-1$

	templatePath: dojo.moduleUrl("com.ibm.team.workitem.web", "ui/internal/view/editor/templates/SecurityContextSelectionDialog.html"), //$NON-NLS-1$ //$NON-NLS-2$

	//_messages: null,

	//_dialog: null,

	//_okButton: null,

	//_defaultRadioControl: null,

	//_customRadioControl: null,

	//_filterProjectsCheckbox: null,

	//_filterAccessGroupsCheckbox: null,

	//_customContainerContainer: null,

	//_defaultDescriptionLabelControl: null,

	//_customList: null,

	//_projectAreaItemId: null,

	//_workItemItemId: null,

	//_currentAccessContext: null,

	//_onCloseCallback: null,

	//_destroyed: null,

	//_selectedElement: null,

	//_defaultElement: null,

	//_lastCustomSelection: null,

	//_isFirst: null,

	//_isOkPressed: null,

	constructor: function(params) {
		this._messages= SecurityContextSelectionMessages;
		this._projectAreaItemId= params.projectAreaItemId;
		this._workItemItemId= params.workItemItemId;
		this._currentAccessContext= params.currentAccessContext;
		this._onCloseCallback= params.onCloseCallback;
		this._lastCustomSelection= null;
		this._isFirst= true;
		this._isOkPressed= false;
	},

	_isDestroyed: function() {
		return this._destroyed;
	},

	postCreate: function() {
		this._filterAccessGroupsCheckbox.checked= true;
		this._filterProjectsCheckbox.checked= true;
		this._defaultRadioControl.checked= true;
		this._customRadioControl.checked= false;
		var params= {};
		params.filterLabel= SecurityContextSelectionMessages.labelFilterField;
		params.listLabel= SecurityContextSelectionMessages.labelAccessContextList;
		params.doubleclickCallback= dojo.hitch(this, "_onElementChosen"); //$NON-NLS-1$
		params.selectionChangedCallback= dojo.hitch(this, "_onElementSelected"); //$NON-NLS-1$
		params.searchResultProvider= dojo.hitch(this, "_performSearch"); //$NON-NLS-1$
		params.allowMultipleSelection= false;
		params.listFilter= dojo.hitch(this, "_checkFilters"); //$NON-NLS-1$
		this._customList= new FilteredListBox(params);
		this._customContainerContainer.appendChild(this._customList.domNode);
		this._openDialog();
	},

	_onElementChosen: function(entry) {
		this._updateSelection(entry.value);
		this._onOkClicked(null);
	},

	_onElementSelected: function(selection) {
		if (selection.length > 0 && !this._customRadioControl.checked) {
			this._lastCustomSelection= null;
			this._setRadio(false);
		}
		if (this._customRadioControl.checked) {
			if (selection.length === 1) {
				this._updateSelection(selection[0].value);
			} else {
				this._updateSelection(null);
			}
		}
	},

	_updateSelection: function(context) {
		this._selectedElement= context;
		this._okButton.disabled= context != null ? "" : "disabled"; //$NON-NLS-1$ //$NON-NLS-2$
	},

	_onOkClicked: function(e) {
		this._isOkPressed= true;
		this._dialog.close(null);
	},

	_onCancelClicked: function(e) {
		this._isOkPressed= false;
		this._dialog.close(null);
	},

	_onProjectFilterClicked: function(e) {
		this._customList.refresh(false);
		e.stopPropagation();
	},

	_onAccessGroupsFilterClicked: function(e) {
		this._customList.refresh(false);
		e.stopPropagation();
	},

	_onDefaultRadioClicked: function(e) {
		this._setRadio(true);
		e.stopPropagation();
	},

	_onCustomRadioClicked: function(e) {
		this._setRadio(false);
		e.stopPropagation();
	},

	_setRadio: function(toDefault) {
		this._defaultRadioControl.checked= toDefault;
		this._customRadioControl.checked= !toDefault;
		if (toDefault) {
			this._lastCustomSelection= this._customList.getSelection();
			this._customList.getListBox().removeAllSelections();
			this._updateSelection(this._defaultElement);
		} else {
			if (this._lastCustomSelection != null) {
				this._customList.getListBox().removeAllSelections();
				this._customList.getListBox().setSelection(this._lastCustomSelection, true);
				if (this._lastCustomSelection.length === 1) {
					this._updateSelection(this._lastCustomSelection[0].value);
				} else {
					this._updateSelection(null);
				}
				this._lastCustomSelection= null;
			}
		}
	},

	_setFocus: function() {
		this._customList.setFocus();
	},

	/**
	 * Call the Search method and add the Message
	 */
	_performSearch: function(queryString, searchResultCallback) {
		var onSuccess= dojo.hitch(this, "_onAccessContextsFetched" , searchResultCallback); //$NON-NLS-1$
		var onFailure= function(data) {
			ExceptionHelper.logTRException(SecurityContextSelectionMessages.errorFetchingContexts, data);
			searchResultCallback(null, null, data.message);
		};
		var handler= new ServiceResponseHandler({'onSuccess': onSuccess, 'onFailure': onFailure}, 'onSuccess', 'onFailure'); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		var params= {};
		params.projectAreaItemId= this._projectAreaItemId;
		if (this._workItemItemId != null) {
			params.workItemItemId= this._workItemItemId;
		}
		params.nameFilter= queryString;
		params.maxResults= 100;
		WorkItemClient.getAccessContexts(handler, params);
	},

	_onAccessContextsFetched: function(searchResultCallback, result) {
		var newSelection= null;
		if (this._isFirst && result != null) {
			var customSelected= null;
			var $subject= result;
			var $length= $subject.length;
			for (var $count= 0; $count < $length; $count++){
				var accessContextDTO= $subject[$count];
				if (accessContextDTO.isDefault) 
					this._defaultElement= accessContextDTO;
				else if (accessContextDTO.contextId === this._currentAccessContext) {
					newSelection= accessContextDTO;
					customSelected= accessContextDTO;
				}
			}
			this._setRadio(customSelected == null);
			this._isFirst= false;
			if (this._projectAreaItemId != null && this._defaultElement != null && this._defaultElement.contextId !== this._projectAreaItemId) {
				this._defaultDescriptionLabelControl.innerHTML= SecurityContextSelectionMessages.descriptionDefaultIsCategory;
			}
		}
		var selectedEntry= null;
		var entries= [];
		if (result != null) {
			var $subject2= result;
			var $length2= $subject2.length;
			for (var $count2= 0; $count2 < $length2; $count2++){
				var accessContextDTO= $subject2[$count2];
				if (!accessContextDTO.isDefault && !accessContextDTO.isArchived) {
					var entry= {};
					entry.id= accessContextDTO.contextId;
					entry.label= accessContextDTO.name;
					entry.value= accessContextDTO;
					entries.push(entry);
					if (accessContextDTO === newSelection) 
						selectedEntry= entry;
				}
			}
		}
		searchResultCallback(entries, selectedEntry, null);
	},

	_checkFilters: function(entry) {
		var type= entry.value.type;
		if (type === "processarea")  //$NON-NLS-1$
			return this._filterProjectsCheckbox.checked;
		if (type === "accessgroup")  //$NON-NLS-1$
			return this._filterAccessGroupsCheckbox.checked;
		return true;
	},

	destroy: function(preserveDom) {
		this.inherited("destroy", arguments, [preserveDom]); //$NON-NLS-1$
		this._destroyed= true;
		if (this._customList != null) {
			this._customList.destroy(preserveDom);
			this._customList= null;
		}
	},

	_openDialog: function() {
		var dialogParams= {};
		dialogParams.primaryTitle= SecurityContextSelectionMessages.titleAccessContextSelectionDialog;
		dialogParams.contentNode= this.domNode;
		dialogParams.width= "32em"; //$NON-NLS-1$
		dialogParams.onClose= dojo.hitch(this, function() {
			this._handleEventDialogClosed();
			return true;
		});
		this._dialog= new Dialog(dialogParams);
	},

	_handleEventDialogClosed: function() {
		if (this._onCloseCallback != null && this._isOkPressed) {
			this._onCloseCallback(this._selectedElement);
		} else {
			this._onCloseCallback(null);
		}
		this._dialog= null;
		this.destroy(false);
	}
});

})();
