/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010, 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.itempicker.ContributorItemPicker"); //$NON-NLS-1$

dojo.require("com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$

(function() {
var TeamContributorSelectionDialog= com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog;
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;

dojo.declare("com.ibm.team.workitem.web.ui.internal.view.editor.itempicker.ContributorItemPicker", [ _Widget, _Templated], { //$NON-NLS-1$

	templatePath: dojo.moduleUrl("com.ibm.team.workitem.web", "ui/internal/view/layout/templates/TextWidget.html"), //$NON-NLS-1$ //$NON-NLS-2$

	//fAllowMultiple: null,

	//fHandlers: null,

	//fOnOkCallback: null,

	//fOnCancelCallback: null,

	constructor: function(params) {
		this.fAllowMultiple= params.allowsMultiple;
		this.fOnOkCallback= params.onOkCallback;
		this.fOnCancelCallback= params.onCancelCallback;
	},

	postCreate: function() {
		this.fHandlers= [];
		this.openUserDialog();
	},

	openUserDialog: function() {
		var params= {};
		params.allowMultiple= this.fAllowMultiple;
		params.hideAdminGuest= true;
		params.useOkCancel= true;
		var fUserDialog= new TeamContributorSelectionDialog(params);
		this.fHandlers.push(dojo.connect(fUserDialog, "onOK", this, "onOK")); //$NON-NLS-1$ //$NON-NLS-2$
		this.fHandlers.push(dojo.connect(fUserDialog, "onClose", this, "onCancel")); //$NON-NLS-1$ //$NON-NLS-2$
		fUserDialog.searchText.focus();
	},

	onOK: function(users) {
		this.disconnectHandlers();
		var userArr= [];
		var $subject= users;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var user= $subject[$count];
			var item= {};
			item.itemId= user.itemId;
			item.name= user.name;
			userArr.push(item);
		}
		if (this.fOnOkCallback != null) {
			this.fOnOkCallback(userArr);
		}
	},

	onCancel: function() {
		if (this.fOnCancelCallback != null) {
			this.fOnCancelCallback(null);
		}
		this.disconnectHandlers();
	},

	disconnectHandlers: function() {
		if (this.fHandlers != null) {
			for (var i= 0; i < this.fHandlers.length; i++){
				var handler= this.fHandlers[i];
				if (handler != null) {
					this.disconnect(handler);
					handler= null;
				}
			}
		}
	}
});

})();
